/* serializer.c generated by valac 0.40.19, the Vala compiler
 * generated from serializer.vala, do not modify */

/*
 * Copyright (C) 2010 Robin Sonefors
 * Copyright (C) 2008-2012 Robert Ancell.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <langinfo.h>
#include <glib/gi18n-lib.h>

typedef enum  {
	DISPLAY_FORMAT_AUTOMATIC,
	DISPLAY_FORMAT_FIXED,
	DISPLAY_FORMAT_SCIENTIFIC,
	DISPLAY_FORMAT_ENGINEERING
} DisplayFormat;


#define TYPE_DISPLAY_FORMAT (display_format_get_type ())

#define TYPE_SERIALIZER (serializer_get_type ())
#define SERIALIZER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SERIALIZER, Serializer))
#define SERIALIZER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SERIALIZER, SerializerClass))
#define IS_SERIALIZER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SERIALIZER))
#define IS_SERIALIZER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SERIALIZER))
#define SERIALIZER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SERIALIZER, SerializerClass))

typedef struct _Serializer Serializer;
typedef struct _SerializerClass SerializerClass;
typedef struct _SerializerPrivate SerializerPrivate;
enum  {
	SERIALIZER_0_PROPERTY,
	SERIALIZER_ERROR_PROPERTY,
	SERIALIZER_NUM_PROPERTIES
};
static GParamSpec* serializer_properties[SERIALIZER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_NUMBER (number_get_type ())
#define NUMBER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NUMBER, Number))
#define NUMBER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NUMBER, NumberClass))
#define IS_NUMBER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NUMBER))
#define IS_NUMBER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NUMBER))
#define NUMBER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NUMBER, NumberClass))

typedef struct _Number Number;
typedef struct _NumberClass NumberClass;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _Serializer {
	GObject parent_instance;
	SerializerPrivate * priv;
};

struct _SerializerClass {
	GObjectClass parent_class;
};

struct _SerializerPrivate {
	gint leading_digits;
	gint trailing_digits;
	DisplayFormat format;
	gboolean show_tsep;
	gboolean show_zeroes;
	gint number_base;
	guint representation_base;
	gunichar radix;
	gunichar tsep;
	gint tsep_count;
	gchar* _error;
};


static gpointer serializer_parent_class = NULL;

GType display_format_get_type (void) G_GNUC_CONST;
GType serializer_get_type (void) G_GNUC_CONST;
#define SERIALIZER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SERIALIZER, SerializerPrivate))
Serializer* serializer_new (DisplayFormat format,
                            gint number_base,
                            gint trailing_digits);
Serializer* serializer_construct (GType object_type,
                                  DisplayFormat format,
                                  gint number_base,
                                  gint trailing_digits);
GType number_get_type (void) G_GNUC_CONST;
gchar* serializer_to_string (Serializer* self,
                             Number* x);
static gchar* serializer_cast_to_string (Serializer* self,
                                  Number* x,
                                  gint* n_digits);
gint serializer_get_base (Serializer* self);
static gchar* serializer_cast_to_exponential_string (Serializer* self,
                                              Number* x,
                                              gboolean eng_format,
                                              gint* n_digits);
Number* serializer_from_string (Serializer* self,
                                const gchar* str);
Number* mp_set_from_string (const gchar* str,
                            gint default_base);
void serializer_set_base (Serializer* self,
                          gint number_base);
void serializer_set_representation_base (Serializer* self,
                                         guint representation_base);
guint serializer_get_representation_base (Serializer* self);
void serializer_set_radix (Serializer* self,
                           gunichar radix);
gunichar serializer_get_radix (Serializer* self);
void serializer_set_thousands_separator (Serializer* self,
                                         gunichar separator);
gunichar serializer_get_thousands_separator (Serializer* self);
gint serializer_get_thousands_separator_count (Serializer* self);
void serializer_set_thousands_separator_count (Serializer* self,
                                               gint count);
void serializer_set_show_thousands_separators (Serializer* self,
                                               gboolean visible);
gboolean serializer_get_show_thousands_separators (Serializer* self);
void serializer_set_show_trailing_zeroes (Serializer* self,
                                          gboolean visible);
gboolean serializer_get_show_trailing_zeroes (Serializer* self);
gint serializer_get_leading_digits (Serializer* self);
void serializer_set_leading_digits (Serializer* self,
                                    gint leading_digits);
gint serializer_get_trailing_digits (Serializer* self);
void serializer_set_trailing_digits (Serializer* self,
                                     gint trailing_digits);
DisplayFormat serializer_get_number_format (Serializer* self);
void serializer_set_number_format (Serializer* self,
                                   DisplayFormat format);
Number* number_real_component (Number* self);
static void serializer_cast_to_string_real (Serializer* self,
                                     Number* x,
                                     gint number_base,
                                     gboolean force_sign,
                                     gint* n_digits,
                                     GString* string);
gboolean number_is_complex (Number* self);
Number* number_imaginary_component (Number* self);
gboolean number_is_negative (Number* self);
Number* number_abs (Number* self);
Number* number_new_integer (gint64 real,
                            gint64 imag);
Number* number_construct_integer (GType object_type,
                                  gint64 real,
                                  gint64 imag);
Number* number_xpowy_integer (Number* self,
                              gint64 n);
Number* number_multiply_integer (Number* self,
                                 gint64 y);
Number* number_divide_integer (Number* self,
                               gint64 y);
Number* number_add (Number* self,
                    Number* y);
Number* number_floor (Number* self);
gboolean number_is_zero (Number* self);
Number* number_subtract (Number* self,
                         Number* y);
gint64 number_to_integer (Number* self);
void serializer_set_error (Serializer* self,
                           const gchar* value);
Number* number_fractional_component (Number* self);
static gint serializer_cast_to_exponential_string_real (Serializer* self,
                                                 Number* x,
                                                 GString* string,
                                                 gboolean eng_format,
                                                 gint* n_digits);
Number* number_divide (Number* self,
                       Number* y);
gint number_compare (Number* self,
                     Number* y);
Number* number_multiply (Number* self,
                         Number* y);
static void serializer_append_exponent (Serializer* self,
                                 GString* string,
                                 gint exponent);
const gchar* serializer_get_error (Serializer* self);
static void serializer_finalize (GObject * obj);
static void _vala_serializer_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_serializer_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);


GType
display_format_get_type (void)
{
	static volatile gsize display_format_type_id__volatile = 0;
	if (g_once_init_enter (&display_format_type_id__volatile)) {
		static const GEnumValue values[] = {{DISPLAY_FORMAT_AUTOMATIC, "DISPLAY_FORMAT_AUTOMATIC", "automatic"}, {DISPLAY_FORMAT_FIXED, "DISPLAY_FORMAT_FIXED", "fixed"}, {DISPLAY_FORMAT_SCIENTIFIC, "DISPLAY_FORMAT_SCIENTIFIC", "scientific"}, {DISPLAY_FORMAT_ENGINEERING, "DISPLAY_FORMAT_ENGINEERING", "engineering"}, {0, NULL, NULL}};
		GType display_format_type_id;
		display_format_type_id = g_enum_register_static ("DisplayFormat", values);
		g_once_init_leave (&display_format_type_id__volatile, display_format_type_id);
	}
	return display_format_type_id__volatile;
}


static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result = 0U;
#line 1210 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1211 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = g_utf8_get_char (((gchar*) self) + index);
#line 1211 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 227 "serializer.c"
}


Serializer*
serializer_construct (GType object_type,
                      DisplayFormat format,
                      gint number_base,
                      gint trailing_digits)
{
	Serializer * self = NULL;
	gchar* radix_string = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	gchar* tsep_string = NULL;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gboolean _tmp11_ = FALSE;
	const gchar* _tmp12_;
#line 38 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	self = (Serializer*) g_object_new (object_type, NULL);
#line 40 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp0_ = nl_langinfo (RADIXCHAR);
#line 40 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 40 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	radix_string = _tmp1_;
#line 41 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp3_ = radix_string;
#line 41 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	if (_tmp3_ != NULL) {
#line 260 "serializer.c"
		const gchar* _tmp4_;
#line 41 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp4_ = radix_string;
#line 41 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "") != 0;
#line 266 "serializer.c"
	} else {
#line 41 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp2_ = FALSE;
#line 270 "serializer.c"
	}
#line 41 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	if (_tmp2_) {
#line 274 "serializer.c"
		gchar* radix_utf8 = NULL;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
#line 42 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp5_ = radix_string;
#line 42 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp6_ = g_locale_to_utf8 (_tmp5_, (gssize) -1, NULL, NULL, NULL);
#line 42 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		radix_utf8 = _tmp6_;
#line 43 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp7_ = radix_utf8;
#line 43 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		if (_tmp7_ != NULL) {
#line 289 "serializer.c"
			const gchar* _tmp8_;
#line 44 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp8_ = radix_utf8;
#line 44 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			self->priv->radix = string_get_char (_tmp8_, (glong) 0);
#line 295 "serializer.c"
		} else {
#line 46 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			self->priv->radix = (gunichar) '.';
#line 299 "serializer.c"
		}
#line 41 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_g_free0 (radix_utf8);
#line 303 "serializer.c"
	} else {
#line 49 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		self->priv->radix = (gunichar) '.';
#line 307 "serializer.c"
	}
#line 50 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp9_ = nl_langinfo (THOUSEP);
#line 50 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp10_ = g_strdup (_tmp9_);
#line 50 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	tsep_string = _tmp10_;
#line 51 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp12_ = tsep_string;
#line 51 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	if (_tmp12_ != NULL) {
#line 319 "serializer.c"
		const gchar* _tmp13_;
#line 51 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp13_ = tsep_string;
#line 51 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp11_ = g_strcmp0 (_tmp13_, "") != 0;
#line 325 "serializer.c"
	} else {
#line 51 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp11_ = FALSE;
#line 329 "serializer.c"
	}
#line 51 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	if (_tmp11_) {
#line 333 "serializer.c"
		gchar* tsep_utf8 = NULL;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		const gchar* _tmp16_;
#line 52 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp14_ = tsep_string;
#line 52 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp15_ = g_locale_to_utf8 (_tmp14_, (gssize) -1, NULL, NULL, NULL);
#line 52 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		tsep_utf8 = _tmp15_;
#line 53 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp16_ = tsep_utf8;
#line 53 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		if (_tmp16_ != NULL) {
#line 348 "serializer.c"
			const gchar* _tmp17_;
#line 54 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp17_ = tsep_utf8;
#line 54 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			self->priv->tsep = string_get_char (_tmp17_, (glong) 0);
#line 354 "serializer.c"
		} else {
#line 56 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			self->priv->tsep = (gunichar) ' ';
#line 358 "serializer.c"
		}
#line 51 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_g_free0 (tsep_utf8);
#line 362 "serializer.c"
	} else {
#line 59 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		self->priv->tsep = (gunichar) ' ';
#line 366 "serializer.c"
	}
#line 60 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	self->priv->tsep_count = 3;
#line 62 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	self->priv->number_base = number_base;
#line 63 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	self->priv->representation_base = (guint) number_base;
#line 64 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	self->priv->leading_digits = 12;
#line 65 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	self->priv->trailing_digits = trailing_digits;
#line 66 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	self->priv->show_zeroes = FALSE;
#line 67 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	self->priv->show_tsep = FALSE;
#line 68 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	self->priv->format = format;
#line 38 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_g_free0 (tsep_string);
#line 38 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_g_free0 (radix_string);
#line 38 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	return self;
#line 390 "serializer.c"
}


Serializer*
serializer_new (DisplayFormat format,
                gint number_base,
                gint trailing_digits)
{
#line 38 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	return serializer_construct (TYPE_SERIALIZER, format, number_base, trailing_digits);
#line 401 "serializer.c"
}


gchar*
serializer_to_string (Serializer* self,
                      Number* x)
{
	gchar* result = NULL;
	guint _tmp0_;
	gint _tmp1_;
	DisplayFormat _tmp3_;
#line 71 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 71 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_val_if_fail (x != NULL, NULL);
#line 74 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp0_ = self->priv->representation_base;
#line 74 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp1_ = self->priv->number_base;
#line 74 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	if (_tmp0_ != ((guint) _tmp1_)) {
#line 423 "serializer.c"
		gint n_digits = 0;
		gchar* _tmp2_;
#line 76 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		n_digits = 0;
#line 77 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp2_ = serializer_cast_to_string (self, x, &n_digits);
#line 77 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		result = _tmp2_;
#line 77 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		return result;
#line 434 "serializer.c"
	}
#line 79 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp3_ = self->priv->format;
#line 79 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	switch (_tmp3_) {
#line 440 "serializer.c"
		default:
#line 79 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		case DISPLAY_FORMAT_AUTOMATIC:
#line 444 "serializer.c"
		{
			gint n_digits = 0;
			gchar* s0 = NULL;
			gchar* _tmp4_;
#line 83 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			n_digits = 0;
#line 84 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp4_ = serializer_cast_to_string (self, x, &n_digits);
#line 84 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			s0 = _tmp4_;
#line 86 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			switch (serializer_get_base (self)) {
#line 86 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				case 2:
#line 459 "serializer.c"
				{
					gint _tmp5_;
#line 90 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
					_tmp5_ = n_digits;
#line 90 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
					if (_tmp5_ <= 64) {
#line 91 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						result = s0;
#line 91 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						return result;
#line 470 "serializer.c"
					} else {
						gchar* _tmp6_;
#line 93 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						_tmp6_ = serializer_cast_to_exponential_string (self, x, FALSE, &n_digits);
#line 93 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						result = _tmp6_;
#line 93 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						_g_free0 (s0);
#line 93 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						return result;
#line 481 "serializer.c"
					}
				}
#line 86 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				case 8:
#line 486 "serializer.c"
				{
					gint _tmp7_;
#line 96 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
					_tmp7_ = n_digits;
#line 96 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
					if (_tmp7_ <= 22) {
#line 97 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						result = s0;
#line 97 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						return result;
#line 497 "serializer.c"
					} else {
						gchar* _tmp8_;
#line 99 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						_tmp8_ = serializer_cast_to_exponential_string (self, x, FALSE, &n_digits);
#line 99 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						result = _tmp8_;
#line 99 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						_g_free0 (s0);
#line 99 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						return result;
#line 508 "serializer.c"
					}
				}
#line 86 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				case 16:
#line 513 "serializer.c"
				{
					gint _tmp9_;
#line 102 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
					_tmp9_ = n_digits;
#line 102 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
					if (_tmp9_ <= 16) {
#line 103 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						result = s0;
#line 103 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						return result;
#line 524 "serializer.c"
					} else {
						gchar* _tmp10_;
#line 105 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						_tmp10_ = serializer_cast_to_exponential_string (self, x, FALSE, &n_digits);
#line 105 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						result = _tmp10_;
#line 105 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						_g_free0 (s0);
#line 105 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						return result;
#line 535 "serializer.c"
					}
				}
				default:
#line 86 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				case 10:
#line 541 "serializer.c"
				{
					gint _tmp11_;
					gint _tmp12_;
#line 109 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
					_tmp11_ = n_digits;
#line 109 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
					_tmp12_ = self->priv->leading_digits;
#line 109 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
					if (_tmp11_ <= _tmp12_) {
#line 110 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						result = s0;
#line 110 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						return result;
#line 555 "serializer.c"
					} else {
						gchar* _tmp13_;
#line 112 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						_tmp13_ = serializer_cast_to_exponential_string (self, x, FALSE, &n_digits);
#line 112 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						result = _tmp13_;
#line 112 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						_g_free0 (s0);
#line 112 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						return result;
#line 566 "serializer.c"
					}
				}
			}
#line 79 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_g_free0 (s0);
#line 572 "serializer.c"
		}
#line 79 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		case DISPLAY_FORMAT_FIXED:
#line 576 "serializer.c"
		{
			gint n_digits = 0;
			gchar* _tmp14_;
#line 115 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			n_digits = 0;
#line 116 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp14_ = serializer_cast_to_string (self, x, &n_digits);
#line 116 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			result = _tmp14_;
#line 116 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			return result;
#line 588 "serializer.c"
		}
#line 79 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		case DISPLAY_FORMAT_SCIENTIFIC:
#line 592 "serializer.c"
		{
			guint _tmp15_;
#line 118 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp15_ = self->priv->representation_base;
#line 118 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			if (_tmp15_ == ((guint) 10)) {
#line 599 "serializer.c"
				gint n_digits = 0;
				gchar* _tmp16_;
#line 120 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				n_digits = 0;
#line 121 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp16_ = serializer_cast_to_exponential_string (self, x, FALSE, &n_digits);
#line 121 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				result = _tmp16_;
#line 121 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				return result;
#line 610 "serializer.c"
			} else {
				gint n_digits = 0;
				gchar* _tmp17_;
#line 125 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				n_digits = 0;
#line 126 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp17_ = serializer_cast_to_string (self, x, &n_digits);
#line 126 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				result = _tmp17_;
#line 126 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				return result;
#line 622 "serializer.c"
			}
		}
#line 79 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		case DISPLAY_FORMAT_ENGINEERING:
#line 627 "serializer.c"
		{
			guint _tmp18_;
#line 129 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp18_ = self->priv->representation_base;
#line 129 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			if (_tmp18_ == ((guint) 10)) {
#line 634 "serializer.c"
				gint n_digits = 0;
				gchar* _tmp19_;
#line 131 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				n_digits = 0;
#line 132 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp19_ = serializer_cast_to_exponential_string (self, x, TRUE, &n_digits);
#line 132 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				result = _tmp19_;
#line 132 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				return result;
#line 645 "serializer.c"
			} else {
				gint n_digits = 0;
				gchar* _tmp20_;
#line 136 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				n_digits = 0;
#line 137 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp20_ = serializer_cast_to_string (self, x, &n_digits);
#line 137 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				result = _tmp20_;
#line 137 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				return result;
#line 657 "serializer.c"
			}
		}
	}
}


Number*
serializer_from_string (Serializer* self,
                        const gchar* str)
{
	Number* result = NULL;
	gint _tmp0_;
	Number* _tmp1_;
#line 142 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 142 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 145 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp0_ = self->priv->number_base;
#line 145 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp1_ = mp_set_from_string (str, _tmp0_);
#line 145 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	result = _tmp1_;
#line 145 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	return result;
#line 683 "serializer.c"
}


void
serializer_set_base (Serializer* self,
                     gint number_base)
{
#line 148 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 150 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	self->priv->number_base = number_base;
#line 695 "serializer.c"
}


gint
serializer_get_base (Serializer* self)
{
	gint result = 0;
	gint _tmp0_;
#line 153 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 155 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp0_ = self->priv->number_base;
#line 155 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	result = _tmp0_;
#line 155 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	return result;
#line 712 "serializer.c"
}


void
serializer_set_representation_base (Serializer* self,
                                    guint representation_base)
{
#line 158 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 160 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	self->priv->representation_base = representation_base;
#line 724 "serializer.c"
}


guint
serializer_get_representation_base (Serializer* self)
{
	guint result = 0U;
	guint _tmp0_;
#line 163 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 165 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp0_ = self->priv->representation_base;
#line 165 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	result = _tmp0_;
#line 165 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	return result;
#line 741 "serializer.c"
}


void
serializer_set_radix (Serializer* self,
                      gunichar radix)
{
#line 168 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 170 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	self->priv->radix = radix;
#line 753 "serializer.c"
}


gunichar
serializer_get_radix (Serializer* self)
{
	gunichar result = 0U;
	gunichar _tmp0_;
#line 173 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 175 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp0_ = self->priv->radix;
#line 175 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	result = _tmp0_;
#line 175 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	return result;
#line 770 "serializer.c"
}


void
serializer_set_thousands_separator (Serializer* self,
                                    gunichar separator)
{
#line 178 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 180 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	self->priv->tsep = separator;
#line 782 "serializer.c"
}


gunichar
serializer_get_thousands_separator (Serializer* self)
{
	gunichar result = 0U;
	gunichar _tmp0_;
#line 183 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 185 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp0_ = self->priv->tsep;
#line 185 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	result = _tmp0_;
#line 185 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	return result;
#line 799 "serializer.c"
}


gint
serializer_get_thousands_separator_count (Serializer* self)
{
	gint result = 0;
	gint _tmp0_;
#line 188 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 190 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp0_ = self->priv->tsep_count;
#line 190 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	result = _tmp0_;
#line 190 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	return result;
#line 816 "serializer.c"
}


void
serializer_set_thousands_separator_count (Serializer* self,
                                          gint count)
{
#line 193 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 195 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	self->priv->tsep_count = count;
#line 828 "serializer.c"
}


void
serializer_set_show_thousands_separators (Serializer* self,
                                          gboolean visible)
{
#line 198 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 200 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	self->priv->show_tsep = visible;
#line 840 "serializer.c"
}


gboolean
serializer_get_show_thousands_separators (Serializer* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 203 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 205 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp0_ = self->priv->show_tsep;
#line 205 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	result = _tmp0_;
#line 205 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	return result;
#line 857 "serializer.c"
}


void
serializer_set_show_trailing_zeroes (Serializer* self,
                                     gboolean visible)
{
#line 208 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 210 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	self->priv->show_zeroes = visible;
#line 869 "serializer.c"
}


gboolean
serializer_get_show_trailing_zeroes (Serializer* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 213 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 215 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp0_ = self->priv->show_zeroes;
#line 215 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	result = _tmp0_;
#line 215 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	return result;
#line 886 "serializer.c"
}


gint
serializer_get_leading_digits (Serializer* self)
{
	gint result = 0;
	gint _tmp0_;
#line 218 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 220 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp0_ = self->priv->leading_digits;
#line 220 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	result = _tmp0_;
#line 220 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	return result;
#line 903 "serializer.c"
}


void
serializer_set_leading_digits (Serializer* self,
                               gint leading_digits)
{
#line 223 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 225 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	self->priv->leading_digits = leading_digits;
#line 915 "serializer.c"
}


gint
serializer_get_trailing_digits (Serializer* self)
{
	gint result = 0;
	gint _tmp0_;
#line 228 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 230 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp0_ = self->priv->trailing_digits;
#line 230 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	result = _tmp0_;
#line 230 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	return result;
#line 932 "serializer.c"
}


void
serializer_set_trailing_digits (Serializer* self,
                                gint trailing_digits)
{
#line 233 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 235 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	self->priv->trailing_digits = trailing_digits;
#line 944 "serializer.c"
}


DisplayFormat
serializer_get_number_format (Serializer* self)
{
	DisplayFormat result = 0;
	DisplayFormat _tmp0_;
#line 238 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 240 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp0_ = self->priv->format;
#line 240 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	result = _tmp0_;
#line 240 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	return result;
#line 961 "serializer.c"
}


void
serializer_set_number_format (Serializer* self,
                              DisplayFormat format)
{
#line 243 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 245 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	self->priv->format = format;
#line 973 "serializer.c"
}


static gchar*
serializer_cast_to_string (Serializer* self,
                           Number* x,
                           gint* n_digits)
{
	gchar* result = NULL;
	GString* string = NULL;
	GString* _tmp0_;
	Number* x_real = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	guint _tmp3_;
	GString* _tmp4_;
	GString* _tmp42_;
	const gchar* _tmp43_;
	gchar* _tmp44_;
#line 248 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 248 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_val_if_fail (x != NULL, NULL);
#line 250 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp0_ = g_string_sized_new ((gsize) 1024);
#line 250 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	string = _tmp0_;
#line 252 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp1_ = number_real_component (x);
#line 252 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	x_real = _tmp1_;
#line 253 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp2_ = x_real;
#line 253 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp3_ = self->priv->representation_base;
#line 253 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp4_ = string;
#line 253 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	serializer_cast_to_string_real (self, _tmp2_, (gint) _tmp3_, FALSE, n_digits, _tmp4_);
#line 254 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	if (number_is_complex (x)) {
#line 1015 "serializer.c"
		Number* x_im = NULL;
		Number* _tmp5_;
		gboolean force_sign = FALSE;
		GString* _tmp6_;
		const gchar* _tmp7_;
		GString* s = NULL;
		GString* _tmp9_;
		gint n_complex_digits = 0;
		Number* _tmp10_;
		guint _tmp11_;
		gboolean _tmp12_;
		GString* _tmp13_;
		gint _tmp14_;
		gboolean _tmp16_ = FALSE;
		gboolean _tmp17_ = FALSE;
		GString* _tmp18_;
		const gchar* _tmp19_;
#line 256 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp5_ = number_imaginary_component (x);
#line 256 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		x_im = _tmp5_;
#line 258 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		force_sign = TRUE;
#line 259 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp6_ = string;
#line 259 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp7_ = _tmp6_->str;
#line 259 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		if (g_strcmp0 (_tmp7_, "0") == 0) {
#line 1045 "serializer.c"
			GString* _tmp8_;
#line 261 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp8_ = string;
#line 261 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			g_string_assign (_tmp8_, "");
#line 262 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			force_sign = FALSE;
#line 1053 "serializer.c"
		}
#line 265 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp9_ = g_string_sized_new ((gsize) 1024);
#line 265 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		s = _tmp9_;
#line 266 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		n_complex_digits = 0;
#line 267 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp10_ = x_im;
#line 267 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp11_ = self->priv->representation_base;
#line 267 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp12_ = force_sign;
#line 267 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp13_ = s;
#line 267 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		serializer_cast_to_string_real (self, _tmp10_, (gint) _tmp11_, _tmp12_, &n_complex_digits, _tmp13_);
#line 268 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp14_ = n_complex_digits;
#line 268 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		if (_tmp14_ > (*n_digits)) {
#line 1075 "serializer.c"
			gint _tmp15_;
#line 269 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp15_ = n_complex_digits;
#line 269 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			*n_digits = _tmp15_;
#line 1081 "serializer.c"
		}
#line 270 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp18_ = s;
#line 270 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp19_ = _tmp18_->str;
#line 270 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		if (g_strcmp0 (_tmp19_, "0") == 0) {
#line 270 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp17_ = TRUE;
#line 1091 "serializer.c"
		} else {
			GString* _tmp20_;
			const gchar* _tmp21_;
#line 270 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp20_ = s;
#line 270 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp21_ = _tmp20_->str;
#line 270 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp17_ = g_strcmp0 (_tmp21_, "+0") == 0;
#line 1101 "serializer.c"
		}
#line 270 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		if (_tmp17_) {
#line 270 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp16_ = TRUE;
#line 1107 "serializer.c"
		} else {
			GString* _tmp22_;
			const gchar* _tmp23_;
#line 270 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp22_ = s;
#line 270 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp23_ = _tmp22_->str;
#line 270 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp16_ = g_strcmp0 (_tmp23_, "−0") == 0;
#line 1117 "serializer.c"
		}
#line 270 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		if (_tmp16_) {
#line 1121 "serializer.c"
		} else {
			GString* _tmp24_;
			const gchar* _tmp25_;
#line 274 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp24_ = s;
#line 274 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp25_ = _tmp24_->str;
#line 274 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			if (g_strcmp0 (_tmp25_, "1") == 0) {
#line 1131 "serializer.c"
				GString* _tmp26_;
#line 276 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp26_ = string;
#line 276 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				g_string_append (_tmp26_, "i");
#line 1137 "serializer.c"
			} else {
				GString* _tmp27_;
				const gchar* _tmp28_;
#line 278 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp27_ = s;
#line 278 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp28_ = _tmp27_->str;
#line 278 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				if (g_strcmp0 (_tmp28_, "+1") == 0) {
#line 1147 "serializer.c"
					GString* _tmp29_;
#line 280 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
					_tmp29_ = string;
#line 280 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
					g_string_append (_tmp29_, "+i");
#line 1153 "serializer.c"
				} else {
					GString* _tmp30_;
					const gchar* _tmp31_;
#line 282 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
					_tmp30_ = s;
#line 282 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
					_tmp31_ = _tmp30_->str;
#line 282 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
					if (g_strcmp0 (_tmp31_, "−1") == 0) {
#line 1163 "serializer.c"
						GString* _tmp32_;
#line 284 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						_tmp32_ = string;
#line 284 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						g_string_append (_tmp32_, "−i");
#line 1169 "serializer.c"
					} else {
						GString* _tmp33_;
						const gchar* _tmp34_;
						GString* _tmp41_;
#line 288 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						_tmp33_ = s;
#line 288 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						_tmp34_ = _tmp33_->str;
#line 288 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						if (g_strcmp0 (_tmp34_, "+0") == 0) {
#line 1180 "serializer.c"
							GString* _tmp35_;
#line 289 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
							_tmp35_ = string;
#line 289 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
							g_string_append (_tmp35_, "+");
#line 1186 "serializer.c"
						} else {
							GString* _tmp36_;
							const gchar* _tmp37_;
#line 290 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
							_tmp36_ = s;
#line 290 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
							_tmp37_ = _tmp36_->str;
#line 290 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
							if (g_strcmp0 (_tmp37_, "0") != 0) {
#line 1196 "serializer.c"
								GString* _tmp38_;
								GString* _tmp39_;
								const gchar* _tmp40_;
#line 291 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
								_tmp38_ = string;
#line 291 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
								_tmp39_ = s;
#line 291 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
								_tmp40_ = _tmp39_->str;
#line 291 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
								g_string_append (_tmp38_, _tmp40_);
#line 1208 "serializer.c"
							}
						}
#line 293 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						_tmp41_ = string;
#line 293 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						g_string_append (_tmp41_, "i");
#line 1215 "serializer.c"
					}
				}
			}
		}
#line 254 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_g_string_free0 (s);
#line 254 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_g_object_unref0 (x_im);
#line 1224 "serializer.c"
	}
#line 297 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp42_ = string;
#line 297 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp43_ = _tmp42_->str;
#line 297 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp44_ = g_strdup (_tmp43_);
#line 297 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	result = _tmp44_;
#line 297 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_g_object_unref0 (x_real);
#line 297 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_g_string_free0 (string);
#line 297 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	return result;
#line 1240 "serializer.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 304 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	return self ? g_object_ref (self) : NULL;
#line 1249 "serializer.c"
}


static void
serializer_cast_to_string_real (Serializer* self,
                                Number* x,
                                gint number_base,
                                gboolean force_sign,
                                gint* n_digits,
                                GString* string)
{
#line 302 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	static const gchar digits[16] = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'};
#line 1263 "serializer.c"
	Number* number = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* temp = NULL;
	Number* _tmp4_;
	Number* _tmp5_;
	gint _tmp6_;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* _tmp10_;
	Number* _tmp11_;
	Number* rounded_number = NULL;
	Number* _tmp12_;
	Number* _tmp13_;
	Number* _tmp14_;
	Number* _tmp15_;
	Number* _tmp16_;
	gint i = 0;
	gssize last_non_zero = 0L;
	gssize _tmp44_;
	gunichar _tmp45_;
	Number* _tmp46_;
	Number* _tmp47_;
	gboolean _tmp65_ = FALSE;
	gboolean _tmp66_;
	gboolean _tmp69_ = FALSE;
	const gchar* _tmp70_;
	gint _tmp71_;
#line 300 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 300 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_if_fail (x != NULL);
#line 300 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_if_fail (string != NULL);
#line 304 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp0_ = _g_object_ref0 (x);
#line 304 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	number = _tmp0_;
#line 305 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp1_ = number;
#line 305 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	if (number_is_negative (_tmp1_)) {
#line 1307 "serializer.c"
		Number* _tmp2_;
		Number* _tmp3_;
#line 306 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp2_ = number;
#line 306 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp3_ = number_abs (_tmp2_);
#line 306 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_g_object_unref0 (number);
#line 306 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		number = _tmp3_;
#line 1318 "serializer.c"
	}
#line 309 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp4_ = number_new_integer ((gint64) number_base, (gint64) 0);
#line 309 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	temp = _tmp4_;
#line 310 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp5_ = temp;
#line 310 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp6_ = self->priv->trailing_digits;
#line 310 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp7_ = number_xpowy_integer (_tmp5_, (gint64) (-(_tmp6_ + 1)));
#line 310 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_g_object_unref0 (temp);
#line 310 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	temp = _tmp7_;
#line 311 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp8_ = temp;
#line 311 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp9_ = number_multiply_integer (_tmp8_, (gint64) number_base);
#line 311 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_g_object_unref0 (temp);
#line 311 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	temp = _tmp9_;
#line 312 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp10_ = temp;
#line 312 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp11_ = number_divide_integer (_tmp10_, (gint64) 2);
#line 312 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_g_object_unref0 (temp);
#line 312 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	temp = _tmp11_;
#line 313 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp12_ = number;
#line 313 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp13_ = temp;
#line 313 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp14_ = number_add (_tmp12_, _tmp13_);
#line 313 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	rounded_number = _tmp14_;
#line 316 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp15_ = rounded_number;
#line 316 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp16_ = number_floor (_tmp15_);
#line 316 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_g_object_unref0 (temp);
#line 316 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	temp = _tmp16_;
#line 317 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	i = 0;
#line 1368 "serializer.c"
	{
		gboolean _tmp17_ = FALSE;
#line 318 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp17_ = TRUE;
#line 318 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		while (TRUE) {
#line 1375 "serializer.c"
			gboolean _tmp19_ = FALSE;
			gboolean _tmp20_ = FALSE;
			gint _tmp25_;
			Number* t = NULL;
			Number* _tmp26_;
			Number* _tmp27_;
			Number* _tmp28_;
			Number* _tmp29_;
			Number* t2 = NULL;
			Number* _tmp30_;
			Number* _tmp31_;
			Number* t3 = NULL;
			Number* _tmp32_;
			Number* _tmp33_;
			Number* _tmp34_;
			gint64 d = 0LL;
			Number* _tmp35_;
			gboolean _tmp36_ = FALSE;
			gint64 _tmp37_;
			gint _tmp41_;
			Number* _tmp42_;
			Number* _tmp43_;
#line 318 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			if (!_tmp17_) {
#line 1400 "serializer.c"
				Number* _tmp18_;
#line 349 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp18_ = temp;
#line 349 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				if (!(!number_is_zero (_tmp18_))) {
#line 349 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
					break;
#line 1408 "serializer.c"
				}
			}
#line 318 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp17_ = FALSE;
#line 320 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			if (number_base == 10) {
#line 1415 "serializer.c"
				gboolean _tmp21_;
#line 320 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp21_ = self->priv->show_tsep;
#line 320 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp20_ = _tmp21_;
#line 1421 "serializer.c"
			} else {
#line 320 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp20_ = FALSE;
#line 1425 "serializer.c"
			}
#line 320 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			if (_tmp20_) {
#line 1429 "serializer.c"
				gint _tmp22_;
				gint _tmp23_;
#line 320 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp22_ = i;
#line 320 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp23_ = self->priv->tsep_count;
#line 320 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp19_ = _tmp22_ == _tmp23_;
#line 1438 "serializer.c"
			} else {
#line 320 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp19_ = FALSE;
#line 1442 "serializer.c"
			}
#line 320 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			if (_tmp19_) {
#line 1446 "serializer.c"
				gunichar _tmp24_;
#line 322 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp24_ = self->priv->tsep;
#line 322 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				g_string_prepend_unichar (string, _tmp24_);
#line 323 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				i = 0;
#line 1454 "serializer.c"
			}
#line 325 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp25_ = i;
#line 325 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			i = _tmp25_ + 1;
#line 327 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp26_ = temp;
#line 327 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp27_ = number_divide_integer (_tmp26_, (gint64) number_base);
#line 327 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			t = _tmp27_;
#line 328 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp28_ = t;
#line 328 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp29_ = number_floor (_tmp28_);
#line 328 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_g_object_unref0 (t);
#line 328 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			t = _tmp29_;
#line 329 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp30_ = t;
#line 329 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp31_ = number_multiply_integer (_tmp30_, (gint64) number_base);
#line 329 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			t2 = _tmp31_;
#line 331 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp32_ = temp;
#line 331 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp33_ = t2;
#line 331 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp34_ = number_subtract (_tmp32_, _tmp33_);
#line 331 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			t3 = _tmp34_;
#line 333 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp35_ = t3;
#line 333 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			d = number_to_integer (_tmp35_);
#line 335 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp37_ = d;
#line 335 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			if (_tmp37_ < ((gint64) 16)) {
#line 1496 "serializer.c"
				gint64 _tmp38_;
#line 335 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp38_ = d;
#line 335 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp36_ = _tmp38_ >= ((gint64) 0);
#line 1502 "serializer.c"
			} else {
#line 335 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp36_ = FALSE;
#line 1506 "serializer.c"
			}
#line 335 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			if (_tmp36_) {
#line 1510 "serializer.c"
				gint64 _tmp39_;
				gchar _tmp40_;
#line 337 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp39_ = d;
#line 337 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp40_ = digits[_tmp39_];
#line 337 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				g_string_prepend_c (string, _tmp40_);
#line 1519 "serializer.c"
			} else {
#line 341 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				g_string_prepend_c (string, '?');
#line 342 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				serializer_set_error (self, _ ("Overflow: the result couldn’t be calculated"));
#line 343 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				g_string_assign (string, "0");
#line 344 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_g_object_unref0 (t3);
#line 344 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_g_object_unref0 (t2);
#line 344 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_g_object_unref0 (t);
#line 344 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				break;
#line 1535 "serializer.c"
			}
#line 346 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp41_ = *n_digits;
#line 346 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			*n_digits = _tmp41_ + 1;
#line 348 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp42_ = t;
#line 348 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp43_ = _g_object_ref0 (_tmp42_);
#line 348 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_g_object_unref0 (temp);
#line 348 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			temp = _tmp43_;
#line 318 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_g_object_unref0 (t3);
#line 318 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_g_object_unref0 (t2);
#line 318 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_g_object_unref0 (t);
#line 1555 "serializer.c"
		}
	}
#line 351 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp44_ = string->len;
#line 351 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	last_non_zero = _tmp44_;
#line 353 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp45_ = self->priv->radix;
#line 353 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_string_append_unichar (string, _tmp45_);
#line 356 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp46_ = rounded_number;
#line 356 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp47_ = number_fractional_component (_tmp46_);
#line 356 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_g_object_unref0 (temp);
#line 356 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	temp = _tmp47_;
#line 1574 "serializer.c"
	{
		gboolean _tmp48_ = FALSE;
#line 357 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		i = 0;
#line 357 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp48_ = TRUE;
#line 357 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		while (TRUE) {
#line 1583 "serializer.c"
			gint _tmp50_;
			gint _tmp51_;
			Number* _tmp52_;
			Number* _tmp53_;
			Number* _tmp54_;
			Number* digit = NULL;
			Number* _tmp55_;
			Number* _tmp56_;
			gint64 d = 0LL;
			Number* _tmp57_;
			gint64 _tmp58_;
			gchar _tmp59_;
			gint64 _tmp60_;
			Number* _tmp62_;
			Number* _tmp63_;
			Number* _tmp64_;
#line 357 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			if (!_tmp48_) {
#line 1602 "serializer.c"
				gint _tmp49_;
#line 357 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp49_ = i;
#line 357 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				i = _tmp49_ + 1;
#line 1608 "serializer.c"
			}
#line 357 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp48_ = FALSE;
#line 357 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp50_ = i;
#line 357 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp51_ = self->priv->trailing_digits;
#line 357 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			if (!(_tmp50_ < _tmp51_)) {
#line 357 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				break;
#line 1620 "serializer.c"
			}
#line 359 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp52_ = temp;
#line 359 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			if (number_is_zero (_tmp52_)) {
#line 360 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				break;
#line 1628 "serializer.c"
			}
#line 362 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp53_ = temp;
#line 362 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp54_ = number_multiply_integer (_tmp53_, (gint64) number_base);
#line 362 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_g_object_unref0 (temp);
#line 362 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			temp = _tmp54_;
#line 363 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp55_ = temp;
#line 363 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp56_ = number_floor (_tmp55_);
#line 363 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			digit = _tmp56_;
#line 364 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp57_ = digit;
#line 364 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			d = number_to_integer (_tmp57_);
#line 366 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp58_ = d;
#line 366 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp59_ = digits[_tmp58_];
#line 366 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			g_string_append_c (string, _tmp59_);
#line 368 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp60_ = d;
#line 368 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			if (_tmp60_ != ((gint64) 0)) {
#line 1658 "serializer.c"
				gssize _tmp61_;
#line 369 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp61_ = string->len;
#line 369 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				last_non_zero = _tmp61_;
#line 1664 "serializer.c"
			}
#line 370 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp62_ = temp;
#line 370 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp63_ = digit;
#line 370 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp64_ = number_subtract (_tmp62_, _tmp63_);
#line 370 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_g_object_unref0 (temp);
#line 370 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			temp = _tmp64_;
#line 357 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_g_object_unref0 (digit);
#line 1678 "serializer.c"
		}
	}
#line 374 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp66_ = self->priv->show_zeroes;
#line 374 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	if (!_tmp66_) {
#line 374 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp65_ = TRUE;
#line 1687 "serializer.c"
	} else {
		gint _tmp67_;
#line 374 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp67_ = self->priv->trailing_digits;
#line 374 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp65_ = _tmp67_ == 0;
#line 1694 "serializer.c"
	}
#line 374 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	if (_tmp65_) {
#line 1698 "serializer.c"
		gssize _tmp68_;
#line 375 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp68_ = last_non_zero;
#line 375 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		g_string_truncate (string, (gsize) _tmp68_);
#line 1704 "serializer.c"
	}
#line 378 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp70_ = string->str;
#line 378 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	if (g_strcmp0 (_tmp70_, "0") != 0) {
#line 378 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp69_ = TRUE;
#line 1712 "serializer.c"
	} else {
#line 378 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp69_ = force_sign;
#line 1716 "serializer.c"
	}
#line 378 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	if (_tmp69_) {
#line 380 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		if (number_is_negative (x)) {
#line 381 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			g_string_prepend (string, "−");
#line 1724 "serializer.c"
		} else {
#line 382 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			if (force_sign) {
#line 383 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				g_string_prepend (string, "+");
#line 1730 "serializer.c"
			}
		}
	}
#line 387 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp71_ = self->priv->number_base;
#line 387 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	if (number_base != _tmp71_) {
#line 389 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		static const gchar* sub_digits[10] = {"₀", "₁", "₂", "₃", "₄", "₅", "₆", "₇", "₈", "₉"};
#line 1740 "serializer.c"
		gint multiplier = 0;
		gint b = 0;
#line 390 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		multiplier = 1;
#line 391 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		b = number_base;
#line 393 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		while (TRUE) {
#line 1749 "serializer.c"
			gint _tmp72_;
			gint _tmp73_;
#line 393 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp72_ = multiplier;
#line 393 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			if (!((number_base / _tmp72_) != 0)) {
#line 393 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				break;
#line 1758 "serializer.c"
			}
#line 394 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp73_ = multiplier;
#line 394 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			multiplier = _tmp73_ * 10;
#line 1764 "serializer.c"
		}
#line 395 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		while (TRUE) {
#line 1768 "serializer.c"
			gint _tmp74_;
			gint d = 0;
			gint _tmp75_;
			gint _tmp76_;
			gint _tmp77_;
			gint _tmp78_;
			const gchar* _tmp79_;
			gint _tmp80_;
			gint _tmp81_;
			gint _tmp82_;
#line 395 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp74_ = multiplier;
#line 395 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			if (!(_tmp74_ != 1)) {
#line 395 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				break;
#line 1785 "serializer.c"
			}
#line 398 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp75_ = multiplier;
#line 398 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			multiplier = _tmp75_ / 10;
#line 399 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp76_ = b;
#line 399 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp77_ = multiplier;
#line 399 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			d = _tmp76_ / _tmp77_;
#line 400 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp78_ = d;
#line 400 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp79_ = sub_digits[_tmp78_];
#line 400 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			g_string_append (string, _tmp79_);
#line 401 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp80_ = b;
#line 401 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp81_ = d;
#line 401 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp82_ = multiplier;
#line 401 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			b = _tmp80_ - (_tmp81_ * _tmp82_);
#line 1811 "serializer.c"
		}
	}
#line 300 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_g_object_unref0 (rounded_number);
#line 300 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_g_object_unref0 (temp);
#line 300 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_g_object_unref0 (number);
#line 1820 "serializer.c"
}


static gint
serializer_cast_to_exponential_string_real (Serializer* self,
                                            Number* x,
                                            GString* string,
                                            gboolean eng_format,
                                            gint* n_digits)
{
	gint result = 0;
	Number* mantissa = NULL;
	Number* _tmp0_;
	Number* base_ = NULL;
	gint _tmp1_;
	Number* _tmp2_;
	Number* base3 = NULL;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* base10 = NULL;
	Number* _tmp5_;
	Number* _tmp6_;
	Number* t = NULL;
	Number* _tmp7_;
	Number* base10inv = NULL;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* _tmp10_;
	gint exponent = 0;
	Number* _tmp11_;
	Number* _tmp49_;
	gchar* _tmp50_;
	gchar* _tmp51_;
#line 406 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 406 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_val_if_fail (x != NULL, 0);
#line 406 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_val_if_fail (string != NULL, 0);
#line 408 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	if (number_is_negative (x)) {
#line 409 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		g_string_append (string, "−");
#line 1864 "serializer.c"
	}
#line 411 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp0_ = number_abs (x);
#line 411 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	mantissa = _tmp0_;
#line 413 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp1_ = self->priv->number_base;
#line 413 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp2_ = number_new_integer ((gint64) _tmp1_, (gint64) 0);
#line 413 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	base_ = _tmp2_;
#line 414 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp3_ = base_;
#line 414 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp4_ = number_xpowy_integer (_tmp3_, (gint64) 3);
#line 414 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	base3 = _tmp4_;
#line 415 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp5_ = base_;
#line 415 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp6_ = number_xpowy_integer (_tmp5_, (gint64) 10);
#line 415 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	base10 = _tmp6_;
#line 416 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp7_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 416 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	t = _tmp7_;
#line 417 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp8_ = t;
#line 417 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp9_ = base10;
#line 417 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp10_ = number_divide (_tmp8_, _tmp9_);
#line 417 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	base10inv = _tmp10_;
#line 419 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	exponent = 0;
#line 420 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp11_ = mantissa;
#line 420 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	if (!number_is_zero (_tmp11_)) {
#line 1906 "serializer.c"
		Number* _tmp39_;
#line 422 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		while (TRUE) {
#line 1910 "serializer.c"
			gboolean _tmp12_ = FALSE;
			gint _tmp15_;
			Number* _tmp16_;
			Number* _tmp17_;
			Number* _tmp18_;
#line 422 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			if (!eng_format) {
#line 1918 "serializer.c"
				Number* _tmp13_;
				Number* _tmp14_;
#line 422 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp13_ = mantissa;
#line 422 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp14_ = base10;
#line 422 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp12_ = number_compare (_tmp13_, _tmp14_) >= 0;
#line 1927 "serializer.c"
			} else {
#line 422 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp12_ = FALSE;
#line 1931 "serializer.c"
			}
#line 422 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			if (!_tmp12_) {
#line 422 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				break;
#line 1937 "serializer.c"
			}
#line 424 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp15_ = exponent;
#line 424 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			exponent = _tmp15_ + 10;
#line 425 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp16_ = mantissa;
#line 425 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp17_ = base10inv;
#line 425 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp18_ = number_multiply (_tmp16_, _tmp17_);
#line 425 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_g_object_unref0 (mantissa);
#line 425 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			mantissa = _tmp18_;
#line 1953 "serializer.c"
		}
#line 428 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		while (TRUE) {
#line 1957 "serializer.c"
			gboolean _tmp19_ = FALSE;
			gboolean _tmp20_ = FALSE;
			gint _tmp28_;
			Number* _tmp29_;
			Number* _tmp30_;
			Number* _tmp31_;
#line 428 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			if (!eng_format) {
#line 1966 "serializer.c"
				Number* _tmp21_;
				Number* _tmp22_;
#line 428 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp21_ = mantissa;
#line 428 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp22_ = base_;
#line 428 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp20_ = number_compare (_tmp21_, _tmp22_) >= 0;
#line 1975 "serializer.c"
			} else {
#line 428 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp20_ = FALSE;
#line 1979 "serializer.c"
			}
#line 428 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			if (_tmp20_) {
#line 428 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp19_ = TRUE;
#line 1985 "serializer.c"
			} else {
				gboolean _tmp23_ = FALSE;
#line 429 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				if (eng_format) {
#line 1990 "serializer.c"
					gboolean _tmp24_ = FALSE;
					Number* _tmp25_;
					Number* _tmp26_;
#line 429 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
					_tmp25_ = mantissa;
#line 429 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
					_tmp26_ = base3;
#line 429 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
					if (number_compare (_tmp25_, _tmp26_) >= 0) {
#line 429 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						_tmp24_ = TRUE;
#line 2002 "serializer.c"
					} else {
						gint _tmp27_;
#line 429 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						_tmp27_ = exponent;
#line 429 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						_tmp24_ = (_tmp27_ % 3) != 0;
#line 2009 "serializer.c"
					}
#line 429 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
					_tmp23_ = _tmp24_;
#line 2013 "serializer.c"
				} else {
#line 429 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
					_tmp23_ = FALSE;
#line 2017 "serializer.c"
				}
#line 429 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp19_ = _tmp23_;
#line 2021 "serializer.c"
			}
#line 428 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			if (!_tmp19_) {
#line 428 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				break;
#line 2027 "serializer.c"
			}
#line 431 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp28_ = exponent;
#line 431 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			exponent = _tmp28_ + 1;
#line 432 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp29_ = mantissa;
#line 432 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp30_ = base_;
#line 432 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp31_ = number_divide (_tmp29_, _tmp30_);
#line 432 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_g_object_unref0 (mantissa);
#line 432 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			mantissa = _tmp31_;
#line 2043 "serializer.c"
		}
#line 435 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		while (TRUE) {
#line 2047 "serializer.c"
			gboolean _tmp32_ = FALSE;
			gint _tmp35_;
			Number* _tmp36_;
			Number* _tmp37_;
			Number* _tmp38_;
#line 435 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			if (!eng_format) {
#line 2055 "serializer.c"
				Number* _tmp33_;
				Number* _tmp34_;
#line 435 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp33_ = mantissa;
#line 435 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp34_ = base10inv;
#line 435 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp32_ = number_compare (_tmp33_, _tmp34_) < 0;
#line 2064 "serializer.c"
			} else {
#line 435 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp32_ = FALSE;
#line 2068 "serializer.c"
			}
#line 435 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			if (!_tmp32_) {
#line 435 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				break;
#line 2074 "serializer.c"
			}
#line 437 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp35_ = exponent;
#line 437 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			exponent = _tmp35_ - 10;
#line 438 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp36_ = mantissa;
#line 438 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp37_ = base10;
#line 438 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp38_ = number_multiply (_tmp36_, _tmp37_);
#line 438 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_g_object_unref0 (mantissa);
#line 438 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			mantissa = _tmp38_;
#line 2090 "serializer.c"
		}
#line 441 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp39_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 441 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_g_object_unref0 (t);
#line 441 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		t = _tmp39_;
#line 442 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		while (TRUE) {
#line 2100 "serializer.c"
			gboolean _tmp40_ = FALSE;
			Number* _tmp41_;
			Number* _tmp42_;
			gint _tmp45_;
			Number* _tmp46_;
			Number* _tmp47_;
			Number* _tmp48_;
#line 442 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp41_ = mantissa;
#line 442 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp42_ = t;
#line 442 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			if (number_compare (_tmp41_, _tmp42_) < 0) {
#line 442 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp40_ = TRUE;
#line 2116 "serializer.c"
			} else {
				gboolean _tmp43_ = FALSE;
#line 442 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				if (eng_format) {
#line 2121 "serializer.c"
					gint _tmp44_;
#line 442 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
					_tmp44_ = exponent;
#line 442 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
					_tmp43_ = (_tmp44_ % 3) != 0;
#line 2127 "serializer.c"
				} else {
#line 442 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
					_tmp43_ = FALSE;
#line 2131 "serializer.c"
				}
#line 442 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp40_ = _tmp43_;
#line 2135 "serializer.c"
			}
#line 442 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			if (!_tmp40_) {
#line 442 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				break;
#line 2141 "serializer.c"
			}
#line 444 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp45_ = exponent;
#line 444 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			exponent = _tmp45_ - 1;
#line 445 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp46_ = mantissa;
#line 445 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp47_ = base_;
#line 445 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp48_ = number_multiply (_tmp46_, _tmp47_);
#line 445 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_g_object_unref0 (mantissa);
#line 445 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			mantissa = _tmp48_;
#line 2157 "serializer.c"
		}
	}
#line 449 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp49_ = mantissa;
#line 449 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp50_ = serializer_cast_to_string (self, _tmp49_, n_digits);
#line 449 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp51_ = _tmp50_;
#line 449 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_string_append (string, _tmp51_);
#line 449 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_g_free0 (_tmp51_);
#line 451 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	result = exponent;
#line 451 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_g_object_unref0 (base10inv);
#line 451 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_g_object_unref0 (t);
#line 451 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_g_object_unref0 (base10);
#line 451 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_g_object_unref0 (base3);
#line 451 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_g_object_unref0 (base_);
#line 451 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_g_object_unref0 (mantissa);
#line 451 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	return result;
#line 2186 "serializer.c"
}


static gchar*
serializer_cast_to_exponential_string (Serializer* self,
                                       Number* x,
                                       gboolean eng_format,
                                       gint* n_digits)
{
	gchar* result = NULL;
	GString* string = NULL;
	GString* _tmp0_;
	Number* x_real = NULL;
	Number* _tmp1_;
	gint exponent = 0;
	Number* _tmp2_;
	GString* _tmp3_;
	gint _tmp4_;
	GString* _tmp5_;
	gint _tmp6_;
	GString* _tmp45_;
	const gchar* _tmp46_;
	gchar* _tmp47_;
#line 454 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 454 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_val_if_fail (x != NULL, NULL);
#line 456 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp0_ = g_string_sized_new ((gsize) 1024);
#line 456 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	string = _tmp0_;
#line 458 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp1_ = number_real_component (x);
#line 458 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	x_real = _tmp1_;
#line 459 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp2_ = x_real;
#line 459 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp3_ = string;
#line 459 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp4_ = serializer_cast_to_exponential_string_real (self, _tmp2_, _tmp3_, eng_format, n_digits);
#line 459 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	exponent = _tmp4_;
#line 460 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp5_ = string;
#line 460 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp6_ = exponent;
#line 460 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	serializer_append_exponent (self, _tmp5_, _tmp6_);
#line 462 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	if (number_is_complex (x)) {
#line 2238 "serializer.c"
		Number* x_im = NULL;
		Number* _tmp7_;
		GString* _tmp8_;
		const gchar* _tmp9_;
		GString* s = NULL;
		GString* _tmp11_;
		gint n_complex_digits = 0;
		Number* _tmp12_;
		GString* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		gboolean _tmp17_ = FALSE;
		gboolean _tmp18_ = FALSE;
		GString* _tmp19_;
		const gchar* _tmp20_;
		GString* _tmp43_;
		gint _tmp44_;
#line 464 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp7_ = number_imaginary_component (x);
#line 464 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		x_im = _tmp7_;
#line 466 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp8_ = string;
#line 466 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp9_ = _tmp8_->str;
#line 466 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		if (g_strcmp0 (_tmp9_, "0") == 0) {
#line 2266 "serializer.c"
			GString* _tmp10_;
#line 467 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp10_ = string;
#line 467 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			g_string_assign (_tmp10_, "");
#line 2272 "serializer.c"
		}
#line 469 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp11_ = g_string_sized_new ((gsize) 1024);
#line 469 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		s = _tmp11_;
#line 470 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		n_complex_digits = 0;
#line 471 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp12_ = x_im;
#line 471 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp13_ = s;
#line 471 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp14_ = serializer_cast_to_exponential_string_real (self, _tmp12_, _tmp13_, eng_format, &n_complex_digits);
#line 471 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		exponent = _tmp14_;
#line 472 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp15_ = n_complex_digits;
#line 472 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		if (_tmp15_ > (*n_digits)) {
#line 2292 "serializer.c"
			gint _tmp16_;
#line 473 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp16_ = n_complex_digits;
#line 473 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			*n_digits = _tmp16_;
#line 2298 "serializer.c"
		}
#line 474 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp19_ = s;
#line 474 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp20_ = _tmp19_->str;
#line 474 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		if (g_strcmp0 (_tmp20_, "0") == 0) {
#line 474 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp18_ = TRUE;
#line 2308 "serializer.c"
		} else {
			GString* _tmp21_;
			const gchar* _tmp22_;
#line 474 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp21_ = s;
#line 474 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp22_ = _tmp21_->str;
#line 474 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp18_ = g_strcmp0 (_tmp22_, "+0") == 0;
#line 2318 "serializer.c"
		}
#line 474 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		if (_tmp18_) {
#line 474 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp17_ = TRUE;
#line 2324 "serializer.c"
		} else {
			GString* _tmp23_;
			const gchar* _tmp24_;
#line 474 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp23_ = s;
#line 474 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp24_ = _tmp23_->str;
#line 474 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp17_ = g_strcmp0 (_tmp24_, "−0") == 0;
#line 2334 "serializer.c"
		}
#line 474 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		if (_tmp17_) {
#line 2338 "serializer.c"
		} else {
			GString* _tmp25_;
			const gchar* _tmp26_;
#line 478 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp25_ = s;
#line 478 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp26_ = _tmp25_->str;
#line 478 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			if (g_strcmp0 (_tmp26_, "1") == 0) {
#line 2348 "serializer.c"
				GString* _tmp27_;
#line 480 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp27_ = string;
#line 480 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				g_string_append (_tmp27_, "i");
#line 2354 "serializer.c"
			} else {
				GString* _tmp28_;
				const gchar* _tmp29_;
#line 482 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp28_ = s;
#line 482 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp29_ = _tmp28_->str;
#line 482 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				if (g_strcmp0 (_tmp29_, "+1") == 0) {
#line 2364 "serializer.c"
					GString* _tmp30_;
#line 484 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
					_tmp30_ = string;
#line 484 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
					g_string_append (_tmp30_, "+i");
#line 2370 "serializer.c"
				} else {
					GString* _tmp31_;
					const gchar* _tmp32_;
#line 486 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
					_tmp31_ = s;
#line 486 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
					_tmp32_ = _tmp31_->str;
#line 486 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
					if (g_strcmp0 (_tmp32_, "−1") == 0) {
#line 2380 "serializer.c"
						GString* _tmp33_;
#line 488 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						_tmp33_ = string;
#line 488 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						g_string_append (_tmp33_, "−i");
#line 2386 "serializer.c"
					} else {
						GString* _tmp34_;
						const gchar* _tmp35_;
						GString* _tmp42_;
#line 492 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						_tmp34_ = s;
#line 492 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						_tmp35_ = _tmp34_->str;
#line 492 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						if (g_strcmp0 (_tmp35_, "+0") == 0) {
#line 2397 "serializer.c"
							GString* _tmp36_;
#line 493 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
							_tmp36_ = string;
#line 493 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
							g_string_append (_tmp36_, "+");
#line 2403 "serializer.c"
						} else {
							GString* _tmp37_;
							const gchar* _tmp38_;
#line 494 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
							_tmp37_ = s;
#line 494 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
							_tmp38_ = _tmp37_->str;
#line 494 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
							if (g_strcmp0 (_tmp38_, "0") != 0) {
#line 2413 "serializer.c"
								GString* _tmp39_;
								GString* _tmp40_;
								const gchar* _tmp41_;
#line 495 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
								_tmp39_ = string;
#line 495 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
								_tmp40_ = s;
#line 495 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
								_tmp41_ = _tmp40_->str;
#line 495 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
								g_string_append (_tmp39_, _tmp41_);
#line 2425 "serializer.c"
							}
						}
#line 497 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						_tmp42_ = string;
#line 497 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
						g_string_append (_tmp42_, "i");
#line 2432 "serializer.c"
					}
				}
			}
		}
#line 499 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp43_ = string;
#line 499 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp44_ = exponent;
#line 499 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		serializer_append_exponent (self, _tmp43_, _tmp44_);
#line 462 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_g_string_free0 (s);
#line 462 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_g_object_unref0 (x_im);
#line 2447 "serializer.c"
	}
#line 502 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp45_ = string;
#line 502 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp46_ = _tmp45_->str;
#line 502 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp47_ = g_strdup (_tmp46_);
#line 502 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	result = _tmp47_;
#line 502 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_g_object_unref0 (x_real);
#line 502 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_g_string_free0 (string);
#line 502 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	return result;
#line 2463 "serializer.c"
}


static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
#line 1180 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1181 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1181 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp0_;
#line 1181 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 2481 "serializer.c"
}


static void
serializer_append_exponent (Serializer* self,
                            GString* string,
                            gint exponent)
{
#line 507 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	static const gunichar super_digits[10] = {8304U, 185U, 178U, 179U, 8308U, 8309U, 8310U, 8311U, 8312U, 8313U};
#line 2492 "serializer.c"
	gchar* super_value = NULL;
	gchar* _tmp0_;
#line 505 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 505 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_if_fail (string != NULL);
#line 509 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	if (exponent == 0) {
#line 510 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		return;
#line 2503 "serializer.c"
	}
#line 512 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_string_append (string, "×10");
#line 513 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	if (exponent < 0) {
#line 515 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		exponent = -exponent;
#line 516 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		g_string_append_unichar (string, 8315U);
#line 2513 "serializer.c"
	}
#line 519 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp0_ = g_strdup_printf ("%d", exponent);
#line 519 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	super_value = _tmp0_;
#line 2519 "serializer.c"
	{
		gint i = 0;
#line 520 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		i = 0;
#line 2524 "serializer.c"
		{
			gboolean _tmp1_ = FALSE;
#line 520 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			_tmp1_ = TRUE;
#line 520 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
			while (TRUE) {
#line 2531 "serializer.c"
				gint _tmp3_;
				const gchar* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				const gchar* _tmp7_;
				gint _tmp8_;
				gunichar _tmp9_;
#line 520 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				if (!_tmp1_) {
#line 2541 "serializer.c"
					gint _tmp2_;
#line 520 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
					_tmp2_ = i;
#line 520 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
					i = _tmp2_ + 1;
#line 2547 "serializer.c"
				}
#line 520 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp1_ = FALSE;
#line 520 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp3_ = i;
#line 520 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp4_ = super_value;
#line 520 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp5_ = strlen (_tmp4_);
#line 520 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp6_ = _tmp5_;
#line 520 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				if (!(_tmp3_ < _tmp6_)) {
#line 520 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
					break;
#line 2563 "serializer.c"
				}
#line 521 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp7_ = super_value;
#line 521 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp8_ = i;
#line 521 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				_tmp9_ = super_digits[string_get (_tmp7_, (glong) _tmp8_) - '0'];
#line 521 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
				g_string_append_unichar (string, _tmp9_);
#line 2573 "serializer.c"
			}
		}
	}
#line 505 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_g_free0 (super_value);
#line 2579 "serializer.c"
}


const gchar*
serializer_get_error (Serializer* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 36 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_tmp0_ = self->priv->_error;
#line 36 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	result = _tmp0_;
#line 36 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	return result;
#line 2596 "serializer.c"
}


void
serializer_set_error (Serializer* self,
                      const gchar* value)
{
#line 36 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 36 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	if (g_strcmp0 (value, serializer_get_error (self)) != 0) {
#line 2608 "serializer.c"
		gchar* _tmp0_;
#line 36 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_tmp0_ = g_strdup (value);
#line 36 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		_g_free0 (self->priv->_error);
#line 36 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		self->priv->_error = _tmp0_;
#line 36 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		g_object_notify_by_pspec ((GObject *) self, serializer_properties[SERIALIZER_ERROR_PROPERTY]);
#line 2618 "serializer.c"
	}
}


static void
serializer_class_init (SerializerClass * klass)
{
#line 20 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	serializer_parent_class = g_type_class_peek_parent (klass);
#line 20 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_type_class_add_private (klass, sizeof (SerializerPrivate));
#line 20 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_serializer_get_property;
#line 20 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_serializer_set_property;
#line 20 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	G_OBJECT_CLASS (klass)->finalize = serializer_finalize;
#line 20 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SERIALIZER_ERROR_PROPERTY, serializer_properties[SERIALIZER_ERROR_PROPERTY] = g_param_spec_string ("error", "error", "error", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2638 "serializer.c"
}


static void
serializer_instance_init (Serializer * self)
{
#line 20 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	self->priv = SERIALIZER_GET_PRIVATE (self);
#line 36 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	self->priv->_error = NULL;
#line 2649 "serializer.c"
}


static void
serializer_finalize (GObject * obj)
{
	Serializer * self;
#line 20 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SERIALIZER, Serializer);
#line 36 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	_g_free0 (self->priv->_error);
#line 20 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	G_OBJECT_CLASS (serializer_parent_class)->finalize (obj);
#line 2663 "serializer.c"
}


GType
serializer_get_type (void)
{
	static volatile gsize serializer_type_id__volatile = 0;
	if (g_once_init_enter (&serializer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SerializerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) serializer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Serializer), 0, (GInstanceInitFunc) serializer_instance_init, NULL };
		GType serializer_type_id;
		serializer_type_id = g_type_register_static (G_TYPE_OBJECT, "Serializer", &g_define_type_info, 0);
		g_once_init_leave (&serializer_type_id__volatile, serializer_type_id);
	}
	return serializer_type_id__volatile;
}


static void
_vala_serializer_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	Serializer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SERIALIZER, Serializer);
#line 20 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	switch (property_id) {
#line 20 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		case SERIALIZER_ERROR_PROPERTY:
#line 20 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		g_value_set_string (value, serializer_get_error (self));
#line 20 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		break;
#line 2697 "serializer.c"
		default:
#line 20 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		break;
#line 2703 "serializer.c"
	}
}


static void
_vala_serializer_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	Serializer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SERIALIZER, Serializer);
#line 20 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
	switch (property_id) {
#line 20 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		case SERIALIZER_ERROR_PROPERTY:
#line 20 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		serializer_set_error (self, g_value_get_string (value));
#line 20 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		break;
#line 2724 "serializer.c"
		default:
#line 20 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/serializer.vala"
		break;
#line 2730 "serializer.c"
	}
}



