/* number.c generated by valac 0.40.19, the Vala compiler
 * generated from number.vala, do not modify */

/*
 * Copyright (C) 1987-2008 Sun Microsystems, Inc. All Rights Reserved.
 * Copyright (C) 2008-2012 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */
/*  This maths library is based on the MP multi-precision floating-point
 *  arithmetic package originally written in FORTRAN by Richard Brent,
 *  Computer Centre, Australian National University in the 1970's.
 *
 *  It has been converted from FORTRAN into C using the freely available
 *  f2c translator, available via netlib on research.att.com.
 *
 *  The subsequently converted C code has then been tidied up, mainly to
 *  remove any dependencies on the libI77 and libF77 support libraries.
 *
 *  FOR A GENERAL DESCRIPTION OF THE PHILOSOPHY AND DESIGN OF MP,
 *  SEE - R. P. BRENT, A FORTRAN MULTIPLE-PRECISION ARITHMETIC
 *  PACKAGE, ACM TRANS. MATH. SOFTWARE 4 (MARCH 1978), 57-70.
 *  SOME ADDITIONAL DETAILS ARE GIVEN IN THE SAME ISSUE, 71-81.
 *  FOR DETAILS OF THE IMPLEMENTATION, CALLING SEQUENCES ETC. SEE
 *  THE MP USERS GUIDE.
 */


#include <glib.h>
#include <glib-object.h>
#include "mpc.h"
#include "mpfr.h"
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>

typedef gint (*BitwiseFunc) (gint v1, gint v2, gpointer user_data);
typedef enum  {
	ANGLE_UNIT_RADIANS,
	ANGLE_UNIT_DEGREES,
	ANGLE_UNIT_GRADIANS
} AngleUnit;


#define TYPE_ANGLE_UNIT (angle_unit_get_type ())

#define TYPE_NUMBER (number_get_type ())
#define NUMBER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NUMBER, Number))
#define NUMBER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NUMBER, NumberClass))
#define IS_NUMBER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NUMBER))
#define IS_NUMBER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NUMBER))
#define NUMBER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NUMBER, NumberClass))

typedef struct _Number Number;
typedef struct _NumberClass NumberClass;
typedef struct _NumberPrivate NumberPrivate;
enum  {
	NUMBER_0_PROPERTY,
	NUMBER_NUM_PROPERTIES
};
static GParamSpec* number_properties[NUMBER_NUM_PROPERTIES];
typedef struct _MPFRRealRef MPFRRealRef;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_SERIALIZER (serializer_get_type ())
#define SERIALIZER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SERIALIZER, Serializer))
#define SERIALIZER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SERIALIZER, SerializerClass))
#define IS_SERIALIZER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SERIALIZER))
#define IS_SERIALIZER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SERIALIZER))
#define SERIALIZER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SERIALIZER, SerializerClass))

typedef struct _Serializer Serializer;
typedef struct _SerializerClass SerializerClass;
typedef enum  {
	DISPLAY_FORMAT_AUTOMATIC,
	DISPLAY_FORMAT_FIXED,
	DISPLAY_FORMAT_SCIENTIFIC,
	DISPLAY_FORMAT_ENGINEERING
} DisplayFormat;


#define TYPE_DISPLAY_FORMAT (display_format_get_type ())

struct _Number {
	GObject parent_instance;
	NumberPrivate * priv;
};

struct _NumberClass {
	GObjectClass parent_class;
};

struct _NumberPrivate {
	__mpc_struct num;
};

struct _MPFRRealRef {
	__mpfr_struct val;
};


static gpointer number_parent_class = NULL;
static mpfr_prec_t number__precision;
static mpfr_prec_t number__precision = (mpfr_prec_t) 1000;
static gchar* number__error;
static gchar* number__error = NULL;

GType angle_unit_get_type (void) G_GNUC_CONST;
GType number_get_type (void) G_GNUC_CONST;
#define NUMBER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_NUMBER, NumberPrivate))
mpfr_prec_t number_get_precision (void);
Number* number_new_integer (gint64 real,
                            gint64 imag);
Number* number_construct_integer (GType object_type,
                                  gint64 real,
                                  gint64 imag);
Number* number_new_unsigned_integer (guint64 real,
                                     guint64 imag);
Number* number_construct_unsigned_integer (GType object_type,
                                           guint64 real,
                                           guint64 imag);
Number* number_new_fraction (gint64 numerator,
                             gint64 denominator);
Number* number_construct_fraction (GType object_type,
                                   gint64 numerator,
                                   gint64 denominator);
Number* number_new_mpreal (__mpfr_struct* real,
                           __mpfr_struct* imag);
Number* number_construct_mpreal (GType object_type,
                                 __mpfr_struct* real,
                                 __mpfr_struct* imag);
Number* number_new_double (gdouble real,
                           gdouble imag);
Number* number_construct_double (GType object_type,
                                 gdouble real,
                                 gdouble imag);
Number* number_new_complex (Number* r,
                            Number* i);
Number* number_construct_complex (GType object_type,
                                  Number* r,
                                  Number* i);
void mpfr_real_ref_free (MPFRRealRef * self);
Number* number_new_polar (Number* r,
                          Number* theta,
                          AngleUnit unit);
Number* number_construct_polar (GType object_type,
                                Number* r,
                                Number* theta,
                                AngleUnit unit);
Number* number_cos (Number* self,
                    AngleUnit unit);
Number* number_sin (Number* self,
                    AngleUnit unit);
Number* number_multiply (Number* self,
                         Number* y);
Number* number_new_eulers (void);
Number* number_construct_eulers (GType object_type);
Number* number_new_i (void);
Number* number_construct_i (GType object_type);
Number* number_new_pi (void);
Number* number_construct_pi (GType object_type);
Number* number_new_random (void);
Number* number_construct_random (GType object_type);
gint64 number_to_integer (Number* self);
guint64 number_to_unsigned_integer (Number* self);
gfloat number_to_float (Number* self);
gdouble number_to_double (Number* self);
gboolean number_is_zero (Number* self);
gboolean number_is_negative (Number* self);
gboolean number_is_integer (Number* self);
gboolean number_is_complex (Number* self);
gboolean number_is_positive_integer (Number* self);
gboolean number_is_natural (Number* self);
void number_check_flags (void);
void number_set_error (const gchar* value);
gboolean number_equals (Number* self,
                        Number* y);
gint number_compare (Number* self,
                     Number* y);
Number* number_sgn (Number* self);
Number* number_invert_sign (Number* self);
Number* number_new (void);
Number* number_construct (GType object_type);
Number* number_abs (Number* self);
Number* number_arg (Number* self,
                    AngleUnit unit);
static void number_mpc_from_radians (__mpc_struct* res,
                              __mpc_struct* op,
                              AngleUnit unit);
Number* number_conjugate (Number* self);
Number* number_real_component (Number* self);
Number* number_imaginary_component (Number* self);
Number* number_integer_component (Number* self);
Number* number_fractional_component (Number* self);
Number* number_fractional_part (Number* self);
Number* number_subtract (Number* self,
                         Number* y);
Number* number_floor (Number* self);
Number* number_ceiling (Number* self);
Number* number_round (Number* self);
Number* number_reciprocal (Number* self);
Number* number_epowy (Number* self);
Number* number_xpowy (Number* self,
                      Number* y);
Number* number_root (Number* self,
                     gint64 n);
Number* number_xpowy_integer (Number* self,
                              gint64 n);
Number* number_sqrt (Number* self);
Number* number_ln (Number* self);
Number* number_logarithm (Number* self,
                          gint64 n);
Number* number_divide (Number* self,
                       Number* y);
Number* number_factorial (Number* self);
Number* number_add (Number* self,
                    Number* y);
Number* number_multiply_integer (Number* self,
                                 gint64 y);
Number* number_divide_integer (Number* self,
                               gint64 y);
Number* number_modulus_divide (Number* self,
                               Number* y);
Number* number_modular_exponentiation (Number* self,
                                       Number* exp,
                                       Number* mod);
static Number* number_copy (Number* self);
static void number_mpc_to_radians (__mpc_struct* res,
                            __mpc_struct* op,
                            AngleUnit unit);
Number* number_tan (Number* self,
                    AngleUnit unit);
static Number* number_to_radians (Number* self,
                           AngleUnit unit);
Number* number_asin (Number* self,
                     AngleUnit unit);
Number* number_acos (Number* self,
                     AngleUnit unit);
Number* number_atan (Number* self,
                     AngleUnit unit);
Number* number_sinh (Number* self);
Number* number_cosh (Number* self);
Number* number_tanh (Number* self);
Number* number_asinh (Number* self);
Number* number_acosh (Number* self);
Number* number_atanh (Number* self);
Number* number_and (Number* self,
                    Number* y);
static Number* number_bitwise (Number* self,
                        Number* y,
                        BitwiseFunc bitwise_operator,
                        gpointer bitwise_operator_target,
                        gint wordlen);
static gint __lambda4_ (Number* self,
                 gint v1,
                 gint v2);
static gint ___lambda4__bitwise_func (gint v1,
                               gint v2,
                               gpointer self);
Number* number_or (Number* self,
                   Number* y);
static gint __lambda5_ (Number* self,
                 gint v1,
                 gint v2);
static gint ___lambda5__bitwise_func (gint v1,
                               gint v2,
                               gpointer self);
Number* number_xor (Number* self,
                    Number* y);
static gint __lambda6_ (Number* self,
                 gint v1,
                 gint v2);
static gint ___lambda6__bitwise_func (gint v1,
                               gint v2,
                               gpointer self);
Number* number_not (Number* self,
                    gint wordlen);
static gint __lambda7_ (Number* self,
                 gint v1,
                 gint v2);
static gint ___lambda7__bitwise_func (gint v1,
                               gint v2,
                               gpointer self);
Number* number_mask (Number* self,
                     Number* x,
                     gint wordlen);
static gchar* number_to_hex_string (Number* self);
Number* mp_set_from_string (const gchar* str,
                            gint default_base);
Number* number_shift (Number* self,
                      gint count);
Number* number_ones_complement (Number* self,
                                gint wordlen);
static gint __lambda8_ (Number* self,
                 gint v1,
                 gint v2);
static gint ___lambda8__bitwise_func (gint v1,
                               gint v2,
                               gpointer self);
Number* number_twos_complement (Number* self,
                                gint wordlen);
GList* number_factorize (Number* self);
GList* number_factorize_uint64 (Number* self,
                                guint64 n);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static gboolean _mpc_equal (const __mpc_struct * s1,
                     const __mpc_struct * s2);
static gint number_hex_to_int (Number* self,
                        gchar digit);
GType serializer_get_type (void) G_GNUC_CONST;
GType display_format_get_type (void) G_GNUC_CONST;
Serializer* serializer_new (DisplayFormat format,
                            gint number_base,
                            gint trailing_digits);
Serializer* serializer_construct (GType object_type,
                                  DisplayFormat format,
                                  gint number_base,
                                  gint trailing_digits);
gchar* serializer_to_string (Serializer* self,
                             Number* x);
void number_set_precision (mpfr_prec_t value);
const gchar* number_get_error (void);
static void number_finalize (GObject * obj);
static void _vala_number_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec);
static void _vala_number_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec);
Number* set_from_sexagesimal (const gchar* str);
gint char_val (gunichar c,
               gint number_base);
gboolean mp_is_overflow (Number* x,
                         gint wordlen);


GType
angle_unit_get_type (void)
{
	static volatile gsize angle_unit_type_id__volatile = 0;
	if (g_once_init_enter (&angle_unit_type_id__volatile)) {
		static const GEnumValue values[] = {{ANGLE_UNIT_RADIANS, "ANGLE_UNIT_RADIANS", "radians"}, {ANGLE_UNIT_DEGREES, "ANGLE_UNIT_DEGREES", "degrees"}, {ANGLE_UNIT_GRADIANS, "ANGLE_UNIT_GRADIANS", "gradians"}, {0, NULL, NULL}};
		GType angle_unit_type_id;
		angle_unit_type_id = g_enum_register_static ("AngleUnit", values);
		g_once_init_leave (&angle_unit_type_id__volatile, angle_unit_type_id);
	}
	return angle_unit_type_id__volatile;
}


Number*
number_construct_integer (GType object_type,
                          gint64 real,
                          gint64 imag)
{
	Number * self = NULL;
#line 52 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 54 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_set_si_si (&self->priv->num, (glong) real, (glong) imag, MPC_RNDNN);
#line 52 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return self;
#line 374 "number.c"
}


Number*
number_new_integer (gint64 real,
                    gint64 imag)
{
#line 52 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return number_construct_integer (TYPE_NUMBER, real, imag);
#line 384 "number.c"
}


Number*
number_construct_unsigned_integer (GType object_type,
                                   guint64 real,
                                   guint64 imag)
{
	Number * self = NULL;
#line 57 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 59 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_set_ui_ui (&self->priv->num, (gulong) real, (gulong) imag, MPC_RNDNN);
#line 57 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return self;
#line 400 "number.c"
}


Number*
number_new_unsigned_integer (guint64 real,
                             guint64 imag)
{
#line 57 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return number_construct_unsigned_integer (TYPE_NUMBER, real, imag);
#line 410 "number.c"
}


Number*
number_construct_fraction (GType object_type,
                           gint64 numerator,
                           gint64 denominator)
{
	Number * self = NULL;
#line 64 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (denominator < ((gint64) 0)) {
#line 66 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		numerator = -numerator;
#line 67 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		denominator = -denominator;
#line 426 "number.c"
	}
#line 70 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	self = (Number*) number_construct_integer (object_type, numerator, (gint64) 0);
#line 71 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (denominator != ((gint64) 1)) {
#line 73 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		mpc_div_ui (&self->priv->num, &self->priv->num, (gulong) ((glong) denominator), MPC_RNDNN);
#line 434 "number.c"
	}
#line 62 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return self;
#line 438 "number.c"
}


Number*
number_new_fraction (gint64 numerator,
                     gint64 denominator)
{
#line 62 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return number_construct_fraction (TYPE_NUMBER, numerator, denominator);
#line 448 "number.c"
}


static gint
mpc_set_mpreal (__mpc_struct *self,
                __mpfr_struct* re,
                __mpfr_struct* im,
                mpc_rnd_t rnd)
{
	gint result = 0;
	__mpfr_struct _tmp1_;
	__mpfr_struct _tmp2_;
#line 59 "/builddir/build/BUILD/gnome-calculator-3.28.2/vapi/mpc.vapi"
	g_return_val_if_fail (re != NULL, 0);
#line 61 "/builddir/build/BUILD/gnome-calculator-3.28.2/vapi/mpc.vapi"
	if (im == NULL) {
#line 465 "number.c"
		__mpfr_struct _tmp0_;
#line 62 "/builddir/build/BUILD/gnome-calculator-3.28.2/vapi/mpc.vapi"
		_tmp0_ = *re;
#line 62 "/builddir/build/BUILD/gnome-calculator-3.28.2/vapi/mpc.vapi"
		result = mpc_set_fr (&(*self), &_tmp0_, rnd);
#line 62 "/builddir/build/BUILD/gnome-calculator-3.28.2/vapi/mpc.vapi"
		return result;
#line 473 "number.c"
	}
#line 64 "/builddir/build/BUILD/gnome-calculator-3.28.2/vapi/mpc.vapi"
	_tmp1_ = *re;
#line 64 "/builddir/build/BUILD/gnome-calculator-3.28.2/vapi/mpc.vapi"
	_tmp2_ = *im;
#line 64 "/builddir/build/BUILD/gnome-calculator-3.28.2/vapi/mpc.vapi"
	result = mpc_set_fr_fr (&(*self), &_tmp1_, &_tmp2_, rnd);
#line 64 "/builddir/build/BUILD/gnome-calculator-3.28.2/vapi/mpc.vapi"
	return result;
#line 483 "number.c"
}


Number*
number_construct_mpreal (GType object_type,
                         __mpfr_struct* real,
                         __mpfr_struct* imag)
{
	Number * self = NULL;
	__mpfr_struct _tmp0_;
#line 78 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (real != NULL, NULL);
#line 78 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 80 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = *real;
#line 80 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_set_mpreal (&self->priv->num, &_tmp0_, imag, MPC_RNDNN);
#line 78 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return self;
#line 504 "number.c"
}


Number*
number_new_mpreal (__mpfr_struct* real,
                   __mpfr_struct* imag)
{
#line 78 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return number_construct_mpreal (TYPE_NUMBER, real, imag);
#line 514 "number.c"
}


Number*
number_construct_double (GType object_type,
                         gdouble real,
                         gdouble imag)
{
	Number * self = NULL;
#line 83 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 85 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_set_d_d (&self->priv->num, real, imag, MPC_RNDNN);
#line 83 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return self;
#line 530 "number.c"
}


Number*
number_new_double (gdouble real,
                   gdouble imag)
{
#line 83 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return number_construct_double (TYPE_NUMBER, real, imag);
#line 540 "number.c"
}


Number*
number_construct_complex (GType object_type,
                          Number* r,
                          Number* i)
{
	Number * self = NULL;
	MPFRRealRef* _tmp0_;
	MPFRRealRef* _tmp1_;
#line 88 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (r != NULL, NULL);
#line 88 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (i != NULL, NULL);
#line 88 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 90 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = mpc_realref (&r->priv->num);
#line 90 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = mpc_realref (&i->priv->num);
#line 90 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_set_mpreal (&self->priv->num, &_tmp0_->val, &_tmp1_->val, MPC_RNDNN);
#line 88 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return self;
#line 566 "number.c"
}


Number*
number_new_complex (Number* r,
                    Number* i)
{
#line 88 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return number_construct_complex (TYPE_NUMBER, r, i);
#line 576 "number.c"
}


Number*
number_construct_polar (GType object_type,
                        Number* r,
                        Number* theta,
                        AngleUnit unit)
{
	Number * self = NULL;
	Number* x = NULL;
	Number* _tmp0_;
	Number* y = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
#line 93 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (r != NULL, NULL);
#line 93 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (theta != NULL, NULL);
#line 95 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_cos (theta, unit);
#line 95 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	x = _tmp0_;
#line 96 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = number_sin (theta, unit);
#line 96 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	y = _tmp1_;
#line 97 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp2_ = number_multiply (x, r);
#line 97 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp3_ = _tmp2_;
#line 97 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp4_ = number_multiply (y, r);
#line 97 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp5_ = _tmp4_;
#line 97 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	self = (Number*) number_construct_complex (object_type, _tmp3_, _tmp5_);
#line 97 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (_tmp5_);
#line 97 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (_tmp3_);
#line 93 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (y);
#line 93 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (x);
#line 93 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return self;
#line 627 "number.c"
}


Number*
number_new_polar (Number* r,
                  Number* theta,
                  AngleUnit unit)
{
#line 93 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return number_construct_polar (TYPE_NUMBER, r, theta, unit);
#line 638 "number.c"
}


Number*
number_construct_eulers (GType object_type)
{
	Number * self = NULL;
	MPFRRealRef* _tmp0_;
	MPFRRealRef* _tmp1_;
	MPFRRealRef* _tmp2_;
	MPFRRealRef* _tmp3_;
#line 100 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 102 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 102 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpfr_set_ui (&_tmp0_->val, (gulong) 1, MPFR_RNDN);
#line 104 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = mpc_realref (&self->priv->num);
#line 104 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp2_ = mpc_realref (&self->priv->num);
#line 104 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpfr_exp (&_tmp1_->val, &_tmp2_->val, MPFR_RNDN);
#line 105 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp3_ = mpc_imagref (&self->priv->num);
#line 105 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpfr_set_zero (&_tmp3_->val, MPFR_RNDN);
#line 100 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return self;
#line 668 "number.c"
}


Number*
number_new_eulers (void)
{
#line 100 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return number_construct_eulers (TYPE_NUMBER);
#line 677 "number.c"
}


Number*
number_construct_i (GType object_type)
{
	Number * self = NULL;
#line 108 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 110 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_set_si_si (&self->priv->num, (glong) 0, (glong) 1, MPC_RNDNN);
#line 108 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return self;
#line 691 "number.c"
}


Number*
number_new_i (void)
{
#line 108 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return number_construct_i (TYPE_NUMBER);
#line 700 "number.c"
}


Number*
number_construct_pi (GType object_type)
{
	Number * self = NULL;
	MPFRRealRef* _tmp0_;
	MPFRRealRef* _tmp1_;
#line 113 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 115 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 115 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpfr_const_pi (&_tmp0_->val, MPFR_RNDN);
#line 116 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = mpc_imagref (&self->priv->num);
#line 116 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 113 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return self;
#line 722 "number.c"
}


Number*
number_new_pi (void)
{
#line 113 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return number_construct_pi (TYPE_NUMBER);
#line 731 "number.c"
}


Number*
number_construct_random (GType object_type)
{
	Number * self = NULL;
#line 122 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	self = (Number*) number_construct_double (object_type, g_random_double (), (gdouble) 0);
#line 120 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return self;
#line 743 "number.c"
}


Number*
number_new_random (void)
{
#line 120 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return number_construct_random (TYPE_NUMBER);
#line 752 "number.c"
}


gint64
number_to_integer (Number* self)
{
	gint64 result = 0LL;
	MPFRRealRef* _tmp0_;
#line 125 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 127 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 127 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = (gint64) mpfr_get_si (&_tmp0_->val, MPFR_RNDN);
#line 127 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 769 "number.c"
}


guint64
number_to_unsigned_integer (Number* self)
{
	guint64 result = 0ULL;
	MPFRRealRef* _tmp0_;
#line 130 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 132 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 132 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = (guint64) mpfr_get_ui (&_tmp0_->val, MPFR_RNDN);
#line 132 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 786 "number.c"
}


gfloat
number_to_float (Number* self)
{
	gfloat result = 0.0F;
	MPFRRealRef* _tmp0_;
#line 135 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 137 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 137 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = mpfr_get_flt (&_tmp0_->val, MPFR_RNDN);
#line 137 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 803 "number.c"
}


gdouble
number_to_double (Number* self)
{
	gdouble result = 0.0;
	MPFRRealRef* _tmp0_;
#line 140 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 142 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 142 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = mpfr_get_d (&_tmp0_->val, MPFR_RNDN);
#line 142 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 820 "number.c"
}


static gboolean
mpc_is_zero (__mpc_struct *self)
{
	gboolean result = FALSE;
	gint res = 0;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
#line 72 "/builddir/build/BUILD/gnome-calculator-3.28.2/vapi/mpc.vapi"
	res = mpc_cmp_si_si (&(*self), (glong) 0, (glong) 0);
#line 72 "/builddir/build/BUILD/gnome-calculator-3.28.2/vapi/mpc.vapi"
	_tmp1_ = res;
#line 72 "/builddir/build/BUILD/gnome-calculator-3.28.2/vapi/mpc.vapi"
	if (MPC_INEX_RE (_tmp1_) == 0) {
#line 837 "number.c"
		gint _tmp2_;
#line 72 "/builddir/build/BUILD/gnome-calculator-3.28.2/vapi/mpc.vapi"
		_tmp2_ = res;
#line 72 "/builddir/build/BUILD/gnome-calculator-3.28.2/vapi/mpc.vapi"
		_tmp0_ = MPC_INEX_IM (_tmp2_) == 0;
#line 843 "number.c"
	} else {
#line 72 "/builddir/build/BUILD/gnome-calculator-3.28.2/vapi/mpc.vapi"
		_tmp0_ = FALSE;
#line 847 "number.c"
	}
#line 72 "/builddir/build/BUILD/gnome-calculator-3.28.2/vapi/mpc.vapi"
	result = _tmp0_;
#line 72 "/builddir/build/BUILD/gnome-calculator-3.28.2/vapi/mpc.vapi"
	return result;
#line 853 "number.c"
}


gboolean
number_is_zero (Number* self)
{
	gboolean result = FALSE;
#line 146 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 148 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = mpc_is_zero (&self->priv->num);
#line 148 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 867 "number.c"
}


gboolean
number_is_negative (Number* self)
{
	gboolean result = FALSE;
	MPFRRealRef* _tmp0_;
#line 152 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 154 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 154 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = mpfr_sgn (&_tmp0_->val) < 0;
#line 154 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 884 "number.c"
}


gboolean
number_is_integer (Number* self)
{
	gboolean result = FALSE;
	MPFRRealRef* _tmp0_;
#line 158 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 160 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (number_is_complex (self)) {
#line 161 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = FALSE;
#line 161 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 901 "number.c"
	}
#line 163 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 163 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = mpfr_integer_p (&_tmp0_->val) != 0;
#line 163 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 909 "number.c"
}


gboolean
number_is_positive_integer (Number* self)
{
	gboolean result = FALSE;
#line 167 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 169 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (number_is_complex (self)) {
#line 170 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = FALSE;
#line 170 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 925 "number.c"
	} else {
		gboolean _tmp0_ = FALSE;
		MPFRRealRef* _tmp1_;
#line 172 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp1_ = mpc_realref (&self->priv->num);
#line 172 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		if (mpfr_sgn (&_tmp1_->val) >= 0) {
#line 172 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp0_ = number_is_integer (self);
#line 935 "number.c"
		} else {
#line 172 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp0_ = FALSE;
#line 939 "number.c"
		}
#line 172 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = _tmp0_;
#line 172 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 945 "number.c"
	}
}


gboolean
number_is_natural (Number* self)
{
	gboolean result = FALSE;
#line 176 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 178 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (number_is_complex (self)) {
#line 179 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = FALSE;
#line 179 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 962 "number.c"
	} else {
		gboolean _tmp0_ = FALSE;
		MPFRRealRef* _tmp1_;
#line 181 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp1_ = mpc_realref (&self->priv->num);
#line 181 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		if (mpfr_sgn (&_tmp1_->val) > 0) {
#line 181 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp0_ = number_is_integer (self);
#line 972 "number.c"
		} else {
#line 181 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp0_ = FALSE;
#line 976 "number.c"
		}
#line 181 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = _tmp0_;
#line 181 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 982 "number.c"
	}
}


gboolean
number_is_complex (Number* self)
{
	gboolean result = FALSE;
	MPFRRealRef* _tmp0_;
#line 185 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 187 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = mpc_imagref (&self->priv->num);
#line 187 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = !mpfr_zero_p (&_tmp0_->val);
#line 187 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 1000 "number.c"
}


void
number_check_flags (void)
{
#line 193 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (mpfr_underflow_p () != 0) {
#line 196 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		number_set_error (_ ("Underflow error"));
#line 1011 "number.c"
	} else {
#line 198 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		if (mpfr_overflow_p () != 0) {
#line 201 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			number_set_error (_ ("Overflow error"));
#line 1017 "number.c"
		}
	}
}


static gboolean
mpc_is_equal (__mpc_struct *self,
              __mpc_struct* c)
{
	gboolean result = FALSE;
	gint res = 0;
	__mpc_struct _tmp0_;
	gboolean _tmp1_ = FALSE;
	gint _tmp2_;
#line 73 "/builddir/build/BUILD/gnome-calculator-3.28.2/vapi/mpc.vapi"
	g_return_val_if_fail (c != NULL, FALSE);
#line 73 "/builddir/build/BUILD/gnome-calculator-3.28.2/vapi/mpc.vapi"
	_tmp0_ = *c;
#line 73 "/builddir/build/BUILD/gnome-calculator-3.28.2/vapi/mpc.vapi"
	res = mpc_cmp (&(*self), &_tmp0_);
#line 73 "/builddir/build/BUILD/gnome-calculator-3.28.2/vapi/mpc.vapi"
	_tmp2_ = res;
#line 73 "/builddir/build/BUILD/gnome-calculator-3.28.2/vapi/mpc.vapi"
	if (MPC_INEX_RE (_tmp2_) == 0) {
#line 1042 "number.c"
		gint _tmp3_;
#line 73 "/builddir/build/BUILD/gnome-calculator-3.28.2/vapi/mpc.vapi"
		_tmp3_ = res;
#line 73 "/builddir/build/BUILD/gnome-calculator-3.28.2/vapi/mpc.vapi"
		_tmp1_ = MPC_INEX_IM (_tmp3_) == 0;
#line 1048 "number.c"
	} else {
#line 73 "/builddir/build/BUILD/gnome-calculator-3.28.2/vapi/mpc.vapi"
		_tmp1_ = FALSE;
#line 1052 "number.c"
	}
#line 73 "/builddir/build/BUILD/gnome-calculator-3.28.2/vapi/mpc.vapi"
	result = _tmp1_;
#line 73 "/builddir/build/BUILD/gnome-calculator-3.28.2/vapi/mpc.vapi"
	return result;
#line 1058 "number.c"
}


gboolean
number_equals (Number* self,
               Number* y)
{
	gboolean result = FALSE;
#line 206 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 206 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (y != NULL, FALSE);
#line 208 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = mpc_is_equal (&self->priv->num, &y->priv->num);
#line 208 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 1075 "number.c"
}


gint
number_compare (Number* self,
                Number* y)
{
	gint result = 0;
	MPFRRealRef* _tmp0_;
	MPFRRealRef* _tmp1_;
#line 216 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 216 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (y != NULL, 0);
#line 218 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 218 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = mpc_realref (&y->priv->num);
#line 218 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = mpfr_cmp (&_tmp0_->val, &_tmp1_->val);
#line 218 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 1098 "number.c"
}


Number*
number_sgn (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	MPFRRealRef* _tmp0_;
	Number* _tmp1_;
#line 222 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 224 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 224 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = number_new_integer ((gint64) mpfr_sgn (&_tmp0_->val), (gint64) 0);
#line 224 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp1_;
#line 225 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 225 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 1121 "number.c"
}


Number*
number_invert_sign (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
#line 229 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 231 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_new ();
#line 231 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp0_;
#line 232 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_neg (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 233 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 233 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 1143 "number.c"
}


Number*
number_abs (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
	MPFRRealRef* _tmp1_;
	MPFRRealRef* _tmp2_;
#line 237 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 239 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_new ();
#line 239 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp0_;
#line 240 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = mpc_imagref (&z->priv->num);
#line 240 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 241 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp2_ = mpc_realref (&z->priv->num);
#line 241 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_abs (&_tmp2_->val, &self->priv->num, MPFR_RNDN);
#line 242 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 242 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 1173 "number.c"
}


Number*
number_arg (Number* self,
            AngleUnit unit)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	MPFRRealRef* _tmp3_;
	Number* _tmp4_;
	MPFRRealRef* _tmp5_;
	Number* _tmp6_;
	Number* _tmp7_;
	gboolean _tmp8_ = FALSE;
#line 246 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 248 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (number_is_zero (self)) {
#line 1195 "number.c"
		Number* _tmp0_;
#line 251 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		number_set_error (_ ("Argument not defined for zero"));
#line 252 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 252 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = _tmp0_;
#line 252 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 1205 "number.c"
	}
#line 254 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = number_new ();
#line 254 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp1_;
#line 255 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp2_ = z;
#line 255 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp3_ = mpc_imagref (&_tmp2_->priv->num);
#line 255 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpfr_set_zero (&_tmp3_->val, MPFR_RNDN);
#line 256 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp4_ = z;
#line 256 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp5_ = mpc_realref (&_tmp4_->priv->num);
#line 256 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_arg (&_tmp5_->val, &self->priv->num, MPFR_RNDN);
#line 257 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp6_ = z;
#line 257 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp7_ = z;
#line 257 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	number_mpc_from_radians (&_tmp6_->priv->num, &_tmp7_->priv->num, unit);
#line 262 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (!number_is_complex (self)) {
#line 262 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp8_ = number_is_negative (self);
#line 1233 "number.c"
	} else {
#line 262 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp8_ = FALSE;
#line 1237 "number.c"
	}
#line 262 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp8_) {
#line 1241 "number.c"
		Number* _tmp9_;
		MPFRRealRef* _tmp10_;
		Number* _tmp11_;
		MPFRRealRef* _tmp12_;
#line 263 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp9_ = z;
#line 263 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp10_ = mpc_realref (&_tmp9_->priv->num);
#line 263 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp11_ = z;
#line 263 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp12_ = mpc_realref (&_tmp11_->priv->num);
#line 263 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		mpfr_abs (&_tmp10_->val, &_tmp12_->val, MPFR_RNDN);
#line 1256 "number.c"
	}
#line 265 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 265 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 1262 "number.c"
}


Number*
number_conjugate (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
#line 269 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 271 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_new ();
#line 271 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp0_;
#line 272 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_conj (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 273 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 273 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 1284 "number.c"
}


Number*
number_real_component (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
	MPFRRealRef* _tmp1_;
#line 277 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 279 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_new ();
#line 279 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp0_;
#line 280 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = mpc_realref (&self->priv->num);
#line 280 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_set_mpreal (&z->priv->num, &_tmp1_->val, NULL, MPC_RNDNN);
#line 281 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 281 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 1309 "number.c"
}


Number*
number_imaginary_component (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
	MPFRRealRef* _tmp1_;
#line 285 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 288 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_new ();
#line 288 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp0_;
#line 289 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = mpc_imagref (&self->priv->num);
#line 289 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_set_mpreal (&z->priv->num, &_tmp1_->val, NULL, MPC_RNDNN);
#line 290 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 290 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 1334 "number.c"
}


Number*
number_integer_component (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
	MPFRRealRef* _tmp1_;
	MPFRRealRef* _tmp2_;
	MPFRRealRef* _tmp3_;
#line 293 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 295 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_new ();
#line 295 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp0_;
#line 296 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = mpc_imagref (&z->priv->num);
#line 296 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 297 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp2_ = mpc_realref (&z->priv->num);
#line 297 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp3_ = mpc_realref (&self->priv->num);
#line 297 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpfr_trunc (&_tmp2_->val, &_tmp3_->val);
#line 298 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 298 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 1367 "number.c"
}


Number*
number_fractional_component (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
	MPFRRealRef* _tmp1_;
	MPFRRealRef* _tmp2_;
	MPFRRealRef* _tmp3_;
#line 302 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 304 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_new ();
#line 304 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp0_;
#line 305 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = mpc_imagref (&z->priv->num);
#line 305 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 306 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp2_ = mpc_realref (&z->priv->num);
#line 306 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp3_ = mpc_realref (&self->priv->num);
#line 306 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpfr_frac (&_tmp2_->val, &_tmp3_->val, MPFR_RNDN);
#line 307 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 307 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 1400 "number.c"
}


Number*
number_fractional_part (Number* self)
{
	Number* result = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
#line 311 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 313 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_floor (self);
#line 313 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = _tmp0_;
#line 313 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp2_ = number_subtract (self, _tmp1_);
#line 313 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp3_ = _tmp2_;
#line 313 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (_tmp1_);
#line 313 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = _tmp3_;
#line 313 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 1428 "number.c"
}


Number*
number_floor (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
	MPFRRealRef* _tmp1_;
	MPFRRealRef* _tmp2_;
	MPFRRealRef* _tmp3_;
#line 317 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 319 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_new ();
#line 319 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp0_;
#line 320 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = mpc_imagref (&z->priv->num);
#line 320 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 321 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp2_ = mpc_realref (&z->priv->num);
#line 321 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp3_ = mpc_realref (&self->priv->num);
#line 321 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpfr_floor (&_tmp2_->val, &_tmp3_->val);
#line 322 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 322 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 1461 "number.c"
}


Number*
number_ceiling (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
	MPFRRealRef* _tmp1_;
	MPFRRealRef* _tmp2_;
	MPFRRealRef* _tmp3_;
#line 326 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 328 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_new ();
#line 328 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp0_;
#line 329 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = mpc_imagref (&z->priv->num);
#line 329 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 330 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp2_ = mpc_realref (&z->priv->num);
#line 330 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp3_ = mpc_realref (&self->priv->num);
#line 330 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpfr_ceil (&_tmp2_->val, &_tmp3_->val);
#line 331 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 331 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 1494 "number.c"
}


Number*
number_round (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
	MPFRRealRef* _tmp1_;
	MPFRRealRef* _tmp2_;
	MPFRRealRef* _tmp3_;
#line 335 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 337 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_new ();
#line 337 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp0_;
#line 338 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = mpc_imagref (&z->priv->num);
#line 338 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 339 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp2_ = mpc_realref (&z->priv->num);
#line 339 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp3_ = mpc_realref (&self->priv->num);
#line 339 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpfr_round (&_tmp2_->val, &_tmp3_->val);
#line 340 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 340 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 1527 "number.c"
}


Number*
number_reciprocal (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
	MPFRRealRef* _tmp1_;
#line 344 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 346 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_new ();
#line 346 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp0_;
#line 347 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_set_si_si (&z->priv->num, (glong) 1, (glong) 0, MPC_RNDNN);
#line 348 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = mpc_realref (&z->priv->num);
#line 348 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_fr_div (&z->priv->num, &_tmp1_->val, &self->priv->num, MPC_RNDNN);
#line 349 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 349 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 1554 "number.c"
}


Number*
number_epowy (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
#line 353 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 355 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_new ();
#line 355 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp0_;
#line 356 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_exp (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 357 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 357 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 1576 "number.c"
}


Number*
number_xpowy (Number* self,
              Number* y)
{
	Number* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	Number* z = NULL;
	Number* _tmp10_;
	Number* _tmp11_;
#line 361 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 361 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 364 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (number_is_zero (self)) {
#line 364 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp0_ = number_is_negative (y);
#line 1600 "number.c"
	} else {
#line 364 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp0_ = FALSE;
#line 1604 "number.c"
	}
#line 364 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp0_) {
#line 1608 "number.c"
		Number* _tmp1_;
#line 367 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		number_set_error (_ ("The power of zero is undefined for a negative exponent"));
#line 368 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp1_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 368 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = _tmp1_;
#line 368 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 1618 "number.c"
	}
#line 372 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (number_is_zero (self)) {
#line 372 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp2_ = number_is_zero (y);
#line 1624 "number.c"
	} else {
#line 372 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp2_ = FALSE;
#line 1628 "number.c"
	}
#line 372 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp2_) {
#line 1632 "number.c"
		Number* _tmp3_;
#line 375 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		number_set_error (_ ("Zero raised to zero is undefined"));
#line 376 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp3_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 376 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = _tmp3_;
#line 376 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 1642 "number.c"
	}
#line 378 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (!number_is_complex (self)) {
#line 378 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp5_ = !number_is_complex (y);
#line 1648 "number.c"
	} else {
#line 378 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp5_ = FALSE;
#line 1652 "number.c"
	}
#line 378 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp5_) {
#line 378 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp4_ = !number_is_integer (y);
#line 1658 "number.c"
	} else {
#line 378 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp4_ = FALSE;
#line 1662 "number.c"
	}
#line 378 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp4_) {
#line 1666 "number.c"
		Number* reciprocal = NULL;
		Number* _tmp6_;
		Number* _tmp7_;
#line 380 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp6_ = number_reciprocal (y);
#line 380 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		reciprocal = _tmp6_;
#line 381 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp7_ = reciprocal;
#line 381 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		if (number_is_integer (_tmp7_)) {
#line 1678 "number.c"
			Number* _tmp8_;
			Number* _tmp9_;
#line 382 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp8_ = reciprocal;
#line 382 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp9_ = number_root (self, number_to_integer (_tmp8_));
#line 382 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			result = _tmp9_;
#line 382 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_g_object_unref0 (reciprocal);
#line 382 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			return result;
#line 1691 "number.c"
		}
#line 378 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (reciprocal);
#line 1695 "number.c"
	}
#line 385 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp10_ = number_new ();
#line 385 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp10_;
#line 386 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp11_ = z;
#line 386 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_pow (&_tmp11_->priv->num, &self->priv->num, &y->priv->num, MPC_RNDNN);
#line 387 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 387 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 1709 "number.c"
}


Number*
number_xpowy_integer (Number* self,
                      gint64 n)
{
	Number* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp2_ = FALSE;
	Number* z = NULL;
	Number* _tmp4_;
	Number* _tmp5_;
#line 391 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 394 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (number_is_zero (self)) {
#line 394 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp0_ = n < ((gint64) 0);
#line 1729 "number.c"
	} else {
#line 394 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp0_ = FALSE;
#line 1733 "number.c"
	}
#line 394 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp0_) {
#line 1737 "number.c"
		Number* _tmp1_;
#line 397 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		number_set_error (_ ("The power of zero is undefined for a negative exponent"));
#line 398 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp1_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 398 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = _tmp1_;
#line 398 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 1747 "number.c"
	}
#line 402 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (number_is_zero (self)) {
#line 402 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp2_ = n == ((gint64) 0);
#line 1753 "number.c"
	} else {
#line 402 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp2_ = FALSE;
#line 1757 "number.c"
	}
#line 402 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp2_) {
#line 1761 "number.c"
		Number* _tmp3_;
#line 405 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		number_set_error (_ ("Zero raised to zero is undefined"));
#line 406 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp3_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 406 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = _tmp3_;
#line 406 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 1771 "number.c"
	}
#line 408 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp4_ = number_new ();
#line 408 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp4_;
#line 409 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp5_ = z;
#line 409 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_pow_si (&_tmp5_->priv->num, &self->priv->num, (glong) n, MPC_RNDNN);
#line 410 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 410 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 1785 "number.c"
}


Number*
number_root (Number* self,
             gint64 n)
{
	Number* result = NULL;
	guint64 p = 0ULL;
	Number* z = NULL;
	Number* _tmp0_;
	gboolean _tmp4_ = FALSE;
#line 414 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 417 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_new ();
#line 417 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp0_;
#line 418 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (n < ((gint64) 0)) {
#line 1806 "number.c"
		Number* _tmp1_;
#line 420 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp1_ = z;
#line 420 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		mpc_ui_div (&_tmp1_->priv->num, (gulong) 1, &self->priv->num, MPC_RNDNN);
#line 421 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		if (n == G_MININT64) {
#line 422 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			p = ((guint64) G_MAXINT64) + 1;
#line 1816 "number.c"
		} else {
#line 424 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			p = (guint64) (-n);
#line 1820 "number.c"
		}
	} else {
#line 425 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		if (n > ((gint64) 0)) {
#line 1825 "number.c"
			Number* _tmp2_;
#line 426 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp2_ = z;
#line 426 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			mpc_set (&_tmp2_->priv->num, &self->priv->num, MPC_RNDNN);
#line 427 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			p = (guint64) n;
#line 1833 "number.c"
		} else {
			Number* _tmp3_;
#line 429 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			number_set_error (_ ("The zeroth root of a number is undefined"));
#line 430 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp3_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 430 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			result = _tmp3_;
#line 430 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_g_object_unref0 (z);
#line 430 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			return result;
#line 1846 "number.c"
		}
	}
#line 433 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (!number_is_complex (self)) {
#line 1851 "number.c"
		gboolean _tmp5_ = FALSE;
#line 433 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		if (!number_is_negative (self)) {
#line 433 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp5_ = TRUE;
#line 1857 "number.c"
		} else {
			guint64 _tmp6_;
#line 433 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp6_ = p;
#line 433 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp5_ = (_tmp6_ & 1) == ((guint64) 1);
#line 1864 "number.c"
		}
#line 433 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp4_ = _tmp5_;
#line 1868 "number.c"
	} else {
#line 433 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp4_ = FALSE;
#line 1872 "number.c"
	}
#line 433 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp4_) {
#line 1876 "number.c"
		Number* _tmp7_;
		MPFRRealRef* _tmp8_;
		Number* _tmp9_;
		MPFRRealRef* _tmp10_;
		guint64 _tmp11_;
		Number* _tmp12_;
		MPFRRealRef* _tmp13_;
#line 435 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp7_ = z;
#line 435 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp8_ = mpc_realref (&_tmp7_->priv->num);
#line 435 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp9_ = z;
#line 435 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp10_ = mpc_realref (&_tmp9_->priv->num);
#line 435 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp11_ = p;
#line 435 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		mpfr_root (&_tmp8_->val, &_tmp10_->val, (gulong) _tmp11_, MPFR_RNDN);
#line 436 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp12_ = z;
#line 436 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp13_ = mpc_imagref (&_tmp12_->priv->num);
#line 436 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		mpfr_set_zero (&_tmp13_->val, MPFR_RNDN);
#line 1902 "number.c"
	} else {
		__mpfr_struct tmp = {0};
		mpfr_prec_t _tmp14_;
		mpfr_prec_t _tmp15_;
		guint64 _tmp16_;
		Number* _tmp17_;
		Number* _tmp18_;
#line 438 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp14_ = number_get_precision ();
#line 438 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp15_ = _tmp14_;
#line 438 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		mpfr_init2 (&tmp, _tmp15_);
#line 439 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp16_ = p;
#line 439 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		mpfr_set_ui (&tmp, (gulong) _tmp16_, MPFR_RNDN);
#line 440 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		mpfr_ui_div (&tmp, (gulong) 1, &tmp, MPFR_RNDN);
#line 441 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp17_ = z;
#line 441 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp18_ = z;
#line 441 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		mpc_pow_fr (&_tmp17_->priv->num, &_tmp18_->priv->num, &tmp, MPC_RNDNN);
#line 433 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		mpfr_clear (&tmp);
#line 1930 "number.c"
	}
#line 443 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 443 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 1936 "number.c"
}


Number*
number_sqrt (Number* self)
{
	Number* result = NULL;
	Number* _tmp0_;
#line 447 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 449 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_root (self, (gint64) 2);
#line 449 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = _tmp0_;
#line 449 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 1953 "number.c"
}


Number*
number_ln (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	gboolean _tmp3_ = FALSE;
#line 453 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 456 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (number_is_zero (self)) {
#line 1969 "number.c"
		Number* _tmp0_;
#line 459 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		number_set_error (_ ("Logarithm of zero is undefined"));
#line 460 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 460 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = _tmp0_;
#line 460 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 1979 "number.c"
	}
#line 472 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = number_new ();
#line 472 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp1_;
#line 473 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp2_ = z;
#line 473 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_log (&_tmp2_->priv->num, &self->priv->num, MPC_RNDNN);
#line 477 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (!number_is_complex (self)) {
#line 477 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp3_ = number_is_negative (self);
#line 1993 "number.c"
	} else {
#line 477 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp3_ = FALSE;
#line 1997 "number.c"
	}
#line 477 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp3_) {
#line 2001 "number.c"
		Number* _tmp4_;
		MPFRRealRef* _tmp5_;
		Number* _tmp6_;
		MPFRRealRef* _tmp7_;
#line 478 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp4_ = z;
#line 478 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp5_ = mpc_imagref (&_tmp4_->priv->num);
#line 478 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp6_ = z;
#line 478 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp7_ = mpc_imagref (&_tmp6_->priv->num);
#line 478 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		mpfr_abs (&_tmp5_->val, &_tmp7_->val, MPFR_RNDN);
#line 2016 "number.c"
	}
#line 480 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 480 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 2022 "number.c"
}


Number*
number_logarithm (Number* self,
                  gint64 n)
{
	Number* result = NULL;
	Number* t1 = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* _tmp6_;
	Number* _tmp7_;
	Number* _tmp8_;
#line 484 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 487 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (number_is_zero (self)) {
#line 2044 "number.c"
		Number* _tmp0_;
#line 490 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		number_set_error (_ ("Logarithm of zero is undefined"));
#line 491 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 491 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = _tmp0_;
#line 491 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 2054 "number.c"
	}
#line 495 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = number_new_integer (n, (gint64) 0);
#line 495 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	t1 = _tmp1_;
#line 496 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp2_ = number_ln (self);
#line 496 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp3_ = _tmp2_;
#line 496 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp4_ = t1;
#line 496 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp5_ = number_ln (_tmp4_);
#line 496 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp6_ = _tmp5_;
#line 496 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp7_ = number_divide (_tmp3_, _tmp6_);
#line 496 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp8_ = _tmp7_;
#line 496 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (_tmp6_);
#line 496 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (_tmp3_);
#line 496 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = _tmp8_;
#line 496 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (t1);
#line 496 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 2084 "number.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 527 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return self ? g_object_ref (self) : NULL;
#line 2093 "number.c"
}


Number*
number_factorial (Number* self)
{
	Number* result = NULL;
	gint64 value = 0LL;
	Number* z = NULL;
	Number* _tmp12_;
#line 500 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 503 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (number_is_zero (self)) {
#line 2108 "number.c"
		Number* _tmp0_;
#line 504 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 504 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = _tmp0_;
#line 504 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 2116 "number.c"
	}
#line 505 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (!number_is_natural (self)) {
#line 2120 "number.c"
		gboolean _tmp1_ = FALSE;
		Number* tmp = NULL;
		Number* _tmp3_;
		Number* _tmp4_;
		Number* _tmp5_;
		Number* _tmp6_;
		__mpfr_struct tmp2 = {0};
		mpfr_prec_t _tmp7_;
		mpfr_prec_t _tmp8_;
		Number* _tmp9_;
		MPFRRealRef* _tmp10_;
		Number* _tmp11_;
#line 509 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		if (number_is_negative (self)) {
#line 509 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp1_ = TRUE;
#line 2137 "number.c"
		} else {
#line 509 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp1_ = number_is_complex (self);
#line 2141 "number.c"
		}
#line 509 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		if (_tmp1_) {
#line 2145 "number.c"
			Number* _tmp2_;
#line 512 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			number_set_error (_ ("Factorial is only defined for non-negative real numbers"));
#line 513 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp2_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 513 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			result = _tmp2_;
#line 513 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			return result;
#line 2155 "number.c"
		}
#line 516 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp3_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 516 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp4_ = _tmp3_;
#line 516 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp5_ = number_add (self, _tmp4_);
#line 516 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp6_ = _tmp5_;
#line 516 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (_tmp4_);
#line 516 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		tmp = _tmp6_;
#line 517 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp7_ = number_get_precision ();
#line 517 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp8_ = _tmp7_;
#line 517 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		mpfr_init2 (&tmp2, _tmp8_);
#line 520 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp9_ = tmp;
#line 520 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp10_ = mpc_realref (&_tmp9_->priv->num);
#line 520 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		mpfr_gamma (&tmp2, &_tmp10_->val, MPFR_RNDN);
#line 522 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp11_ = number_new_mpreal (&tmp2, NULL);
#line 522 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = _tmp11_;
#line 522 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		mpfr_clear (&tmp2);
#line 522 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (tmp);
#line 522 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 2191 "number.c"
	}
#line 526 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	value = number_to_integer (self);
#line 527 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp12_ = _g_object_ref0 (self);
#line 527 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp12_;
#line 2199 "number.c"
	{
		gint i = 0;
#line 528 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		i = 2;
#line 2204 "number.c"
		{
			gboolean _tmp13_ = FALSE;
#line 528 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp13_ = TRUE;
#line 528 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			while (TRUE) {
#line 2211 "number.c"
				gint _tmp15_;
				gint64 _tmp16_;
				Number* _tmp17_;
				gint _tmp18_;
				Number* _tmp19_;
#line 528 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				if (!_tmp13_) {
#line 2219 "number.c"
					gint _tmp14_;
#line 528 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					_tmp14_ = i;
#line 528 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					i = _tmp14_ + 1;
#line 2225 "number.c"
				}
#line 528 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				_tmp13_ = FALSE;
#line 528 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				_tmp15_ = i;
#line 528 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				_tmp16_ = value;
#line 528 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				if (!(((gint64) _tmp15_) < _tmp16_)) {
#line 528 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					break;
#line 2237 "number.c"
				}
#line 529 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				_tmp17_ = z;
#line 529 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				_tmp18_ = i;
#line 529 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				_tmp19_ = number_multiply_integer (_tmp17_, (gint64) _tmp18_);
#line 529 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				_g_object_unref0 (z);
#line 529 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				z = _tmp19_;
#line 2249 "number.c"
			}
		}
	}
#line 531 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 531 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 2257 "number.c"
}


Number*
number_add (Number* self,
            Number* y)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
#line 535 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 535 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 537 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_new ();
#line 537 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp0_;
#line 538 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_add (&z->priv->num, &self->priv->num, &y->priv->num, MPC_RNDNN);
#line 539 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 539 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 2282 "number.c"
}


Number*
number_subtract (Number* self,
                 Number* y)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
#line 543 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 543 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 545 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_new ();
#line 545 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp0_;
#line 546 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_sub (&z->priv->num, &self->priv->num, &y->priv->num, MPC_RNDNN);
#line 547 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 547 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 2307 "number.c"
}


Number*
number_multiply (Number* self,
                 Number* y)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
#line 551 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 551 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 553 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_new ();
#line 553 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp0_;
#line 554 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_mul (&z->priv->num, &self->priv->num, &y->priv->num, MPC_RNDNN);
#line 555 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 555 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 2332 "number.c"
}


Number*
number_multiply_integer (Number* self,
                         gint64 y)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
#line 559 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 561 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_new ();
#line 561 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp0_;
#line 562 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_mul_si (&z->priv->num, &self->priv->num, (glong) y, MPC_RNDNN);
#line 563 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 563 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 2355 "number.c"
}


Number*
number_divide (Number* self,
               Number* y)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
#line 567 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 567 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 569 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (number_is_zero (y)) {
#line 2373 "number.c"
		Number* _tmp0_;
#line 572 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		number_set_error (_ ("Division by zero is undefined"));
#line 573 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 573 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = _tmp0_;
#line 573 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 2383 "number.c"
	}
#line 576 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = number_new ();
#line 576 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp1_;
#line 577 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp2_ = z;
#line 577 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_div (&_tmp2_->priv->num, &self->priv->num, &y->priv->num, MPC_RNDNN);
#line 578 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 578 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 2397 "number.c"
}


Number*
number_divide_integer (Number* self,
                       gint64 y)
{
	Number* result = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
#line 582 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 584 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_new_integer (y, (gint64) 0);
#line 584 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = _tmp0_;
#line 584 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp2_ = number_divide (self, _tmp1_);
#line 584 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp3_ = _tmp2_;
#line 584 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (_tmp1_);
#line 584 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = _tmp3_;
#line 584 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 2426 "number.c"
}


Number*
number_modulus_divide (Number* self,
                       Number* y)
{
	Number* result = NULL;
	gboolean _tmp0_ = FALSE;
	Number* t1 = NULL;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* t2 = NULL;
	Number* _tmp6_;
	Number* _tmp7_;
	Number* z = NULL;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* _tmp10_;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	Number* _tmp13_;
#line 588 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 588 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 590 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (!number_is_integer (self)) {
#line 590 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp0_ = TRUE;
#line 2459 "number.c"
	} else {
#line 590 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp0_ = !number_is_integer (y);
#line 2463 "number.c"
	}
#line 590 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp0_) {
#line 2467 "number.c"
		Number* _tmp1_;
#line 593 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		number_set_error (_ ("Modulus division is only defined for integers"));
#line 594 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp1_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 594 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = _tmp1_;
#line 594 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 2477 "number.c"
	}
#line 597 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp2_ = number_divide (self, y);
#line 597 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp3_ = _tmp2_;
#line 597 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp4_ = number_floor (_tmp3_);
#line 597 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp5_ = _tmp4_;
#line 597 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (_tmp3_);
#line 597 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	t1 = _tmp5_;
#line 598 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp6_ = t1;
#line 598 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp7_ = number_multiply (_tmp6_, y);
#line 598 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	t2 = _tmp7_;
#line 599 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp8_ = t2;
#line 599 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp9_ = number_subtract (self, _tmp8_);
#line 599 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp9_;
#line 601 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp10_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 601 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (t1);
#line 601 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	t1 = _tmp10_;
#line 602 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp13_ = t1;
#line 602 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (number_compare (y, _tmp13_) < 0) {
#line 2513 "number.c"
		Number* _tmp14_;
		Number* _tmp15_;
#line 602 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp14_ = z;
#line 602 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp15_ = t1;
#line 602 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp12_ = number_compare (_tmp14_, _tmp15_) > 0;
#line 2522 "number.c"
	} else {
#line 602 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp12_ = FALSE;
#line 2526 "number.c"
	}
#line 602 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp12_) {
#line 602 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp11_ = TRUE;
#line 2532 "number.c"
	} else {
		gboolean _tmp16_ = FALSE;
		Number* _tmp17_;
#line 602 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp17_ = t1;
#line 602 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		if (number_compare (y, _tmp17_) > 0) {
#line 2540 "number.c"
			Number* _tmp18_;
			Number* _tmp19_;
#line 602 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp18_ = z;
#line 602 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp19_ = t1;
#line 602 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp16_ = number_compare (_tmp18_, _tmp19_) < 0;
#line 2549 "number.c"
		} else {
#line 602 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp16_ = FALSE;
#line 2553 "number.c"
		}
#line 602 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp11_ = _tmp16_;
#line 2557 "number.c"
	}
#line 602 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp11_) {
#line 2561 "number.c"
		Number* _tmp20_;
		Number* _tmp21_;
#line 603 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp20_ = z;
#line 603 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp21_ = number_add (_tmp20_, y);
#line 603 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (z);
#line 603 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		z = _tmp21_;
#line 2572 "number.c"
	}
#line 605 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 605 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (t2);
#line 605 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (t1);
#line 605 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 2582 "number.c"
}


Number*
number_modular_exponentiation (Number* self,
                               Number* exp,
                               Number* mod)
{
	Number* result = NULL;
	Number* base_value = NULL;
	Number* _tmp0_;
	Number* exp_value = NULL;
	Number* _tmp3_;
	Number* ans = NULL;
	Number* _tmp4_;
	Number* two = NULL;
	Number* _tmp5_;
	Number* _tmp27_;
	Number* _tmp28_;
#line 609 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 609 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (exp != NULL, NULL);
#line 609 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (mod != NULL, NULL);
#line 611 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_copy (self);
#line 611 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	base_value = _tmp0_;
#line 612 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (number_is_negative (exp)) {
#line 2614 "number.c"
		Number* _tmp1_;
		Number* _tmp2_;
#line 613 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp1_ = base_value;
#line 613 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp2_ = number_reciprocal (_tmp1_);
#line 613 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (base_value);
#line 613 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		base_value = _tmp2_;
#line 2625 "number.c"
	}
#line 614 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp3_ = number_abs (exp);
#line 614 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	exp_value = _tmp3_;
#line 615 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp4_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 615 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	ans = _tmp4_;
#line 616 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp5_ = number_new_integer ((gint64) 2, (gint64) 0);
#line 616 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	two = _tmp5_;
#line 617 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	while (TRUE) {
#line 2641 "number.c"
		Number* _tmp6_;
		gboolean is_even = FALSE;
		Number* _tmp7_;
		Number* _tmp8_;
		Number* _tmp9_;
		Number* _tmp10_;
		gboolean _tmp11_;
		gboolean _tmp12_;
		Number* _tmp18_;
		Number* _tmp19_;
		Number* _tmp20_;
		Number* _tmp21_;
		Number* _tmp22_;
		Number* _tmp23_;
		Number* _tmp24_;
		Number* _tmp25_;
		Number* _tmp26_;
#line 617 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp6_ = exp_value;
#line 617 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		if (!(!number_is_zero (_tmp6_))) {
#line 617 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			break;
#line 2665 "number.c"
		}
#line 619 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp7_ = exp_value;
#line 619 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp8_ = two;
#line 619 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp9_ = number_modulus_divide (_tmp7_, _tmp8_);
#line 619 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp10_ = _tmp9_;
#line 619 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp11_ = number_is_zero (_tmp10_);
#line 619 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (_tmp10_);
#line 619 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		is_even = _tmp11_;
#line 620 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp12_ = is_even;
#line 620 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		if (!_tmp12_) {
#line 2685 "number.c"
			Number* _tmp13_;
			Number* _tmp14_;
			Number* _tmp15_;
			Number* _tmp16_;
			Number* _tmp17_;
#line 622 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp13_ = ans;
#line 622 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp14_ = base_value;
#line 622 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp15_ = number_multiply (_tmp13_, _tmp14_);
#line 622 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_g_object_unref0 (ans);
#line 622 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			ans = _tmp15_;
#line 623 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp16_ = ans;
#line 623 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp17_ = number_modulus_divide (_tmp16_, mod);
#line 623 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_g_object_unref0 (ans);
#line 623 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			ans = _tmp17_;
#line 2709 "number.c"
		}
#line 625 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp18_ = base_value;
#line 625 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp19_ = base_value;
#line 625 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp20_ = number_multiply (_tmp18_, _tmp19_);
#line 625 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (base_value);
#line 625 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		base_value = _tmp20_;
#line 626 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp21_ = base_value;
#line 626 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp22_ = number_modulus_divide (_tmp21_, mod);
#line 626 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (base_value);
#line 626 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		base_value = _tmp22_;
#line 627 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp23_ = exp_value;
#line 627 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp24_ = number_divide_integer (_tmp23_, (gint64) 2);
#line 627 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp25_ = _tmp24_;
#line 627 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp26_ = number_floor (_tmp25_);
#line 627 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (exp_value);
#line 627 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		exp_value = _tmp26_;
#line 627 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (_tmp25_);
#line 2743 "number.c"
	}
#line 629 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp27_ = ans;
#line 629 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp28_ = number_modulus_divide (_tmp27_, mod);
#line 629 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = _tmp28_;
#line 629 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (two);
#line 629 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (ans);
#line 629 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (exp_value);
#line 629 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (base_value);
#line 629 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 2761 "number.c"
}


Number*
number_sin (Number* self,
            AngleUnit unit)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
	Number* _tmp3_;
	Number* _tmp4_;
#line 633 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 635 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_new ();
#line 635 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp0_;
#line 636 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (number_is_complex (self)) {
#line 2782 "number.c"
		Number* _tmp1_;
#line 637 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp1_ = z;
#line 637 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		mpc_set (&_tmp1_->priv->num, &self->priv->num, MPC_RNDNN);
#line 2788 "number.c"
	} else {
		Number* _tmp2_;
#line 639 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp2_ = z;
#line 639 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		number_mpc_to_radians (&_tmp2_->priv->num, &self->priv->num, unit);
#line 2795 "number.c"
	}
#line 640 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp3_ = z;
#line 640 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp4_ = z;
#line 640 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_sin (&_tmp3_->priv->num, &_tmp4_->priv->num, MPC_RNDNN);
#line 641 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 641 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 2807 "number.c"
}


Number*
number_cos (Number* self,
            AngleUnit unit)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
	Number* _tmp3_;
	Number* _tmp4_;
#line 645 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 647 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_new ();
#line 647 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp0_;
#line 648 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (number_is_complex (self)) {
#line 2828 "number.c"
		Number* _tmp1_;
#line 649 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp1_ = z;
#line 649 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		mpc_set (&_tmp1_->priv->num, &self->priv->num, MPC_RNDNN);
#line 2834 "number.c"
	} else {
		Number* _tmp2_;
#line 651 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp2_ = z;
#line 651 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		number_mpc_to_radians (&_tmp2_->priv->num, &self->priv->num, unit);
#line 2841 "number.c"
	}
#line 652 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp3_ = z;
#line 652 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp4_ = z;
#line 652 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_cos (&_tmp3_->priv->num, &_tmp4_->priv->num, MPC_RNDNN);
#line 653 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 653 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 2853 "number.c"
}


Number*
number_tan (Number* self,
            AngleUnit unit)
{
	Number* result = NULL;
	Number* x_radians = NULL;
	Number* _tmp0_;
	Number* check = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* _tmp6_;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* _tmp10_;
	Number* _tmp11_;
	Number* _tmp12_;
	Number* z = NULL;
	Number* _tmp14_;
	Number* _tmp17_;
	Number* _tmp18_;
#line 657 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 660 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_to_radians (self, unit);
#line 660 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	x_radians = _tmp0_;
#line 661 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = x_radians;
#line 661 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp2_ = number_new_pi ();
#line 661 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp3_ = _tmp2_;
#line 661 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp4_ = number_divide_integer (_tmp3_, (gint64) 2);
#line 661 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp5_ = _tmp4_;
#line 661 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp6_ = number_subtract (_tmp1_, _tmp5_);
#line 661 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp7_ = _tmp6_;
#line 661 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp8_ = number_new_pi ();
#line 661 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp9_ = _tmp8_;
#line 661 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp10_ = number_divide (_tmp7_, _tmp9_);
#line 661 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp11_ = _tmp10_;
#line 661 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (_tmp9_);
#line 661 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (_tmp7_);
#line 661 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (_tmp5_);
#line 661 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (_tmp3_);
#line 661 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	check = _tmp11_;
#line 663 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp12_ = check;
#line 663 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (number_is_integer (_tmp12_)) {
#line 2923 "number.c"
		Number* _tmp13_;
#line 666 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		number_set_error (_ ("Tangent is undefined for angles that are multiples of π (180°) from π∕" \
"2 (90°)"));
#line 667 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp13_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 667 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = _tmp13_;
#line 667 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (check);
#line 667 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (x_radians);
#line 667 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 2937 "number.c"
	}
#line 670 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp14_ = number_new ();
#line 670 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp14_;
#line 671 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (number_is_complex (self)) {
#line 2945 "number.c"
		Number* _tmp15_;
#line 672 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp15_ = z;
#line 672 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		mpc_set (&_tmp15_->priv->num, &self->priv->num, MPC_RNDNN);
#line 2951 "number.c"
	} else {
		Number* _tmp16_;
#line 674 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp16_ = z;
#line 674 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		number_mpc_to_radians (&_tmp16_->priv->num, &self->priv->num, unit);
#line 2958 "number.c"
	}
#line 675 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp17_ = z;
#line 675 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp18_ = z;
#line 675 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_tan (&_tmp17_->priv->num, &_tmp18_->priv->num, MPC_RNDNN);
#line 676 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 676 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (check);
#line 676 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (x_radians);
#line 676 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 2974 "number.c"
}


Number*
number_asin (Number* self,
             AngleUnit unit)
{
	Number* result = NULL;
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
	Number* _tmp2_;
	gboolean _tmp3_;
	Number* z = NULL;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
#line 680 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 682 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 682 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp2_ = _tmp1_;
#line 682 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp3_ = number_compare (self, _tmp2_) > 0;
#line 682 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (_tmp2_);
#line 682 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp3_) {
#line 682 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp0_ = TRUE;
#line 3005 "number.c"
	} else {
		Number* _tmp4_;
		Number* _tmp5_;
#line 682 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp4_ = number_new_integer ((gint64) -1, (gint64) 0);
#line 682 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp5_ = _tmp4_;
#line 682 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp0_ = number_compare (self, _tmp5_) < 0;
#line 682 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (_tmp5_);
#line 3017 "number.c"
	}
#line 682 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp0_) {
#line 3021 "number.c"
		Number* _tmp6_;
#line 685 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		number_set_error (_ ("Inverse sine is undefined for values outside [-1, 1]"));
#line 686 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp6_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 686 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = _tmp6_;
#line 686 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 3031 "number.c"
	}
#line 689 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp7_ = number_new ();
#line 689 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp7_;
#line 690 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp8_ = z;
#line 690 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_asin (&_tmp8_->priv->num, &self->priv->num, MPC_RNDNN);
#line 691 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp9_ = z;
#line 691 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (!number_is_complex (_tmp9_)) {
#line 3045 "number.c"
		Number* _tmp10_;
		Number* _tmp11_;
#line 692 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp10_ = z;
#line 692 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp11_ = z;
#line 692 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		number_mpc_from_radians (&_tmp10_->priv->num, &_tmp11_->priv->num, unit);
#line 3054 "number.c"
	}
#line 693 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 693 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 3060 "number.c"
}


Number*
number_acos (Number* self,
             AngleUnit unit)
{
	Number* result = NULL;
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
	Number* _tmp2_;
	gboolean _tmp3_;
	Number* z = NULL;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
#line 697 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 699 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 699 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp2_ = _tmp1_;
#line 699 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp3_ = number_compare (self, _tmp2_) > 0;
#line 699 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (_tmp2_);
#line 699 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp3_) {
#line 699 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp0_ = TRUE;
#line 3091 "number.c"
	} else {
		Number* _tmp4_;
		Number* _tmp5_;
#line 699 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp4_ = number_new_integer ((gint64) -1, (gint64) 0);
#line 699 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp5_ = _tmp4_;
#line 699 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp0_ = number_compare (self, _tmp5_) < 0;
#line 699 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (_tmp5_);
#line 3103 "number.c"
	}
#line 699 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp0_) {
#line 3107 "number.c"
		Number* _tmp6_;
#line 702 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		number_set_error (_ ("Inverse cosine is undefined for values outside [-1, 1]"));
#line 703 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp6_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 703 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = _tmp6_;
#line 703 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 3117 "number.c"
	}
#line 706 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp7_ = number_new ();
#line 706 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp7_;
#line 707 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp8_ = z;
#line 707 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_acos (&_tmp8_->priv->num, &self->priv->num, MPC_RNDNN);
#line 708 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp9_ = z;
#line 708 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (!number_is_complex (_tmp9_)) {
#line 3131 "number.c"
		Number* _tmp10_;
		Number* _tmp11_;
#line 709 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp10_ = z;
#line 709 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp11_ = z;
#line 709 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		number_mpc_from_radians (&_tmp10_->priv->num, &_tmp11_->priv->num, unit);
#line 3140 "number.c"
	}
#line 710 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 710 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 3146 "number.c"
}


Number*
number_atan (Number* self,
             AngleUnit unit)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
#line 714 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 716 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_new ();
#line 716 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp0_;
#line 717 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = z;
#line 717 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_atan (&_tmp1_->priv->num, &self->priv->num, MPC_RNDNN);
#line 718 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp2_ = z;
#line 718 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (!number_is_complex (_tmp2_)) {
#line 3173 "number.c"
		Number* _tmp3_;
		Number* _tmp4_;
#line 719 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp3_ = z;
#line 719 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp4_ = z;
#line 719 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		number_mpc_from_radians (&_tmp3_->priv->num, &_tmp4_->priv->num, unit);
#line 3182 "number.c"
	}
#line 720 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 720 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 3188 "number.c"
}


Number*
number_sinh (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
#line 724 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 726 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_new ();
#line 726 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp0_;
#line 727 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_sinh (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 728 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 728 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 3210 "number.c"
}


Number*
number_cosh (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
#line 732 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 734 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_new ();
#line 734 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp0_;
#line 735 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_cosh (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 736 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 736 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 3232 "number.c"
}


Number*
number_tanh (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
#line 740 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 742 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_new ();
#line 742 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp0_;
#line 743 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_tanh (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 744 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 744 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 3254 "number.c"
}


Number*
number_asinh (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
#line 748 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 750 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_new ();
#line 750 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp0_;
#line 751 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_asinh (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 752 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 752 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 3276 "number.c"
}


Number*
number_acosh (Number* self)
{
	Number* result = NULL;
	Number* t = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* z = NULL;
	Number* _tmp3_;
	Number* _tmp4_;
#line 756 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 759 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 759 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	t = _tmp0_;
#line 760 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = t;
#line 760 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (number_compare (self, _tmp1_) < 0) {
#line 3300 "number.c"
		Number* _tmp2_;
#line 763 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		number_set_error (_ ("Inverse hyperbolic cosine is undefined for values less than one"));
#line 764 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp2_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 764 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = _tmp2_;
#line 764 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (t);
#line 764 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 3312 "number.c"
	}
#line 767 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp3_ = number_new ();
#line 767 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp3_;
#line 768 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp4_ = z;
#line 768 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_acosh (&_tmp4_->priv->num, &self->priv->num, MPC_RNDNN);
#line 769 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 769 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (t);
#line 769 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 3328 "number.c"
}


Number*
number_atanh (Number* self)
{
	Number* result = NULL;
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
	Number* _tmp2_;
	gboolean _tmp3_;
	Number* z = NULL;
	Number* _tmp7_;
	Number* _tmp8_;
#line 773 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 776 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 776 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp2_ = _tmp1_;
#line 776 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp3_ = number_compare (self, _tmp2_) >= 0;
#line 776 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (_tmp2_);
#line 776 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp3_) {
#line 776 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp0_ = TRUE;
#line 3357 "number.c"
	} else {
		Number* _tmp4_;
		Number* _tmp5_;
#line 776 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp4_ = number_new_integer ((gint64) -1, (gint64) 0);
#line 776 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp5_ = _tmp4_;
#line 776 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp0_ = number_compare (self, _tmp5_) <= 0;
#line 776 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (_tmp5_);
#line 3369 "number.c"
	}
#line 776 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp0_) {
#line 3373 "number.c"
		Number* _tmp6_;
#line 779 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		number_set_error (_ ("Inverse hyperbolic tangent is undefined for values outside [-1, 1]"));
#line 780 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp6_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 780 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = _tmp6_;
#line 780 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 3383 "number.c"
	}
#line 783 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp7_ = number_new ();
#line 783 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp7_;
#line 784 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp8_ = z;
#line 784 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_atanh (&_tmp8_->priv->num, &self->priv->num, MPC_RNDNN);
#line 785 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 785 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 3397 "number.c"
}


static gint
__lambda4_ (Number* self,
            gint v1,
            gint v2)
{
	gint result = 0;
#line 798 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = v1 & v2;
#line 798 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 3411 "number.c"
}


static gint
___lambda4__bitwise_func (gint v1,
                          gint v2,
                          gpointer self)
{
	gint result;
	result = __lambda4_ ((Number*) self, v1, v2);
#line 798 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 3424 "number.c"
}


Number*
number_and (Number* self,
            Number* y)
{
	Number* result = NULL;
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
#line 789 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 789 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 791 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (!number_is_positive_integer (self)) {
#line 791 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp0_ = TRUE;
#line 3443 "number.c"
	} else {
#line 792 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp0_ = !number_is_positive_integer (y);
#line 3447 "number.c"
	}
#line 791 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp0_) {
#line 795 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		number_set_error (_ ("Boolean AND is only defined for positive integers"));
#line 3453 "number.c"
	}
#line 798 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = number_bitwise (self, y, ___lambda4__bitwise_func, self, 0);
#line 798 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = _tmp1_;
#line 798 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 3461 "number.c"
}


static gint
__lambda5_ (Number* self,
            gint v1,
            gint v2)
{
	gint result = 0;
#line 810 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = v1 | v2;
#line 810 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 3475 "number.c"
}


static gint
___lambda5__bitwise_func (gint v1,
                          gint v2,
                          gpointer self)
{
	gint result;
	result = __lambda5_ ((Number*) self, v1, v2);
#line 810 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 3488 "number.c"
}


Number*
number_or (Number* self,
           Number* y)
{
	Number* result = NULL;
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
#line 802 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 802 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 804 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (!number_is_positive_integer (self)) {
#line 804 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp0_ = TRUE;
#line 3507 "number.c"
	} else {
#line 804 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp0_ = !number_is_positive_integer (y);
#line 3511 "number.c"
	}
#line 804 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp0_) {
#line 807 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		number_set_error (_ ("Boolean OR is only defined for positive integers"));
#line 3517 "number.c"
	}
#line 810 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = number_bitwise (self, y, ___lambda5__bitwise_func, self, 0);
#line 810 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = _tmp1_;
#line 810 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 3525 "number.c"
}


static gint
__lambda6_ (Number* self,
            gint v1,
            gint v2)
{
	gint result = 0;
#line 822 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = v1 ^ v2;
#line 822 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 3539 "number.c"
}


static gint
___lambda6__bitwise_func (gint v1,
                          gint v2,
                          gpointer self)
{
	gint result;
	result = __lambda6_ ((Number*) self, v1, v2);
#line 822 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 3552 "number.c"
}


Number*
number_xor (Number* self,
            Number* y)
{
	Number* result = NULL;
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
#line 814 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 814 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 816 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (!number_is_positive_integer (self)) {
#line 816 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp0_ = TRUE;
#line 3571 "number.c"
	} else {
#line 816 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp0_ = !number_is_positive_integer (y);
#line 3575 "number.c"
	}
#line 816 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp0_) {
#line 819 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		number_set_error (_ ("Boolean XOR is only defined for positive integers"));
#line 3581 "number.c"
	}
#line 822 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = number_bitwise (self, y, ___lambda6__bitwise_func, self, 0);
#line 822 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = _tmp1_;
#line 822 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 3589 "number.c"
}


static gint
__lambda7_ (Number* self,
            gint v1,
            gint v2)
{
	gint result = 0;
#line 834 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = v1 ^ 0xF;
#line 834 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 3603 "number.c"
}


static gint
___lambda7__bitwise_func (gint v1,
                          gint v2,
                          gpointer self)
{
	gint result;
	result = __lambda7_ ((Number*) self, v1, v2);
#line 834 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 3616 "number.c"
}


Number*
number_not (Number* self,
            gint wordlen)
{
	Number* result = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
#line 826 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 828 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (!number_is_positive_integer (self)) {
#line 831 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		number_set_error (_ ("Boolean NOT is only defined for positive integers"));
#line 3635 "number.c"
	}
#line 834 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 834 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = _tmp0_;
#line 834 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp2_ = number_bitwise (self, _tmp1_, ___lambda7__bitwise_func, self, wordlen);
#line 834 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp3_ = _tmp2_;
#line 834 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (_tmp1_);
#line 834 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = _tmp3_;
#line 834 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 3651 "number.c"
}


static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1392 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1392 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	end = _tmp0_;
#line 1393 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = end;
#line 1393 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1394 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = maxlen;
#line 1394 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 3675 "number.c"
	} else {
		gchar* _tmp2_;
#line 1396 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = end;
#line 1396 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1396 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 3684 "number.c"
	}
}


static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp6_;
	gchar* _tmp7_;
#line 1403 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1405 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1405 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 3705 "number.c"
	} else {
#line 1405 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 3709 "number.c"
	}
#line 1405 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 1407 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 3715 "number.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1409 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1409 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1409 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 3725 "number.c"
	}
#line 1412 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 3729 "number.c"
		glong _tmp3_;
#line 1413 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1413 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		offset = _tmp3_ + offset;
#line 1414 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 3737 "number.c"
	} else {
		glong _tmp4_;
#line 1416 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp4_ = string_length;
#line 1416 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		g_return_val_if_fail (offset <= _tmp4_, NULL);
#line 3744 "number.c"
	}
#line 1418 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 3748 "number.c"
		glong _tmp5_;
#line 1419 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp5_ = string_length;
#line 1419 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		len = _tmp5_ - offset;
#line 3754 "number.c"
	}
#line 1421 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp6_ = string_length;
#line 1421 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= _tmp6_, NULL);
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp7_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp7_;
#line 1422 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 3766 "number.c"
}


Number*
number_mask (Number* self,
             Number* x,
             gint wordlen)
{
	Number* result = NULL;
	gchar* text = NULL;
	gchar* _tmp0_;
	gint len = 0;
	const gchar* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint offset = 0;
	gint _tmp4_ = 0;
	gint _tmp5_;
	gint _tmp6_;
	const gchar* _tmp9_;
	gint _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	Number* _tmp13_;
	Number* _tmp14_;
#line 838 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 838 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (x != NULL, NULL);
#line 841 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_to_hex_string (x);
#line 841 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	text = _tmp0_;
#line 842 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = text;
#line 842 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp2_ = strlen (_tmp1_);
#line 842 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp3_ = _tmp2_;
#line 842 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	len = _tmp3_;
#line 843 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	offset = wordlen / 4;
#line 844 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp5_ = len;
#line 844 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp6_ = offset;
#line 844 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp5_ > _tmp6_) {
#line 3816 "number.c"
		gint _tmp7_;
		gint _tmp8_;
#line 844 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp7_ = len;
#line 844 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp8_ = offset;
#line 844 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp4_ = ((gint) _tmp7_) - _tmp8_;
#line 3825 "number.c"
	} else {
#line 844 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp4_ = 0;
#line 3829 "number.c"
	}
#line 844 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	offset = _tmp4_;
#line 845 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp9_ = text;
#line 845 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp10_ = offset;
#line 845 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp11_ = string_substring (_tmp9_, (glong) _tmp10_, (glong) -1);
#line 845 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp12_ = _tmp11_;
#line 845 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp13_ = mp_set_from_string (_tmp12_, 16);
#line 845 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp14_ = _tmp13_;
#line 845 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_free0 (_tmp12_);
#line 845 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = _tmp14_;
#line 845 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_free0 (text);
#line 845 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 3853 "number.c"
}


Number*
number_shift (Number* self,
              gint count)
{
	Number* result = NULL;
#line 849 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 851 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (!number_is_integer (self)) {
#line 3866 "number.c"
		Number* _tmp0_;
#line 854 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		number_set_error (_ ("Shift is only possible on integer values"));
#line 855 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 855 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = _tmp0_;
#line 855 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 3876 "number.c"
	}
#line 858 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (count >= 0) {
#line 3880 "number.c"
		gint multiplier = 0;
		gint _tmp5_;
		Number* _tmp6_;
#line 860 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		multiplier = 1;
#line 3886 "number.c"
		{
			gint i = 0;
#line 861 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			i = 0;
#line 3891 "number.c"
			{
				gboolean _tmp1_ = FALSE;
#line 861 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				_tmp1_ = TRUE;
#line 861 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				while (TRUE) {
#line 3898 "number.c"
					gint _tmp3_;
					gint _tmp4_;
#line 861 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					if (!_tmp1_) {
#line 3903 "number.c"
						gint _tmp2_;
#line 861 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
						_tmp2_ = i;
#line 861 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
						i = _tmp2_ + 1;
#line 3909 "number.c"
					}
#line 861 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					_tmp1_ = FALSE;
#line 861 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					_tmp3_ = i;
#line 861 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					if (!(_tmp3_ < count)) {
#line 861 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
						break;
#line 3919 "number.c"
					}
#line 862 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					_tmp4_ = multiplier;
#line 862 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					multiplier = _tmp4_ * 2;
#line 3925 "number.c"
				}
			}
		}
#line 863 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp5_ = multiplier;
#line 863 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp6_ = number_multiply_integer (self, (gint64) _tmp5_);
#line 863 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = _tmp6_;
#line 863 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 3937 "number.c"
	} else {
		gint multiplier = 0;
		gint _tmp11_;
		Number* _tmp12_;
		Number* _tmp13_;
		Number* _tmp14_;
		Number* _tmp15_;
#line 867 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		multiplier = 1;
#line 3947 "number.c"
		{
			gint i = 0;
#line 868 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			i = 0;
#line 3952 "number.c"
			{
				gboolean _tmp7_ = FALSE;
#line 868 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				_tmp7_ = TRUE;
#line 868 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				while (TRUE) {
#line 3959 "number.c"
					gint _tmp9_;
					gint _tmp10_;
#line 868 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					if (!_tmp7_) {
#line 3964 "number.c"
						gint _tmp8_;
#line 868 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
						_tmp8_ = i;
#line 868 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
						i = _tmp8_ + 1;
#line 3970 "number.c"
					}
#line 868 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					_tmp7_ = FALSE;
#line 868 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					_tmp9_ = i;
#line 868 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					if (!(_tmp9_ < (-count))) {
#line 868 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
						break;
#line 3980 "number.c"
					}
#line 869 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					_tmp10_ = multiplier;
#line 869 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					multiplier = _tmp10_ * 2;
#line 3986 "number.c"
				}
			}
		}
#line 870 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp11_ = multiplier;
#line 870 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp12_ = number_divide_integer (self, (gint64) _tmp11_);
#line 870 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp13_ = _tmp12_;
#line 870 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp14_ = number_floor (_tmp13_);
#line 870 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp15_ = _tmp14_;
#line 870 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (_tmp13_);
#line 870 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = _tmp15_;
#line 870 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 4006 "number.c"
	}
}


static gint
__lambda8_ (Number* self,
            gint v1,
            gint v2)
{
	gint result = 0;
#line 877 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = v1 ^ v2;
#line 877 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 4021 "number.c"
}


static gint
___lambda8__bitwise_func (gint v1,
                          gint v2,
                          gpointer self)
{
	gint result;
	result = __lambda8_ ((Number*) self, v1, v2);
#line 877 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 4034 "number.c"
}


Number*
number_ones_complement (Number* self,
                        gint wordlen)
{
	Number* result = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
#line 875 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 877 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 877 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = _tmp0_;
#line 877 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp2_ = number_bitwise (self, _tmp1_, ___lambda8__bitwise_func, self, wordlen);
#line 877 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp3_ = _tmp2_;
#line 877 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp4_ = number_not (_tmp3_, wordlen);
#line 877 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp5_ = _tmp4_;
#line 877 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (_tmp3_);
#line 877 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (_tmp1_);
#line 877 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = _tmp5_;
#line 877 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 4071 "number.c"
}


Number*
number_twos_complement (Number* self,
                        gint wordlen)
{
	Number* result = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
#line 881 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 883 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_ones_complement (self, wordlen);
#line 883 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = _tmp0_;
#line 883 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp2_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 883 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp3_ = _tmp2_;
#line 883 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp4_ = number_add (_tmp1_, _tmp3_);
#line 883 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp5_ = _tmp4_;
#line 883 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (_tmp3_);
#line 883 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (_tmp1_);
#line 883 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = _tmp5_;
#line 883 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 4108 "number.c"
}


static void
_g_object_unref0_ (gpointer var)
{
#line 917 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 4117 "number.c"
}


static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 917 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 4126 "number.c"
}


GList*
number_factorize (Number* self)
{
	GList* result = NULL;
	GList* factors = NULL;
	Number* value = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* _tmp6_;
	gboolean _tmp7_;
	guint64 num = 0ULL;
	guint64 _tmp9_;
	guint64 _tmp10_;
	guint64 _tmp11_;
	Number* int_max = NULL;
	guint64 _tmp12_;
	Number* _tmp13_;
	Number* _tmp14_;
	Number* _tmp15_;
	Number* divisor = NULL;
	Number* _tmp22_;
	Number* _tmp31_;
	Number* root = NULL;
	Number* _tmp32_;
	Number* _tmp33_;
	Number* _tmp52_;
	Number* _tmp53_;
	Number* _tmp54_;
	gboolean _tmp55_;
#line 887 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 889 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	factors = NULL;
#line 891 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_abs (self);
#line 891 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	value = _tmp0_;
#line 893 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = value;
#line 893 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (number_is_zero (_tmp1_)) {
#line 4173 "number.c"
		Number* _tmp2_;
		Number* _tmp3_;
#line 895 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp2_ = value;
#line 895 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 895 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		factors = g_list_append (factors, _tmp3_);
#line 896 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = factors;
#line 896 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (value);
#line 896 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 4188 "number.c"
	}
#line 899 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp4_ = value;
#line 899 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp5_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 899 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp6_ = _tmp5_;
#line 899 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp7_ = number_equals (_tmp4_, _tmp6_);
#line 899 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (_tmp6_);
#line 899 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp7_) {
#line 4202 "number.c"
		Number* _tmp8_;
#line 901 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp8_ = _g_object_ref0 (self);
#line 901 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		factors = g_list_append (factors, _tmp8_);
#line 902 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = factors;
#line 902 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (value);
#line 902 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 4214 "number.c"
	}
#line 907 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	num = (guint64) 1;
#line 908 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp9_ = num;
#line 908 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	num = _tmp9_ << 63;
#line 909 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp10_ = num;
#line 909 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp11_ = num;
#line 909 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	num = _tmp10_ + (_tmp11_ - 1);
#line 910 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp12_ = num;
#line 910 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp13_ = number_new_unsigned_integer (_tmp12_, (guint64) 0);
#line 910 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	int_max = _tmp13_;
#line 912 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp14_ = value;
#line 912 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp15_ = int_max;
#line 912 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (number_compare (_tmp14_, _tmp15_) <= 0) {
#line 4240 "number.c"
		GList* factors_int64 = NULL;
		Number* _tmp16_;
		GList* _tmp17_;
#line 914 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp16_ = value;
#line 914 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp17_ = number_factorize_uint64 (self, number_to_unsigned_integer (_tmp16_));
#line 914 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		factors_int64 = _tmp17_;
#line 915 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		if (number_is_negative (self)) {
#line 4252 "number.c"
			GList* _tmp18_;
			GList* _tmp19_;
			gconstpointer _tmp20_;
			Number* _tmp21_;
#line 916 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp18_ = factors_int64;
#line 916 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp19_ = factors_int64;
#line 916 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp20_ = _tmp19_->data;
#line 916 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp21_ = number_invert_sign ((Number*) _tmp20_);
#line 916 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_g_object_unref0 (_tmp18_->data);
#line 916 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp18_->data = _tmp21_;
#line 4269 "number.c"
		}
#line 917 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = factors_int64;
#line 917 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (int_max);
#line 917 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (value);
#line 917 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		(factors == NULL) ? NULL : (factors = (_g_list_free__g_object_unref0_ (factors), NULL));
#line 917 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 4281 "number.c"
	}
#line 920 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp22_ = number_new_integer ((gint64) 2, (gint64) 0);
#line 920 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	divisor = _tmp22_;
#line 921 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	while (TRUE) {
#line 4289 "number.c"
		Number* tmp = NULL;
		Number* _tmp23_;
		Number* _tmp24_;
		Number* _tmp25_;
		Number* _tmp26_;
#line 923 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp23_ = value;
#line 923 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp24_ = divisor;
#line 923 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp25_ = number_divide (_tmp23_, _tmp24_);
#line 923 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		tmp = _tmp25_;
#line 924 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp26_ = tmp;
#line 924 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		if (number_is_integer (_tmp26_)) {
#line 4307 "number.c"
			Number* _tmp27_;
			Number* _tmp28_;
			Number* _tmp29_;
			Number* _tmp30_;
#line 926 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp27_ = tmp;
#line 926 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp28_ = _g_object_ref0 (_tmp27_);
#line 926 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_g_object_unref0 (value);
#line 926 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			value = _tmp28_;
#line 927 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp29_ = divisor;
#line 927 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp30_ = _g_object_ref0 (_tmp29_);
#line 927 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			factors = g_list_append (factors, _tmp30_);
#line 4326 "number.c"
		} else {
#line 930 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_g_object_unref0 (tmp);
#line 930 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			break;
#line 4332 "number.c"
		}
#line 921 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (tmp);
#line 4336 "number.c"
	}
#line 933 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp31_ = number_new_integer ((gint64) 3, (gint64) 0);
#line 933 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (divisor);
#line 933 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	divisor = _tmp31_;
#line 934 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp32_ = value;
#line 934 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp33_ = number_sqrt (_tmp32_);
#line 934 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	root = _tmp33_;
#line 935 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	while (TRUE) {
#line 4352 "number.c"
		Number* _tmp34_;
		Number* _tmp35_;
		Number* tmp = NULL;
		Number* _tmp36_;
		Number* _tmp37_;
		Number* _tmp38_;
		Number* _tmp39_;
#line 935 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp34_ = divisor;
#line 935 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp35_ = root;
#line 935 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		if (!(number_compare (_tmp34_, _tmp35_) <= 0)) {
#line 935 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			break;
#line 4368 "number.c"
		}
#line 937 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp36_ = value;
#line 937 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp37_ = divisor;
#line 937 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp38_ = number_divide (_tmp36_, _tmp37_);
#line 937 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		tmp = _tmp38_;
#line 938 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp39_ = tmp;
#line 938 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		if (number_is_integer (_tmp39_)) {
#line 4382 "number.c"
			Number* _tmp40_;
			Number* _tmp41_;
			Number* _tmp42_;
			Number* _tmp43_;
			Number* _tmp44_;
			Number* _tmp45_;
#line 940 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp40_ = tmp;
#line 940 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp41_ = _g_object_ref0 (_tmp40_);
#line 940 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_g_object_unref0 (value);
#line 940 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			value = _tmp41_;
#line 941 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp42_ = value;
#line 941 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp43_ = number_sqrt (_tmp42_);
#line 941 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_g_object_unref0 (root);
#line 941 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			root = _tmp43_;
#line 942 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp44_ = divisor;
#line 942 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp45_ = _g_object_ref0 (_tmp44_);
#line 942 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			factors = g_list_append (factors, _tmp45_);
#line 4411 "number.c"
		} else {
			Number* _tmp46_;
			Number* _tmp47_;
			Number* _tmp48_;
			Number* _tmp49_;
			Number* _tmp50_;
			Number* _tmp51_;
#line 946 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp46_ = divisor;
#line 946 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp47_ = number_new_integer ((gint64) 2, (gint64) 0);
#line 946 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp48_ = _tmp47_;
#line 946 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp49_ = number_add (_tmp46_, _tmp48_);
#line 946 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_g_object_unref0 (tmp);
#line 946 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			tmp = _tmp49_;
#line 946 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_g_object_unref0 (_tmp48_);
#line 947 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp50_ = tmp;
#line 947 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp51_ = _g_object_ref0 (_tmp50_);
#line 947 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_g_object_unref0 (divisor);
#line 947 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			divisor = _tmp51_;
#line 4441 "number.c"
		}
#line 935 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (tmp);
#line 4445 "number.c"
	}
#line 951 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp52_ = value;
#line 951 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp53_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 951 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp54_ = _tmp53_;
#line 951 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp55_ = number_compare (_tmp52_, _tmp54_) > 0;
#line 951 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (_tmp54_);
#line 951 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp55_) {
#line 4459 "number.c"
		Number* _tmp56_;
		Number* _tmp57_;
#line 952 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp56_ = value;
#line 952 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp57_ = _g_object_ref0 (_tmp56_);
#line 952 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		factors = g_list_append (factors, _tmp57_);
#line 4468 "number.c"
	}
#line 954 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (number_is_negative (self)) {
#line 4472 "number.c"
		GList* _tmp58_;
		GList* _tmp59_;
		gconstpointer _tmp60_;
		Number* _tmp61_;
#line 955 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp58_ = factors;
#line 955 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp59_ = factors;
#line 955 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp60_ = _tmp59_->data;
#line 955 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp61_ = number_invert_sign ((Number*) _tmp60_);
#line 955 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (_tmp58_->data);
#line 955 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp58_->data = _tmp61_;
#line 4489 "number.c"
	}
#line 957 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = factors;
#line 957 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (root);
#line 957 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (divisor);
#line 957 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (int_max);
#line 957 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (value);
#line 957 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 4503 "number.c"
}


GList*
number_factorize_uint64 (Number* self,
                         guint64 n)
{
	GList* result = NULL;
	GList* factors = NULL;
#line 960 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 962 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	factors = NULL;
#line 963 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	while (TRUE) {
#line 4519 "number.c"
		Number* _tmp0_;
#line 963 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		if (!((n % 2) == ((guint64) 0))) {
#line 963 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			break;
#line 4525 "number.c"
		}
#line 965 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		n = n / 2;
#line 966 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp0_ = number_new_unsigned_integer ((guint64) 2, (guint64) 0);
#line 966 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		factors = g_list_append (factors, _tmp0_);
#line 4533 "number.c"
	}
	{
		guint64 divisor = 0ULL;
#line 969 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		divisor = (guint64) 3;
#line 4539 "number.c"
		{
			gboolean _tmp1_ = FALSE;
#line 969 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp1_ = TRUE;
#line 969 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			while (TRUE) {
#line 4546 "number.c"
				guint64 _tmp3_;
				guint64 _tmp4_;
#line 969 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				if (!_tmp1_) {
#line 4551 "number.c"
					guint64 _tmp2_;
#line 969 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					_tmp2_ = divisor;
#line 969 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					divisor = _tmp2_ + 2;
#line 4557 "number.c"
				}
#line 969 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				_tmp1_ = FALSE;
#line 969 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				_tmp3_ = divisor;
#line 969 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				_tmp4_ = divisor;
#line 969 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				if (!(_tmp3_ <= (n / _tmp4_))) {
#line 969 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					break;
#line 4569 "number.c"
				}
#line 971 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				while (TRUE) {
#line 4573 "number.c"
					guint64 _tmp5_;
					guint64 _tmp6_;
					guint64 _tmp7_;
					Number* _tmp8_;
#line 971 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					_tmp5_ = divisor;
#line 971 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					if (!((n % _tmp5_) == ((guint64) 0))) {
#line 971 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
						break;
#line 4584 "number.c"
					}
#line 973 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					_tmp6_ = divisor;
#line 973 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					n = n / _tmp6_;
#line 974 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					_tmp7_ = divisor;
#line 974 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					_tmp8_ = number_new_unsigned_integer (_tmp7_, (guint64) 0);
#line 974 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					factors = g_list_append (factors, _tmp8_);
#line 4596 "number.c"
				}
			}
		}
	}
#line 978 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (n > ((guint64) 1)) {
#line 4603 "number.c"
		Number* _tmp9_;
#line 979 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp9_ = number_new_unsigned_integer (n, (guint64) 0);
#line 979 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		factors = g_list_append (factors, _tmp9_);
#line 4609 "number.c"
	}
#line 980 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = factors;
#line 980 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 4615 "number.c"
}


static Number*
number_copy (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
#line 983 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 985 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_new ();
#line 985 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp0_;
#line 986 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_set (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 987 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 987 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 4637 "number.c"
}


static gboolean
_mpc_equal (const __mpc_struct * s1,
            const __mpc_struct * s2)
{
#line 998 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (s1 == s2) {
#line 998 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return TRUE;
#line 4649 "number.c"
	}
#line 998 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (s1 == NULL) {
#line 998 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return FALSE;
#line 4655 "number.c"
	}
#line 998 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (s2 == NULL) {
#line 998 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return FALSE;
#line 4661 "number.c"
	}
#line 998 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return FALSE;
#line 4665 "number.c"
}


static void
number_mpc_from_radians (__mpc_struct* res,
                         __mpc_struct* op,
                         AngleUnit unit)
{
	gint i = 0;
	__mpfr_struct scale = {0};
	mpfr_prec_t _tmp1_;
	mpfr_prec_t _tmp2_;
	gint _tmp3_;
	__mpc_struct _tmp4_;
#line 990 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_if_fail (res != NULL);
#line 990 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_if_fail (op != NULL);
#line 994 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	switch (unit) {
#line 4686 "number.c"
		default:
#line 994 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		case ANGLE_UNIT_RADIANS:
#line 4690 "number.c"
		{
#line 998 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			if (_mpc_equal (res, op) != TRUE) {
#line 4694 "number.c"
				__mpc_struct _tmp0_;
#line 999 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				_tmp0_ = *op;
#line 999 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				mpc_set (res, &_tmp0_, MPC_RNDNN);
#line 4700 "number.c"
			}
#line 1000 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			return;
#line 4704 "number.c"
		}
#line 994 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		case ANGLE_UNIT_DEGREES:
#line 4708 "number.c"
		{
#line 1003 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			i = 180;
#line 1004 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			break;
#line 4714 "number.c"
		}
#line 994 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		case ANGLE_UNIT_GRADIANS:
#line 4718 "number.c"
		{
#line 1007 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			i = 200;
#line 1008 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			break;
#line 4724 "number.c"
		}
	}
#line 1011 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = number_get_precision ();
#line 1011 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp2_ = _tmp1_;
#line 1011 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpfr_init2 (&scale, _tmp2_);
#line 1012 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpfr_const_pi (&scale, MPFR_RNDN);
#line 1013 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp3_ = i;
#line 1013 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpfr_si_div (&scale, (glong) _tmp3_, &scale, MPFR_RNDN);
#line 1014 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp4_ = *op;
#line 1014 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_mul_fr (res, &_tmp4_, &scale, MPC_RNDNN);
#line 990 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpfr_clear (&scale);
#line 4745 "number.c"
}


static void
number_mpc_to_radians (__mpc_struct* res,
                       __mpc_struct* op,
                       AngleUnit unit)
{
	gint i = 0;
	__mpfr_struct scale = {0};
	mpfr_prec_t _tmp1_;
	mpfr_prec_t _tmp2_;
	gint _tmp3_;
	__mpc_struct _tmp4_;
#line 1017 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_if_fail (res != NULL);
#line 1017 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_if_fail (op != NULL);
#line 1021 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	switch (unit) {
#line 4766 "number.c"
		default:
#line 1021 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		case ANGLE_UNIT_RADIANS:
#line 4770 "number.c"
		{
#line 1025 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			if (_mpc_equal (res, op) != TRUE) {
#line 4774 "number.c"
				__mpc_struct _tmp0_;
#line 1026 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				_tmp0_ = *op;
#line 1026 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				mpc_set (res, &_tmp0_, MPC_RNDNN);
#line 4780 "number.c"
			}
#line 1027 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			return;
#line 4784 "number.c"
		}
#line 1021 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		case ANGLE_UNIT_DEGREES:
#line 4788 "number.c"
		{
#line 1030 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			i = 180;
#line 1031 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			break;
#line 4794 "number.c"
		}
#line 1021 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		case ANGLE_UNIT_GRADIANS:
#line 4798 "number.c"
		{
#line 1034 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			i = 200;
#line 1035 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			break;
#line 4804 "number.c"
		}
	}
#line 1037 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = number_get_precision ();
#line 1037 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp2_ = _tmp1_;
#line 1037 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpfr_init2 (&scale, _tmp2_);
#line 1038 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpfr_const_pi (&scale, MPFR_RNDN);
#line 1039 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp3_ = i;
#line 1039 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpfr_div_si (&scale, &scale, (glong) _tmp3_, MPFR_RNDN);
#line 1040 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp4_ = *op;
#line 1040 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_mul_fr (res, &_tmp4_, &scale, MPC_RNDNN);
#line 1017 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpfr_clear (&scale);
#line 4825 "number.c"
}


static Number*
number_to_radians (Number* self,
                   AngleUnit unit)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
#line 1044 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1046 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_new ();
#line 1046 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp0_;
#line 1047 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	number_mpc_to_radians (&z->priv->num, &self->priv->num, unit);
#line 1048 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 1048 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 4848 "number.c"
}


static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
#line 1180 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1181 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1181 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	result = _tmp0_;
#line 1181 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	return result;
#line 4866 "number.c"
}


static Number*
number_bitwise (Number* self,
                Number* y,
                BitwiseFunc bitwise_operator,
                gpointer bitwise_operator_target,
                gint wordlen)
{
	Number* result = NULL;
	gchar* text1 = NULL;
	gchar* _tmp0_;
	gchar* text2 = NULL;
	gchar* _tmp1_;
	gint offset1 = 0;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint offset2 = 0;
	const gchar* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint offset_out = 0;
	gint _tmp8_;
	gboolean _tmp14_ = FALSE;
	gint _tmp15_;
	gchar* text_out = NULL;
	gint _tmp22_;
	gchar* _tmp23_;
	gint text_out_length1;
	gint _text_out_size_;
	gchar* _tmp42_;
	gint _tmp42__length1;
	Number* _tmp43_;
#line 1051 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1051 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 1053 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_to_hex_string (self);
#line 1053 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	text1 = _tmp0_;
#line 1054 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = number_to_hex_string (y);
#line 1054 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	text2 = _tmp1_;
#line 1055 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp2_ = text1;
#line 1055 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp3_ = strlen (_tmp2_);
#line 1055 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp4_ = _tmp3_;
#line 1055 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	offset1 = _tmp4_ - 1;
#line 1056 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp5_ = text2;
#line 1056 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp6_ = strlen (_tmp5_);
#line 1056 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp7_ = _tmp6_;
#line 1056 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	offset2 = _tmp7_ - 1;
#line 1057 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	offset_out = (wordlen / 4) - 1;
#line 1058 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp8_ = offset_out;
#line 1058 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp8_ <= 0) {
#line 4936 "number.c"
		gint _tmp9_ = 0;
		gint _tmp10_;
		gint _tmp11_;
#line 1059 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp10_ = offset1;
#line 1059 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp11_ = offset2;
#line 1059 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		if (_tmp10_ > _tmp11_) {
#line 4946 "number.c"
			gint _tmp12_;
#line 1059 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp12_ = offset1;
#line 1059 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp9_ = _tmp12_;
#line 4952 "number.c"
		} else {
			gint _tmp13_;
#line 1059 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp13_ = offset2;
#line 1059 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp9_ = _tmp13_;
#line 4959 "number.c"
		}
#line 1059 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		offset_out = _tmp9_;
#line 4963 "number.c"
	}
#line 1060 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp15_ = offset_out;
#line 1060 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp15_ > 0) {
#line 4969 "number.c"
		gboolean _tmp16_ = FALSE;
		gint _tmp17_;
		gint _tmp18_;
#line 1060 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp17_ = offset_out;
#line 1060 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp18_ = offset1;
#line 1060 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		if (_tmp17_ < _tmp18_) {
#line 1060 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp16_ = TRUE;
#line 4981 "number.c"
		} else {
			gint _tmp19_;
			gint _tmp20_;
#line 1060 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp19_ = offset_out;
#line 1060 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp20_ = offset2;
#line 1060 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp16_ = _tmp19_ < _tmp20_;
#line 4991 "number.c"
		}
#line 1060 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp14_ = _tmp16_;
#line 4995 "number.c"
	} else {
#line 1060 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp14_ = FALSE;
#line 4999 "number.c"
	}
#line 1060 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp14_) {
#line 5003 "number.c"
		Number* _tmp21_;
#line 1062 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		number_set_error ("Overflow. Try a bigger word size");
#line 1063 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp21_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1063 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = _tmp21_;
#line 1063 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_free0 (text2);
#line 1063 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_free0 (text1);
#line 1063 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 5017 "number.c"
	}
#line 1066 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp22_ = offset_out;
#line 1066 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp23_ = g_new0 (gchar, _tmp22_ + 2);
#line 1066 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	text_out = _tmp23_;
#line 1066 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	text_out_length1 = _tmp22_ + 2;
#line 1066 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_text_out_size_ = text_out_length1;
#line 5029 "number.c"
	{
		gchar* _tmp24_;
		gint _tmp24__length1;
		gint _tmp25_;
		gboolean _tmp26_ = FALSE;
#line 1069 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp24_ = text_out;
#line 1069 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp24__length1 = text_out_length1;
#line 1069 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp25_ = offset_out;
#line 1069 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp24_[_tmp25_ + 1] = '\0';
#line 1069 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp26_ = TRUE;
#line 1069 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		while (TRUE) {
#line 5047 "number.c"
			gint _tmp28_;
			gint v1 = 0;
			gint v2 = 0;
#line 1072 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			static const gchar digits[16] = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'};
#line 5053 "number.c"
			gint _tmp29_;
			gint _tmp33_;
			gchar* _tmp37_;
			gint _tmp37__length1;
			gint _tmp38_;
			gint _tmp39_;
			gint _tmp40_;
			gchar _tmp41_;
#line 1069 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			if (!_tmp26_) {
#line 5064 "number.c"
				gint _tmp27_;
#line 1069 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				_tmp27_ = offset_out;
#line 1069 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				offset_out = _tmp27_ - 1;
#line 5070 "number.c"
			}
#line 1069 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp26_ = FALSE;
#line 1069 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp28_ = offset_out;
#line 1069 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			if (!(_tmp28_ >= 0)) {
#line 1069 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				break;
#line 5080 "number.c"
			}
#line 1071 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			v1 = 0;
#line 1071 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			v2 = 0;
#line 1074 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp29_ = offset1;
#line 1074 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			if (_tmp29_ >= 0) {
#line 5090 "number.c"
				const gchar* _tmp30_;
				gint _tmp31_;
				gint _tmp32_;
#line 1076 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				_tmp30_ = text1;
#line 1076 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				_tmp31_ = offset1;
#line 1076 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				v1 = number_hex_to_int (self, string_get (_tmp30_, (glong) _tmp31_));
#line 1077 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				_tmp32_ = offset1;
#line 1077 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				offset1 = _tmp32_ - 1;
#line 5104 "number.c"
			}
#line 1079 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp33_ = offset2;
#line 1079 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			if (_tmp33_ >= 0) {
#line 5110 "number.c"
				const gchar* _tmp34_;
				gint _tmp35_;
				gint _tmp36_;
#line 1081 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				_tmp34_ = text2;
#line 1081 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				_tmp35_ = offset2;
#line 1081 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				v2 = number_hex_to_int (self, string_get (_tmp34_, (glong) _tmp35_));
#line 1082 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				_tmp36_ = offset2;
#line 1082 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				offset2 = _tmp36_ - 1;
#line 5124 "number.c"
			}
#line 1084 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp37_ = text_out;
#line 1084 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp37__length1 = text_out_length1;
#line 1084 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp38_ = offset_out;
#line 1084 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp39_ = v1;
#line 1084 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp40_ = v2;
#line 1084 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp41_ = digits[bitwise_operator (_tmp39_, _tmp40_, bitwise_operator_target)];
#line 1084 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp37_[_tmp38_] = _tmp41_;
#line 5140 "number.c"
		}
	}
#line 1087 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp42_ = text_out;
#line 1087 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp42__length1 = text_out_length1;
#line 1087 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp43_ = mp_set_from_string ((const gchar*) _tmp42_, 16);
#line 1087 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = _tmp43_;
#line 1087 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	text_out = (g_free (text_out), NULL);
#line 1087 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_free0 (text2);
#line 1087 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_free0 (text1);
#line 1087 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 5159 "number.c"
}


static gint
number_hex_to_int (Number* self,
                   gchar digit)
{
	gint result = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 1090 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1092 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (digit >= '0') {
#line 1092 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp0_ = digit <= '9';
#line 5177 "number.c"
	} else {
#line 1092 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp0_ = FALSE;
#line 5181 "number.c"
	}
#line 1092 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp0_) {
#line 1093 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = (gint) (digit - '0');
#line 1093 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 5189 "number.c"
	}
#line 1094 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (digit >= 'A') {
#line 1094 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp1_ = digit <= 'F';
#line 5195 "number.c"
	} else {
#line 1094 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp1_ = FALSE;
#line 5199 "number.c"
	}
#line 1094 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp1_) {
#line 1095 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = (digit - 'A') + 10;
#line 1095 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 5207 "number.c"
	}
#line 1096 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (digit >= 'a') {
#line 1096 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp2_ = digit <= 'f';
#line 5213 "number.c"
	} else {
#line 1096 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp2_ = FALSE;
#line 5217 "number.c"
	}
#line 1096 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp2_) {
#line 1097 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = (digit - 'a') + 10;
#line 1097 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 5225 "number.c"
	}
#line 1098 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = 0;
#line 1098 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 5231 "number.c"
}


static gchar*
number_to_hex_string (Number* self)
{
	gchar* result = NULL;
	Serializer* serializer = NULL;
	Serializer* _tmp0_;
	gchar* _tmp1_;
#line 1101 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1103 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = serializer_new (DISPLAY_FORMAT_FIXED, 16, 0);
#line 1103 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	serializer = _tmp0_;
#line 1104 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = serializer_to_string (serializer, self);
#line 1104 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = _tmp1_;
#line 1104 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (serializer);
#line 1104 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 5256 "number.c"
}


Number*
number_construct (GType object_type)
{
	Number * self = NULL;
#line 42 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 42 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return self;
#line 5268 "number.c"
}


Number*
number_new (void)
{
#line 42 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return number_construct (TYPE_NUMBER);
#line 5277 "number.c"
}


mpfr_prec_t
number_get_precision (void)
{
	mpfr_prec_t result;
	mpfr_prec_t _tmp0_;
#line 47 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number__precision;
#line 47 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = _tmp0_;
#line 47 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 5292 "number.c"
}


void
number_set_precision (mpfr_prec_t value)
{
#line 47 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	number__precision = value;
#line 5301 "number.c"
}


const gchar*
number_get_error (void)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 50 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number__error;
#line 50 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = _tmp0_;
#line 50 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 5316 "number.c"
}


void
number_set_error (const gchar* value)
{
	gchar* _tmp0_;
#line 50 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = g_strdup (value);
#line 50 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_free0 (number__error);
#line 50 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	number__error = _tmp0_;
#line 5330 "number.c"
}


static void
number_class_init (NumberClass * klass)
{
#line 42 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	number_parent_class = g_type_class_peek_parent (klass);
#line 42 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_type_class_add_private (klass, sizeof (NumberPrivate));
#line 42 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_number_get_property;
#line 42 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_number_set_property;
#line 42 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	G_OBJECT_CLASS (klass)->finalize = number_finalize;
#line 5347 "number.c"
}


static void
number_instance_init (Number * self)
{
	mpfr_prec_t _tmp0_;
	mpfr_prec_t _tmp1_;
#line 42 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	self->priv = NUMBER_GET_PRIVATE (self);
#line 45 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_get_precision ();
#line 45 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = _tmp0_;
#line 45 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_init2 (&self->priv->num, _tmp1_);
#line 5364 "number.c"
}


static void
number_finalize (GObject * obj)
{
	Number * self;
#line 42 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NUMBER, Number);
#line 45 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	mpc_clear (&self->priv->num);
#line 42 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	G_OBJECT_CLASS (number_parent_class)->finalize (obj);
#line 5378 "number.c"
}


GType
number_get_type (void)
{
	static volatile gsize number_type_id__volatile = 0;
	if (g_once_init_enter (&number_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NumberClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) number_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Number), 0, (GInstanceInitFunc) number_instance_init, NULL };
		GType number_type_id;
		number_type_id = g_type_register_static (G_TYPE_OBJECT, "Number", &g_define_type_info, 0);
		g_once_init_leave (&number_type_id__volatile, number_type_id);
	}
	return number_type_id__volatile;
}


static void
_vala_number_get_property (GObject * object,
                           guint property_id,
                           GValue * value,
                           GParamSpec * pspec)
{
	Number * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NUMBER, Number);
#line 42 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	switch (property_id) {
#line 5406 "number.c"
		default:
#line 42 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 42 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		break;
#line 5412 "number.c"
	}
}


static void
_vala_number_set_property (GObject * object,
                           guint property_id,
                           const GValue * value,
                           GParamSpec * pspec)
{
	Number * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NUMBER, Number);
#line 42 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	switch (property_id) {
#line 5427 "number.c"
		default:
#line 42 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 42 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		break;
#line 5433 "number.c"
	}
}


static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1101 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1102 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1102 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1104 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1104 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 5457 "number.c"
		gchar* _tmp2_;
#line 1105 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1105 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1105 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 5465 "number.c"
	} else {
#line 1107 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = -1;
#line 1107 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 5471 "number.c"
	}
}


static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result = FALSE;
	gunichar _tmp0_;
#line 1199 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1200 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1201 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	_tmp0_ = _vala_c;
#line 1201 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (_tmp0_ != ((gunichar) 0)) {
#line 5492 "number.c"
		gchar* _tmp1_;
#line 1202 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp1_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1202 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		*index = (gint) (_tmp1_ - ((gchar*) self));
#line 1203 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = TRUE;
#line 1203 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (c) {
#line 1203 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			*c = _vala_c;
#line 5504 "number.c"
		}
#line 1203 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 5508 "number.c"
	} else {
#line 1205 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = FALSE;
#line 1205 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (c) {
#line 1205 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			*c = _vala_c;
#line 5516 "number.c"
		}
#line 1205 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 5520 "number.c"
	}
#line 1199 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (c) {
#line 1199 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		*c = _vala_c;
#line 5526 "number.c"
	}
}


static gboolean
string_get_prev_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result = FALSE;
#line 1238 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1239 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (0 < (*index)) {
#line 5542 "number.c"
		gchar* _tmp0_;
#line 1240 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_tmp0_ = g_utf8_prev_char (((gchar*) self) + (*index));
#line 1240 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1241 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1242 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = TRUE;
#line 1242 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (c) {
#line 1242 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			*c = _vala_c;
#line 5556 "number.c"
		}
#line 1242 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 5560 "number.c"
	} else {
#line 1244 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		_vala_c = (gunichar) 0;
#line 1245 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		result = FALSE;
#line 1245 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		if (c) {
#line 1245 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
			*c = _vala_c;
#line 5570 "number.c"
		}
#line 1245 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		return result;
#line 5574 "number.c"
	}
#line 1238 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
	if (c) {
#line 1238 "/usr/share/vala-0.40/vapi/glib-2.0.vapi"
		*c = _vala_c;
#line 5580 "number.c"
	}
}


Number*
mp_set_from_string (const gchar* str,
                    gint default_base)
{
	Number* result = NULL;
#line 1119 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	static const gunichar base_digits[10] = {8320U, 8321U, 8322U, 8323U, 8324U, 8325U, 8326U, 8327U, 8328U, 8329U};
#line 5592 "number.c"
	gint index = 0;
	gunichar c = 0U;
	gint end = 0;
	gint _tmp3_;
	gint number_base = 0;
	gint base_multiplier = 0;
	gint _tmp19_;
	gboolean negate = FALSE;
	gunichar _tmp20_ = 0U;
	gunichar _tmp21_;
	Number* z = NULL;
	Number* _tmp26_;
#line 1176 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	static const gunichar fractions[15] = {189U, 8531U, 8532U, 188U, 190U, 8533U, 8534U, 8535U, 8536U, 8537U, 8538U, 8539U, 8540U, 8541U, 8542U};
#line 1177 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	static const gint numerators[15] = {1, 1, 2, 1, 3, 1, 2, 3, 4, 1, 5, 1, 3, 5, 7};
#line 1178 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	static const gint denominators[15] = {2, 3, 3, 4, 4, 5, 5, 5, 5, 6, 6, 8, 8, 8, 8};
#line 5611 "number.c"
	gboolean has_fraction = FALSE;
	gunichar _tmp43_ = 0U;
	gboolean _tmp44_;
	gboolean _tmp63_;
	gint _tmp89_;
	gint _tmp90_;
	gboolean _tmp91_;
#line 1113 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 1115 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (string_index_of_char (str, 176U, 0) >= 0) {
#line 5623 "number.c"
		Number* _tmp0_;
#line 1116 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp0_ = set_from_sexagesimal (str);
#line 1116 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = _tmp0_;
#line 1116 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 5631 "number.c"
	}
#line 1120 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	index = 0;
#line 1122 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	while (TRUE) {
#line 5637 "number.c"
		gunichar _tmp1_ = 0U;
		gboolean _tmp2_;
#line 1122 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp2_ = string_get_next_char (str, &index, &_tmp1_);
#line 1122 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		c = _tmp1_;
#line 1122 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		if (!_tmp2_) {
#line 1122 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			break;
#line 5648 "number.c"
		}
	}
#line 1123 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp3_ = index;
#line 1123 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	end = _tmp3_;
#line 1124 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	number_base = 0;
#line 1125 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	base_multiplier = 1;
#line 1126 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	while (TRUE) {
#line 5661 "number.c"
		gunichar _tmp4_ = 0U;
		gboolean _tmp5_;
		gint value = 0;
		gint _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
#line 1126 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp5_ = string_get_prev_char (str, &index, &_tmp4_);
#line 1126 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		c = _tmp4_;
#line 1126 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		if (!_tmp5_) {
#line 1126 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			break;
#line 5679 "number.c"
		}
#line 1128 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		value = -1;
#line 5683 "number.c"
		{
			gint i = 0;
#line 1129 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			i = 0;
#line 5688 "number.c"
			{
				gboolean _tmp6_ = FALSE;
#line 1129 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				_tmp6_ = TRUE;
#line 1129 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				while (TRUE) {
#line 5695 "number.c"
					gint _tmp8_;
					gunichar _tmp9_;
					gint _tmp10_;
					gunichar _tmp11_;
#line 1129 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					if (!_tmp6_) {
#line 5702 "number.c"
						gint _tmp7_;
#line 1129 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
						_tmp7_ = i;
#line 1129 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
						i = _tmp7_ + 1;
#line 5708 "number.c"
					}
#line 1129 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					_tmp6_ = FALSE;
#line 1129 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					_tmp8_ = i;
#line 1129 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					if (!(_tmp8_ < G_N_ELEMENTS (base_digits))) {
#line 1129 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
						break;
#line 5718 "number.c"
					}
#line 1131 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					_tmp9_ = c;
#line 1131 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					_tmp10_ = i;
#line 1131 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					_tmp11_ = base_digits[_tmp10_];
#line 1131 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					if (_tmp9_ == _tmp11_) {
#line 5728 "number.c"
						gint _tmp12_;
#line 1133 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
						_tmp12_ = i;
#line 1133 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
						value = _tmp12_;
#line 1134 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
						break;
#line 5736 "number.c"
					}
				}
			}
		}
#line 1137 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp13_ = value;
#line 1137 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		if (_tmp13_ < 0) {
#line 1138 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			break;
#line 5747 "number.c"
		}
#line 1140 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp14_ = index;
#line 1140 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		end = _tmp14_;
#line 1141 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp15_ = number_base;
#line 1141 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp16_ = value;
#line 1141 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp17_ = base_multiplier;
#line 1141 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		number_base = _tmp15_ + (_tmp16_ * _tmp17_);
#line 1142 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp18_ = base_multiplier;
#line 1142 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		base_multiplier = _tmp18_ * 10;
#line 5765 "number.c"
	}
#line 1144 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp19_ = base_multiplier;
#line 1144 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp19_ == 1) {
#line 1145 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		number_base = default_base;
#line 5773 "number.c"
	}
#line 1148 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	negate = FALSE;
#line 1149 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	index = 0;
#line 1150 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	string_get_next_char (str, &index, &_tmp20_);
#line 1150 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	c = _tmp20_;
#line 1151 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp21_ = c;
#line 1151 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp21_ == ((gunichar) '+')) {
#line 1152 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		negate = FALSE;
#line 5789 "number.c"
	} else {
		gboolean _tmp22_ = FALSE;
		gunichar _tmp23_;
#line 1153 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp23_ = c;
#line 1153 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		if (_tmp23_ == ((gunichar) '-')) {
#line 1153 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp22_ = TRUE;
#line 5799 "number.c"
		} else {
			gunichar _tmp24_;
#line 1153 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp24_ = c;
#line 1153 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp22_ = _tmp24_ == 8722U;
#line 5806 "number.c"
		}
#line 1153 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		if (_tmp22_) {
#line 1154 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			negate = TRUE;
#line 5812 "number.c"
		} else {
			gunichar _tmp25_ = 0U;
#line 1156 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			string_get_prev_char (str, &index, &_tmp25_);
#line 1156 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			c = _tmp25_;
#line 5819 "number.c"
		}
	}
#line 1159 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp26_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1159 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	z = _tmp26_;
#line 1161 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	while (TRUE) {
#line 5828 "number.c"
		gunichar _tmp27_ = 0U;
		gboolean _tmp28_;
		gint i = 0;
		gunichar _tmp29_;
		gint _tmp30_;
		gint _tmp31_;
		gint _tmp32_;
		gint _tmp33_;
		Number* _tmp35_;
		gint _tmp36_;
		Number* _tmp37_;
		Number* _tmp38_;
		gint _tmp39_;
		Number* _tmp40_;
		Number* _tmp41_;
		Number* _tmp42_;
#line 1161 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp28_ = string_get_next_char (str, &index, &_tmp27_);
#line 1161 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		c = _tmp27_;
#line 1161 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		if (!_tmp28_) {
#line 1161 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			break;
#line 5853 "number.c"
		}
#line 1163 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp29_ = c;
#line 1163 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp30_ = number_base;
#line 1163 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		i = char_val (_tmp29_, _tmp30_);
#line 1164 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp31_ = i;
#line 1164 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp32_ = number_base;
#line 1164 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		if (_tmp31_ > _tmp32_) {
#line 1165 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			result = NULL;
#line 1165 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_g_object_unref0 (z);
#line 1165 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			return result;
#line 5873 "number.c"
		}
#line 1166 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp33_ = i;
#line 1166 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		if (_tmp33_ < 0) {
#line 5879 "number.c"
			gunichar _tmp34_ = 0U;
#line 1168 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			string_get_prev_char (str, &index, &_tmp34_);
#line 1168 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			c = _tmp34_;
#line 1169 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			break;
#line 5887 "number.c"
		}
#line 1172 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp35_ = z;
#line 1172 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp36_ = number_base;
#line 1172 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp37_ = number_multiply_integer (_tmp35_, (gint64) _tmp36_);
#line 1172 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp38_ = _tmp37_;
#line 1172 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp39_ = i;
#line 1172 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp40_ = number_new_integer ((gint64) _tmp39_, (gint64) 0);
#line 1172 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp41_ = _tmp40_;
#line 1172 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp42_ = number_add (_tmp38_, _tmp41_);
#line 1172 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (z);
#line 1172 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		z = _tmp42_;
#line 1172 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (_tmp41_);
#line 1172 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (_tmp38_);
#line 5913 "number.c"
	}
#line 1179 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	has_fraction = FALSE;
#line 1180 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp44_ = string_get_next_char (str, &index, &_tmp43_);
#line 1180 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	c = _tmp43_;
#line 1180 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp44_) {
#line 5923 "number.c"
		gunichar _tmp61_;
		{
			gint i = 0;
#line 1182 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			i = 0;
#line 5929 "number.c"
			{
				gboolean _tmp45_ = FALSE;
#line 1182 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				_tmp45_ = TRUE;
#line 1182 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				while (TRUE) {
#line 5936 "number.c"
					gint _tmp47_;
					gunichar _tmp48_;
					gint _tmp49_;
					gunichar _tmp50_;
#line 1182 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					if (!_tmp45_) {
#line 5943 "number.c"
						gint _tmp46_;
#line 1182 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
						_tmp46_ = i;
#line 1182 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
						i = _tmp46_ + 1;
#line 5949 "number.c"
					}
#line 1182 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					_tmp45_ = FALSE;
#line 1182 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					_tmp47_ = i;
#line 1182 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					if (!(_tmp47_ < G_N_ELEMENTS (fractions))) {
#line 1182 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
						break;
#line 5959 "number.c"
					}
#line 1184 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					_tmp48_ = c;
#line 1184 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					_tmp49_ = i;
#line 1184 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					_tmp50_ = fractions[_tmp49_];
#line 1184 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
					if (_tmp48_ == _tmp50_) {
#line 5969 "number.c"
						Number* fraction = NULL;
						gint _tmp51_;
						gint _tmp52_;
						gint _tmp53_;
						gint _tmp54_;
						Number* _tmp55_;
						Number* _tmp56_;
						Number* _tmp57_;
						Number* _tmp58_;
						gunichar _tmp59_ = 0U;
						gboolean _tmp60_;
#line 1186 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
						_tmp51_ = i;
#line 1186 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
						_tmp52_ = numerators[_tmp51_];
#line 1186 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
						_tmp53_ = i;
#line 1186 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
						_tmp54_ = denominators[_tmp53_];
#line 1186 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
						_tmp55_ = number_new_fraction ((gint64) _tmp52_, (gint64) _tmp54_);
#line 1186 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
						fraction = _tmp55_;
#line 1187 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
						_tmp56_ = z;
#line 1187 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
						_tmp57_ = fraction;
#line 1187 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
						_tmp58_ = number_add (_tmp56_, _tmp57_);
#line 1187 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
						_g_object_unref0 (z);
#line 1187 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
						z = _tmp58_;
#line 1190 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
						_tmp60_ = string_get_next_char (str, &index, &_tmp59_);
#line 1190 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
						c = _tmp59_;
#line 1190 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
						if (!_tmp60_) {
#line 1191 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
							result = z;
#line 1191 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
							_g_object_unref0 (fraction);
#line 1191 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
							return result;
#line 6015 "number.c"
						} else {
#line 1193 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
							result = NULL;
#line 1193 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
							_g_object_unref0 (fraction);
#line 1193 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
							_g_object_unref0 (z);
#line 1193 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
							return result;
#line 6025 "number.c"
						}
#line 1184 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
						_g_object_unref0 (fraction);
#line 6029 "number.c"
					}
				}
			}
		}
#line 1198 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp61_ = c;
#line 1198 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		if (_tmp61_ == ((gunichar) '.')) {
#line 1199 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			has_fraction = TRUE;
#line 6040 "number.c"
		} else {
			gunichar _tmp62_ = 0U;
#line 1201 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			string_get_prev_char (str, &index, &_tmp62_);
#line 1201 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			c = _tmp62_;
#line 6047 "number.c"
		}
	}
#line 1205 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp63_ = has_fraction;
#line 1205 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp63_) {
#line 6054 "number.c"
		Number* numerator = NULL;
		Number* _tmp64_;
		Number* denominator = NULL;
		Number* _tmp65_;
		Number* _tmp83_;
		Number* _tmp84_;
		Number* _tmp85_;
		Number* _tmp86_;
		Number* _tmp87_;
		Number* _tmp88_;
#line 1207 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp64_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1207 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		numerator = _tmp64_;
#line 1208 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp65_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 1208 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		denominator = _tmp65_;
#line 1210 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		while (TRUE) {
#line 6075 "number.c"
			gunichar _tmp66_ = 0U;
			gboolean _tmp67_;
			gint i = 0;
			gunichar _tmp68_;
			gint _tmp69_;
			gint _tmp70_;
			Number* _tmp72_;
			gint _tmp73_;
			Number* _tmp74_;
			Number* _tmp75_;
			gint _tmp76_;
			Number* _tmp77_;
			Number* _tmp78_;
			gint _tmp79_;
			Number* _tmp80_;
			Number* _tmp81_;
			Number* _tmp82_;
#line 1210 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp67_ = string_get_next_char (str, &index, &_tmp66_);
#line 1210 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			c = _tmp66_;
#line 1210 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			if (!_tmp67_) {
#line 1210 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				break;
#line 6101 "number.c"
			}
#line 1212 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp68_ = c;
#line 1212 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp69_ = number_base;
#line 1212 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			i = char_val (_tmp68_, _tmp69_);
#line 1213 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp70_ = i;
#line 1213 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			if (_tmp70_ < 0) {
#line 6113 "number.c"
				gunichar _tmp71_ = 0U;
#line 1215 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				string_get_prev_char (str, &index, &_tmp71_);
#line 1215 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				c = _tmp71_;
#line 1216 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
				break;
#line 6121 "number.c"
			}
#line 1219 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp72_ = denominator;
#line 1219 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp73_ = number_base;
#line 1219 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp74_ = number_multiply_integer (_tmp72_, (gint64) _tmp73_);
#line 1219 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_g_object_unref0 (denominator);
#line 1219 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			denominator = _tmp74_;
#line 1220 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp75_ = numerator;
#line 1220 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp76_ = number_base;
#line 1220 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp77_ = number_multiply_integer (_tmp75_, (gint64) _tmp76_);
#line 1220 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_g_object_unref0 (numerator);
#line 1220 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			numerator = _tmp77_;
#line 1221 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp78_ = numerator;
#line 1221 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp79_ = i;
#line 1221 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp80_ = number_new_integer ((gint64) _tmp79_, (gint64) 0);
#line 1221 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp81_ = _tmp80_;
#line 1221 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_tmp82_ = number_add (_tmp78_, _tmp81_);
#line 1221 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_g_object_unref0 (numerator);
#line 1221 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			numerator = _tmp82_;
#line 1221 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
			_g_object_unref0 (_tmp81_);
#line 6159 "number.c"
		}
#line 1224 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp83_ = numerator;
#line 1224 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp84_ = denominator;
#line 1224 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp85_ = number_divide (_tmp83_, _tmp84_);
#line 1224 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (numerator);
#line 1224 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		numerator = _tmp85_;
#line 1225 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp86_ = z;
#line 1225 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp87_ = numerator;
#line 1225 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp88_ = number_add (_tmp86_, _tmp87_);
#line 1225 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (z);
#line 1225 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		z = _tmp88_;
#line 1205 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (denominator);
#line 1205 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (numerator);
#line 6185 "number.c"
	}
#line 1228 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp89_ = index;
#line 1228 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp90_ = end;
#line 1228 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp89_ != _tmp90_) {
#line 1229 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = NULL;
#line 1229 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (z);
#line 1229 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 6199 "number.c"
	}
#line 1231 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp91_ = negate;
#line 1231 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp91_) {
#line 6205 "number.c"
		Number* _tmp92_;
		Number* _tmp93_;
#line 1232 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp92_ = z;
#line 1232 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_tmp93_ = number_invert_sign (_tmp92_);
#line 1232 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (z);
#line 1232 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		z = _tmp93_;
#line 6216 "number.c"
	}
#line 1234 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = z;
#line 1234 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 6222 "number.c"
}


gint
char_val (gunichar c,
          gint number_base)
{
	gint result = 0;
	gint value = 0;
	gint _tmp0_;
#line 1239 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (!g_unichar_isxdigit (c)) {
#line 1240 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = -1;
#line 1240 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 6239 "number.c"
	}
#line 1242 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	value = g_unichar_xdigit_value (c);
#line 1244 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = value;
#line 1244 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp0_ >= number_base) {
#line 1245 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = -1;
#line 1245 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 6251 "number.c"
	}
#line 1247 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = value;
#line 1247 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 6257 "number.c"
}


Number*
set_from_sexagesimal (const gchar* str)
{
	Number* result = NULL;
	gint degree_index = 0;
	gint _tmp0_;
	Number* degrees = NULL;
	gint _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* _tmp6_;
	gint minute_start = 0;
	gint _tmp7_;
	gunichar c = 0U;
	gunichar _tmp8_ = 0U;
	gint _tmp9_;
	gint minute_index = 0;
	gint _tmp10_;
	gint _tmp11_;
	Number* minutes = NULL;
	gint _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	Number* _tmp17_;
	Number* _tmp18_;
	Number* _tmp19_;
	Number* _tmp20_;
	Number* _tmp21_;
	Number* _tmp22_;
	Number* _tmp23_;
	Number* _tmp24_;
	gint second_start = 0;
	gint _tmp25_;
	gunichar _tmp26_ = 0U;
	gint _tmp27_;
	gint second_index = 0;
	gint _tmp28_;
	gint _tmp29_;
	Number* seconds = NULL;
	gint _tmp30_;
	gint _tmp31_;
	gint _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	Number* _tmp35_;
	Number* _tmp36_;
	Number* _tmp37_;
	Number* _tmp38_;
	Number* _tmp39_;
	Number* _tmp40_;
	Number* _tmp41_;
	Number* _tmp42_;
	gunichar _tmp43_ = 0U;
	gint _tmp44_;
#line 1250 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 1252 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	degree_index = string_index_of_char (str, 176U, 0);
#line 1253 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = degree_index;
#line 1253 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp0_ < 0) {
#line 1254 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = NULL;
#line 1254 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 6331 "number.c"
	}
#line 1255 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = degree_index;
#line 1255 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp2_ = string_substring (str, (glong) 0, (glong) _tmp1_);
#line 1255 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp3_ = _tmp2_;
#line 1255 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp4_ = mp_set_from_string (_tmp3_, 10);
#line 1255 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp5_ = _tmp4_;
#line 1255 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_free0 (_tmp3_);
#line 1255 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	degrees = _tmp5_;
#line 1256 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp6_ = degrees;
#line 1256 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp6_ == NULL) {
#line 1257 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = NULL;
#line 1257 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (degrees);
#line 1257 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 6357 "number.c"
	}
#line 1258 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp7_ = degree_index;
#line 1258 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	minute_start = _tmp7_;
#line 1260 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	string_get_next_char (str, &minute_start, &_tmp8_);
#line 1260 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	c = _tmp8_;
#line 1262 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp9_ = minute_start;
#line 1262 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (string_get (str, (glong) _tmp9_) == '\0') {
#line 1263 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = degrees;
#line 1263 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 6375 "number.c"
	}
#line 1264 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp10_ = minute_start;
#line 1264 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	minute_index = string_index_of_char (str, (gunichar) '\'', _tmp10_);
#line 1265 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp11_ = minute_index;
#line 1265 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp11_ < 0) {
#line 1266 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = NULL;
#line 1266 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (degrees);
#line 1266 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 6391 "number.c"
	}
#line 1267 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp12_ = minute_start;
#line 1267 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp13_ = minute_index;
#line 1267 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp14_ = minute_start;
#line 1267 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp15_ = string_substring (str, (glong) _tmp12_, (glong) (_tmp13_ - _tmp14_));
#line 1267 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp16_ = _tmp15_;
#line 1267 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp17_ = mp_set_from_string (_tmp16_, 10);
#line 1267 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp18_ = _tmp17_;
#line 1267 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_free0 (_tmp16_);
#line 1267 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	minutes = _tmp18_;
#line 1268 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp19_ = minutes;
#line 1268 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp19_ == NULL) {
#line 1269 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = NULL;
#line 1269 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (minutes);
#line 1269 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (degrees);
#line 1269 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 6423 "number.c"
	}
#line 1270 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp20_ = degrees;
#line 1270 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp21_ = minutes;
#line 1270 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp22_ = number_divide_integer (_tmp21_, (gint64) 60);
#line 1270 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp23_ = _tmp22_;
#line 1270 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp24_ = number_add (_tmp20_, _tmp23_);
#line 1270 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (degrees);
#line 1270 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	degrees = _tmp24_;
#line 1270 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (_tmp23_);
#line 1271 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp25_ = minute_index;
#line 1271 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	second_start = _tmp25_;
#line 1272 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	string_get_next_char (str, &second_start, &_tmp26_);
#line 1272 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	c = _tmp26_;
#line 1274 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp27_ = second_start;
#line 1274 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (string_get (str, (glong) _tmp27_) == '\0') {
#line 1275 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = degrees;
#line 1275 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (minutes);
#line 1275 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 6459 "number.c"
	}
#line 1276 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp28_ = second_start;
#line 1276 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	second_index = string_index_of_char (str, (gunichar) '"', _tmp28_);
#line 1277 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp29_ = second_index;
#line 1277 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp29_ < 0) {
#line 1278 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = NULL;
#line 1278 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (minutes);
#line 1278 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (degrees);
#line 1278 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 6477 "number.c"
	}
#line 1279 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp30_ = second_start;
#line 1279 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp31_ = second_index;
#line 1279 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp32_ = second_start;
#line 1279 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp33_ = string_substring (str, (glong) _tmp30_, (glong) (_tmp31_ - _tmp32_));
#line 1279 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp34_ = _tmp33_;
#line 1279 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp35_ = mp_set_from_string (_tmp34_, 10);
#line 1279 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp36_ = _tmp35_;
#line 1279 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_free0 (_tmp34_);
#line 1279 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	seconds = _tmp36_;
#line 1280 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp37_ = seconds;
#line 1280 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (_tmp37_ == NULL) {
#line 1281 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = NULL;
#line 1281 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (seconds);
#line 1281 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (minutes);
#line 1281 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (degrees);
#line 1281 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 6511 "number.c"
	}
#line 1282 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp38_ = degrees;
#line 1282 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp39_ = seconds;
#line 1282 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp40_ = number_divide_integer (_tmp39_, (gint64) 3600);
#line 1282 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp41_ = _tmp40_;
#line 1282 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp42_ = number_add (_tmp38_, _tmp41_);
#line 1282 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (degrees);
#line 1282 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	degrees = _tmp42_;
#line 1282 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (_tmp41_);
#line 1283 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	string_get_next_char (str, &second_index, &_tmp43_);
#line 1283 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	c = _tmp43_;
#line 1286 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp44_ = second_index;
#line 1286 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	if (string_get (str, (glong) _tmp44_) == '\0') {
#line 1287 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = degrees;
#line 1287 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (seconds);
#line 1287 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (minutes);
#line 1287 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 6545 "number.c"
	} else {
#line 1289 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		result = NULL;
#line 1289 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (seconds);
#line 1289 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (minutes);
#line 1289 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		_g_object_unref0 (degrees);
#line 1289 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
		return result;
#line 6557 "number.c"
	}
#line 1250 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (seconds);
#line 1250 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (minutes);
#line 1250 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (degrees);
#line 6565 "number.c"
}


gboolean
mp_is_overflow (Number* x,
                gint wordlen)
{
	gboolean result = FALSE;
	Number* t2 = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
#line 1293 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	g_return_val_if_fail (x != NULL, FALSE);
#line 1295 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp0_ = number_new_integer ((gint64) 2, (gint64) 0);
#line 1295 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp1_ = _tmp0_;
#line 1295 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp2_ = number_xpowy_integer (_tmp1_, (gint64) wordlen);
#line 1295 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_tmp3_ = _tmp2_;
#line 1295 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (_tmp1_);
#line 1295 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	t2 = _tmp3_;
#line 1296 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	result = number_compare (t2, x) > 0;
#line 1296 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	_g_object_unref0 (t2);
#line 1296 "/builddir/build/BUILD/gnome-calculator-3.28.2/lib/number.vala"
	return result;
#line 6599 "number.c"
}



